
*------------------------------
	subroutine aaplot( y1, y2, nloop )
* plot Adot vs A
* 2010 Jul Keith Horne @ St.Andrews

	include 'plens.inc'
	write(*,*) 'aaplot ****************'
	a0 = atotl( y0 )
	thalf = thalf_u0( y0 )

* window
	extra = 1.0
	ymx = max( 0.1, a0 - 1. ) / thalf * extra
	ymn = - ymx
	write(*,*) 'te', te, ' t1/2 = ', thalf, 'x te = ', thalf * te

	xmn = 0.
	xmx = 1.5
	write(*,*) 'u0', y0, ' A0', a0, ' b0', b0
	if( a0.le.0. ) a0 = 5. 
	xmx = max( xmx, a0 + b0 ) * 1.05

      if( ndata.gt.0 ) then
	flx0 = toflx( smag0 )
	fs0 = flx0 / ( 1. + b0 )
	fb0 = fs0 * b0
	write(*,*) 'I0', smag0, ' f0', flx0
     &		, ' fs', fs0, ' fb', fb0, ' b0', b0
	call xcalc
	call lcalc( ndata, x_t, y0 )
      do i = 1, ndata
	pflx = preflx( hjd_t( i ) )
c	eflx = erbflx( i, pflx )
	eflx = erbcorflx( i, pflx )

	x = x_t( i )
	u = sqrt( x * x + y0 * y0 )
	a = a_t( i )
	dadx = dpspl( u ) * x / u
	plot0( i ) = a
	plot1( i ) = dadx
	plot2( i ) = corflx( i ) / fs0 - b0
	plot3( i ) = eflx / fs0
      end do

	dmx = a0
	dmn = 0.
      do i=1,ndata
      if( plot1(i) .ge. xmn .and. plot1(i) .le. xmx ) then
	dmn = min( dmn, plot2(i) )
	dmx = max( dmx, plot2(i) )
      end if
      end do
	xmx = max( xmx, dmx * 1.1 )
	xmn = min( xmn, dmn, b0 )
      end if

	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
* horizontals
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
* verticals
	call pgmove( 0., ymn )
	call pgdraw( 0., ymx )
	call pgmove( 1., ymn )
	call pgdraw( 1., ymx )
	call pgsls(1)

* labels
	ylabel = 'dA / dx'
	xlabel = 'magnification A'
      if( nloc .gt. 0 ) then
	title = ' '
	call title_event( title )
	call title_apm( title )
	call title_priority( title )
	call noeqbl( title )
      else
	title = 'Microlens Phase Space'
      end if
	call pgsci( kolor_window )
	call pglabel( xlabel, ylabel, title )

	call legend
* data
      if( ndata .gt. 0 ) then
* connect data to curve
	call pgsci( 2 )
      do i=1,ndata
	call pgmove( plot0(i), plot1(i) )
	call pgdraw( plot2(i), plot1(i) )
      end do
* colour-coded plot of data points
	call pgxsy( plot2, plot1, plot3, plot3 )
      end if

* predicted data
	nplot = 2000
	nplot = min( nplot, maxplot )
	xlo = -1.
	xhi = 1.
      do i = 1, nplot
	part = float( i - 1 ) / max( 1, nplot - 1 )
	x = xlo + part * ( xhi - xlo )
	u = sqrt( x*x + y0*y0 ) 
	a = atotl( u )
	dadx = dpspl( u ) * x / u
	plot0(i) = a
	plot1(i) = dadx
      end do
	call pgsci( kolor_model )
	call pgline( nplot, plot0, plot1 )

* other loops

      if( nloop .gt. 0 ) then
	nloops = nloop
	if( y2 .eq. y1 ) nloops=1
      do loop = 1, nloops
	part = float(loop-1)/max(1,nloops-1)
	y = y1 + (y2-y1)*part
	yy = y * y
      do i = 1, nplot
	part = float( i - 1 ) / max( 1, nplot - 1 )
	x = xlo + part * ( xhi - xlo )
	u = sqrt( x*x + yy ) 
	a = atotl( u )
	dadX = dpspl( u ) * x / u
	plot0(i) = a
	plot1(i) = dadX
      end do
	call pgsci( kolor_model )
	call pgline( nplot, plot0, plot1 )
      end do
      end if

	return
	end
