
*------------------------------
	subroutine aplot( y1, y2, nloop )
* plot magnifications
*	y1 and y2 and nloop specify impact parameters
* 1998 Aug Keith Horne @ St-Andrews
* 2002 Nov KDH @ St-And - b0
* 2003 Jun KDH @ St-And - te now radius crossing time
* 2003 Jul KDH @ St-And - pgxys, tbeg,tend
* 2003 Nov KDH @ St-And - cormag, erbmag
* 2005 Aug KDH @ St-And - timeaxis
* 2006 Feb KDH @ St-And - hjdaxis
* 2006 Mar KDH @ St-And - marknow
* 2008 Jun KDH @ St-And - plot flux data and account for blending
* 2009 Jul KDH @ St-A  - t0 => hjd0, preflx(t)->preflx(hjd)
* 2010 Mar KDH @ LCO  - revise ymn, ymx

	include 'plens.inc'
	write(*,*) 'aplot ****************'
	t0 = hjd0 - mjd0
* window

	call timeaxis( xmn, xmx, xlabel )

	ymn = 0.
	ymx = 1.5
	a0 = atotl( y0 )
	write(*,*) 'u0', y0, ' A0', a0, ' b0', b0
	if( a0.le.0. ) a0 = 5. 
	ymx = max( ymx, a0 + b0 ) * 1.05

      if( ndata.gt.0 ) then
	flx0 = toflx( smag0 )
	fs0 = flx0 / ( 1. + b0 )
	fb0 = fs0 * b0
	write(*,*) 'I0', smag0, ' f0', flx0
     &		, ' fs', fs0, ' fb', fb0, ' b0', b0
	call xcalc
      do i = 1, ndata
	pflx = preflx( hjd_t( i ) )
c	eflx = erbflx( i, pflx )
	eflx = erbcorflx( i, pflx )
	plot1( i ) = x_t( i )
	if( hjdaxis ) plot1( i ) = t_t( i )
	plot2( i ) = corflx( i ) / fs0
	plot3( i ) = eflx / fs0
	plot4( i ) = plot2(i) - b0
      end do
c	call mnmx( ndata, plot2, dmn, dmx )
	dmx = a0
	dmn = 0.
      do i=1,ndata
      if( plot1(i) .ge. xmn .and. plot1(i) .le. xmx ) then
	dmn = min( dmn, plot2(i) )
	dmx = max( dmx, plot2(i) )
      end if
      end do
	ymx = max( ymx, dmx * 1.1 )
	ymn = min( ymn, dmn, b0 )
      end if

	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	call pgsci( kolor_window )
* window (y axis shifted to account for blending)
c	call pgenv( xmn, xmx, ymn-b0, ymx-b0, 0, 0 )
c	call pgswin( xmn, xmx, ymn, ymx )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
* horizontals
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	call pgsls( 4 )
	call pgsci( 2 )
	call pgmove( xmn, 1. )
	call pgdraw( xmx, 1. )
* verticals
	call pgsci( kolor_model )
	call marktime( ymn, ymx )
	call pgsls(1)
* now
	call pgsci( kolor_now )
	call marknow( ymn, ymx )

* labels
	ylabel = 'magnification A'
      if( nloc .gt. 0 ) then
	title = ' '
	call title_event( title )
	call title_apm( title )
	call title_priority( title )
	call noeqbl( title )
      else
	title = 'Microlens Lightcurve'
      end if
	call pgsci( kolor_window )
	call pglabel( xlabel, ylabel, title )

	call legend
* data
      if( ndata .gt. 0 ) then
      if( b0 .ge. 0. ) then
	call pgxys( plot1, plot2, plot3, plot3 )
c	if( abs( b0 ) .gt. a0/3. ) call pgxys( plot1, plot4, plot3, plot3 )
      else
	call pgxys( plot1, plot4, plot3, plot3 )
      end if
      end if

* predicted data
	nplot = 1000
	nplot = min( nplot, maxplot )
      do i = 1, nplot
	part = float( i - 1 ) / max( 1, nplot - 1 )
	xx = xmn + part * ( xmx - xmn )
	x_t(i) = xx
	if( hjdaxis ) x_t(i) = ( xx - t0 ) / te
	plot0(i) = xx
      end do
	call lcalc( nplot, x_t, y0 )
	call aplot1

* other lightcurves

      if( nloop .gt. 0 ) then
	nloops = nloop
	if( y2 .eq. y1 ) nloops=1
      do loop = 1, nloops
	part = float(loop-1)/max(1,nloops-1)
	umin = y1 + (y2-y1)*part
	call lcalc( nplot, x_t, umin )
	call aplot1
      end do
      end if

	return
	end
