*--------------------
	subroutine bof_flx( bof, nd, np )
* badness of fit = - 2 ln( prob ) = Chi^2 + 2 sum ln(sig) + n ln(2pi)
*
* 1998 Sep Keith Horne @ St-Andrews
* 2003 Jul KDH @ St-And - datmag_t -> cormag
* 2003 Jul KDH @ St-And - multi-site
* 2003 Jul KDH @ St-And - fudge error bars for each site
* 2003 Jul KDH @ St-And - prior(f)
* 2003 Nov KDH @ St-And - seecor
* 2003 Nov KDH @ St-And - badness -> bof_mag or bof_flx
* 2005 Apr KDH @ St-And - fudge error bars only if npfit > 4
* 2006 Jan KDH @ St-And - and scalerb_l(l) is .true.
* 2006 Jul KDH @ St-And - transition to median at 5-sigma
* 2007 Jul KDH @ Goettingen - clip high points at +5-sigma
* 2007 Apr KDH @ St-And - fit 5 = with blending
* 2009 Jul KDH @ St-And - fix clip bug, try to speed inner loop
* 2009 Jul KDH @ StA - preflx(t)->preflx(hjd)
	include 'plens.inc'
	logical verbose/.false./
c	logical verbose/.true./
	real*8 sumw
	real*8 sum, sum1, sum2, sum3
	real*8 sumf, sum1f, sum2f
	real*8 sumc, sum1c, sum2c
	real*8 bofc, boff
	real*8 bofd, bofdc, bofdf
	bof = 0.
	nd = 0
	np = 0
	if( ndata .le. 0 ) return

* original error bars
	ierb = 0
* fudged error bars
	ierb = 1

* no clipping
	klipmethod = 0
* stark clipping ( quadratic -> constant bof )
	klipmethod = 1
* smooth clipping ( quadratic -> linear bof )
	klipmethod = 2

	klipmethod = 0

* fit source and baseline fluxes
	j = ndata / 2
	call fitfsfb
* seeing corrections
	call seecor

* zero sums (f=fudged, c=clipped)
	sum = 0.d0
	sumw = 0.d0
	sumf = 0.d0
	sumc = 0.d0
* locations
	locsave = loc
      do l = 1, nloc
* set site-dependent parameters
	call setsite( l )
	if( verbose .and. nloc .gt. 1 ) call showsite
* data set for this location
	i1 = it1_l( l )
	i2 = it2_l( l )
* zero sums
	sum1 = 0.d0
	sum2 = 0.d0
	sum3 = 0.d0
	sum1f = 0.d0
	sum2f = 0.d0
	sum1c = 0.d0
	sum2c = 0.d0
* count data points
	ndf = 0

* data points for this site
      do i = i1, i2
	hjd = hjd_t( i )
* data flux
	d = datflx_t( i )
* predicted flux
	p = preflx( hjd )

* original flux error bar
	s = sigflx_t( i )
	e = ( d - p ) / s
	ee = e * e
* fudged flux error bar
	sf = erbflx( i, p )
	ef = ( d - p ) / sf
	eef = ef * ef

* trap divide by zero
      if( s .le. 0. .or. sf .le. 0 ) then
	write(*,*) '** bof_flx ERROR divide by ZERO error bar.'
	write(*,*) i, ' hjd', t_t(i), ' ', site(:len1(site))
	write(*,*) ' flux dat', d, ' pre', p, ' cor', c
	write(*,*) ' sig', s, ' fudged', sf
	write(*,*) ' eta', e, ' fudged', ef
c	call die
      end if

* apply clipping
	sc = sf
	eec = eef
	wgt = 1.
      if( klipmethod .ne. 0 ) then
      if( cliphi .ne. 0. .and. ef .gt. cliphi ) then
      if( klipmethod .eq. 1 ) then
	eec = cliphi * ( ef + ef - cliphi )
      else
	eec = chiphi * cliphi
      end if
      else if( cliplo .ne. 0. .and. ef .lt. cliplo ) then
      if( klipmethod .eq. 1 ) then
	eec = cliplo * ( ef + ef - cliplo )
      else
	eec = cliplo * cliplo
      end if
      end if
	wgt = eec / eef
* DANGER DIVIDE BY ZERO HERE
	if( wgt .ne. 1. ) sc = sf / sqrt( wgt )
      end if

* report zero weight points
      if( wgt .le. 0. ) then
	write(*,*) '** WARNING: bof_flx wgt(', i, ' ) =', wgt
	write(*,*) 'e', e, ' ef', ef, ' eec', eec, ' eef', eef
      else
* sum chi^2 part of - 2 ln( P )
	sum1 = sum1 + ee
	sum1f = sum1f + eef
	sum1c = sum1c + eec


* sum penalty for large error bar
	sum2  = sum2  + alog( s )
	sum2f = sum2f + alog( sf )
	sum2c = sum2c + alog( sc )
* sum weights (clipped and unclipped)
	sum3 = sum3 + wgt
	ndf = ndf + 1
      end if
* stow weight
	clip_t(i) = wgt

* debug report
      if( verbose ) then
      if( i .eq. i1 .or. i .eq. i2
     &		.or. mod( i, max(1, (i2-i1+1)/10) ) .eq. 0 ) then
	write(*,*) i, 'p', p, ' d', d, ' s', s, ' sf', sf
	write(*,*) i, 'ee', ee, ' eef', eef
	write(*,*) i,' sum1', sum1, sum1f, ' sum2', sum2, sum2f
      end if
      end if

* next data point
      end do
	sum2  = sum2  + sum2
	sum2f = sum2f + sum2f
	sum2c = sum2c + sum2c

* number of scale parameters that have been fitted
	npf = 0
	if( npfit .ge. 1 ) npf = 1
	if( npfit .ge. 4 ) npf = 2
	npf = min( npf, ndf )

* fudge error bars to force chi2/ndof=1 for each data sub-set
* (note clipping will have been done using the previous erbscl)

      if( npfit .gt. 6 ) then
c	write(*,*) 'npfit', npfit, ' l', l, ' ndf', ndf, ' sum1', sum1
      if( l .gt. 1 ) then
c      if( scalerb_l( l ) ) then

* require 4 data points and some scatter
      if( ndf .gt. 4 .and. sum1 .gt. 0.d0 ) then
	fudge = sum1f / max( 1, ndf - npf )
* adjust Chi2
	sum1f = sum1f / fudge
	sum1c = sum1c / fudge
* adjust +2lnSig
	add = ndf * alog( fudge )
	sum2f = sum2f + add
	sum2c = sum2c + add

* adjust error bar scale
      if( fudge .gt. 1.e-4 ) then
	erbscl_l( l ) = erbscl_l( l ) * sqrt( fudge )
* report
      if( verbose ) then
	write(*,*) 'Site', l, ' nd', ndf, ' np', npf, 
     &		' fudge', sqrt( fudge )
      end if
      end if

      end if
c      end if
      end if
      end if

* accumulate -2 ln P = chi2 + sum ln(sigma^2)
	sumw = sumw + sum3
	sum = sum + sum1 + sum2
	sumf = sumf + sum1f + sum2f
	sumc = sumc + sum1c + sum2c
	nd = nd + ndf
	np = np + npf

* stow clipped?
c	chi2_l( l ) = sum1c
* stow fudged
	chi2_l( l ) = sum1f
	ndf_l( l ) = max( 0, ndf - npf )
* report
      if( verbose ) then
	write(*,*) '--------------------------------------------------'
	write(*,*) 'Site', l,' Data', ndf, ' SumW', sum3, ' Fit', npf
	write(*,*) 'nominal -2lnP', sum,  ' Chi2', sum1,  ' 2lnSig', sum2
	write(*,*) ' fudged -2lnP', sumf, ' Chi2', sum1f, ' 2lnSig', sum2f
	write(*,*) 'clipped -2lnP', sumc, ' Chi2', sum1c, ' 2lnSig', sum2c
      end if
* next location
      end do
* restore original location
	call setsite( locsave )

* -2ln(likelihood)
	add = nd * alog( pi + pi )
	add = 0.
	bofd = sum + add
	bofdf = sumf + add
	bofdc = sumc + add
* -2ln(prior)
	bofp = prior()
	bof = bofd + bofp
	boff = bofdf + bofp
	bofc = bofdc + bofp
* report
      if( verbose ) then
	write(*,*) '--------------------------------------------------'
	write(*,*) 'nominal -2lnL', bofd,  ' prior', bofp, ' sum', bof
	write(*,*) ' fudged -2lnL', bofdf, ' prior', bofp, ' sum', boff
	write(*,*) 'clipped -2lnL', bofdc, ' prior', bofp, ' sum', bofc
	write(*,*) 'USING CLIPPED BOF', bofc
      end if


* use fudged error bars
      if( ierb .ne. 0 ) then
      if( klipmethod .eq. 0 ) then
	bof = boff
* use clipped error bars
      else
	bof = bofc
      end if
      end if

* sanity check
      if( nd .ne. ndata ) then
	write(*,*) '** WARNING bof_flx NDATA=', ndata, ' ND=', nd
      end if
* final report
      if( verbose ) then
	write(*,*) '** bof_flx(', bof, nd, np, ' ) SumW:', sumw
      end if
	return
	end
