*-----------------------------------
	subroutine cleansite( sitein, event,
     &		icon, colour, site, glat, glon, elev, diam )
* change standard archive file name to clean scope:filter name
* and event name (e.g. OB08234)
* also assign icon and colour
* 2007 Apr Keith Horne @ St.Andrews
* 2008 Jul KDH @ St.A add glat, glon, elev
* 2008 Jul KDH @ St.A fix robonet filter
* 2008 Jul KDH @ St.A add telescope diam
* 2008 Jul KDH @ SAAO fudge OB08123.dat filenames
* 2008 Aug KDH @ St.A fudge OB-2002-123 filenames
* 2009 Jun KDH @ St.A add icon and colour
* 2010 Mar KDH @ LCO initialise scope survey year seqnum filter to ??
* 2011 Jun KDH @ StA strip path from the filename
	character*(*) sitein, event, icon, colour, site
	real*8 glat, glon, elev
	logical robdata
	character*1 filt, scope, survey, field
	character*50 filter
	character*2 year
	character*4 seqnum
	dms2d( idegs, mins, sec ) = idegs+(mins*(sec/60.d0)/60.d0)

* default scope
	icon = ' '
	colour = ' '
	site = sitein
	glat = -30.d0
	glon = 00.d0
	elev = 100.d0
	diam = 1.0
	event = ' '

* strip path from the input file name
	call index_nopath( site, l )
	write(*,*) 'File:', site(:len1(site))
	write(*,*) 'index_nopath', l
      if( l .gt. 1 ) then
	write(*,*) 'Path:', site(:l-1)
	write(*,*) 'File:', site(l:)
      end if
	site = site(l:)

* fudge OB08123.anything -> OOB08123I.anything
	l = index( site, '.' )
      if( l .eq. 8 .or. len1( site ) .eq. 7 ) then
	write(*,*) 'Original name: ', site(:len1(site))
* fudge OB08123.anything -> OOB08123I.anything
      if( site(1:2) .eq. 'OB' .or. site(1:2) .eq. 'ob' ) then
      if( l .eq. 8 ) then
	site = 'OOB' // site(3:7) // 'I' // site(l:)
      else
	site = 'OOB' // site(3:7) // 'I'
      end if
* fudge KB08123.anything -> KKB08123I.anything
      else if( site(1:2) .eq. 'KB' .or. site(1:2) .eq. 'kb' ) then
      if( l .eq. 8 ) then
	site = 'KKB' // site(3:7) // 'I' // site(8:)
      else
	site = 'KKB' // site(3:7) // 'I'
      end if
      end if
	write(*,*) 'Fudged name: ', site(:len1(site))
      end if

* fudge OB-2002-001.anything -> OOB02001I.anything
	l = index( site, '.' )
      if( l .eq. 12 .or. len1( site ) .eq. 11 ) then
      if( site(3:3) .eq. '-' .and. site(8:8) .eq. '-' ) then
	write(*,*) 'Original name: ', site(:len1(site))
      if( site(1:2) .eq. 'OB' .or. site(1:2) .eq. 'ob' ) then
      if( l .eq. 12 ) then
	site = 'OOB' // site(6:7) // site(9:11) // 'I' // site(l:)
      else
	site = 'OOB' // site(6:7) // site(9:11) // 'I'
      end if
* fudge KB-2002-001.anything -> KOB02001I.anything
      else if( site(1:2) .eq. 'KB' .or. site(1:2) .eq. 'kb' ) then
      if( l .eq. 12 ) then
	site = 'KKB' // site(6:7) // site(9:11) // 'I' // site(l:)
      else
	site = 'KKB' // site(6:7) // site(9:11) // 'I'
      end if
      end if
	write(*,*) 'Fudged name: ', site(:len1(site))
      end if
      end if

* strip default suffix .dat
	call word1( site, l1, l2 )
	ld = index( site, '.dat' )
	if( l2 .eq. ld + 3 ) l2 = ld - 1
	site = site(l1:l2)

* recognise standard archive name
	filter = '??'
	filt = '??'
	scope = '??'
	survey = '??'
	field = '??'
	year = '??'
	seqnum = '??'
* 9 letters (or more)
	l = len1( site )
      if( l .ge. 9 ) then

* extract components
	scope = site(1:1)
	survey = site(2:2)
	field = site(3:3)
* year
	year = site(4:5)
	if( iyr .lt. 0 ) goto 999
	if( year .eq. '2K' ) year = '00'
	read( year, '(i2)', err=999 ) iyr

* sequence number
	idigits = 3
	if( iyr .ge. 11 ) idigits = 4

      if( idigits .eq. 3 ) then
	seqnum = site(6:8)
	read( seqnum, '(i3)', err=999 ) num
	if( num .lt. 0 .or. num .gt. 999 ) goto 999
      else
	seqnum = site(6:9)
	read( seqnum, '(i4)', err=999 ) num
	if( num .lt. 0 .or. num .gt. 9999 ) goto 999
      end if

* filter
      if( idigits .eq. 3 ) then
	filter = site(9:l)
      else
	filter = site(10:l)
      end if
	filt = filter(1:1)

* try to translate robonet filter
	robdata = scope .eq. 'H'
     &		.or. scope .eq. 'J' 
     &		.or. scope .eq. 'I' 
      if( robdata ) then
	if( index( filter, 'Bess-R' ) .gt. 0 ) filt = 'R'
	if( index( filter, 'Bess-V' ) .gt. 0 ) filt = 'V'
	if( index( filter, 'Bess-I' ) .gt. 0 ) filt = 'I'
	if( index( filter, 'SDSS-R' ) .gt. 0 ) filt = 'R'
	if( index( filter, 'SDSS-V' ) .gt. 0 ) filt = 'V'
	if( index( filter, 'SDSS-I' ) .gt. 0 ) filt = 'I'
      end if


* ogle or moa event
      if( survey .eq. 'O' .or. survey .eq. 'K' ) then

* construct event name
	long = 0
* short version
      if( long .eq. 0 ) then
	event = survey(1:1) // 'B-' // year(1:2) // '-'
* long version
      else
	if( survey .eq. 'O' ) event = 'OGLE'
	if( survey .eq. 'K' ) event = 'MOA'
      if( iyr .lt. 50 ) then
	call append( event, '-19' )
      else
	call append( event, '-20' )
      end if
	call append( event, year )
	call nospace( event )
	call append( event, '-BLG-' )
      end if
      if( idigits .eq. 3 ) then
	write( event( len1(event)+1:), '(I3.3)' ) num
      else
	write( event( len1(event)+1:), '(I4.4)' ) num
      end if

* note longitude east + west -
* ogle
      if( scope .eq. 'O' ) then
	site = 'OGLE'
	diam = 1.3
	icon = 'O'
	colour = 'black'
* moa
      else if( scope .eq. 'K' ) then
	site = 'MOA'
	diam = 1.8
	icon = 'K'
	colour = 'maroon'
* robonet
      else if( scope .eq. 'H' ) then
	site = 'FTN'
	glat = 20.70666
	glon = -156.24
	elev = 3054
	diam = 2.0
	icon = 'H'
	colour = 'cyan'
	
      else if( scope .eq. 'I' ) then
	site = 'FTS'
	glat = -31.27333
	glon = 149.06166
	elev = 1149
	diam = 2.0
	icon = 'I'
	colour = 'darkgreen'

      else if( scope .eq. 'J' ) then
	site = 'LT'
	glat = 28.76
	glon = -17.88166
	elev = 2326
	diam = 2.0
	icon = 'J'
	colour = 'turquoise'

* PLANET
      else if( scope .eq. 'Z' ) then
	site = 'LaSilla'
	glat = -29.2543
	glon = 289.2654
	elev = 2335.
	diam = 1.54
	icon = 'Z'
	colour = 'orange'

      else if( scope .eq. 'A' ) then
	site = 'SAAO'
	glat = -32.379444
	glon = 20.810694
	elev = 1798.
	diam = 1.0
	icon = 'A'
	colour = 'green'

      else if( scope .eq. 'U' ) then
	site = 'UTas'
	diam = 1.0
	icon = 'U'
	colour = 'magenta'

      else if( scope .eq. 'W' ) then
	site = 'Perth'
	diam = 0.6
	icon = 'W'
	colour = 'navy'

      else if( scope .eq. 'F' ) then
	site = 'Boyden'
	diam = 1.5
	icon = 'F'
	colour = 'skin'

      else if( scope .eq. 'R' ) then
	site = 'LNA/OPD'
	diam = 0.6
	icon = 'R'
	colour = 'grey'

      else if( scope .eq. 'P' ) then
	site = 'MonetN'
	diam = 1.2
	icon = 'P'
	colour = 'purple'

      else if( scope .eq. 'Q' ) then
	site = 'MonetS'
	diam = 1.2
	icon = 'Q'
	colour = 'darkred'

* microFUN
      else if( scope .eq. 'y' ) then
	site = 'Yale'
	diam = 1.0
	icon = 'y'
	colour = 'olive'

      else if( scope .eq. 'C' .or. scope .eq. 'c' ) then
	site = 'CTIO'
	glat = -dms2d( 30, 10, 06. )
	glon = -dms2d( 70, 48, 17. )
	elev = 2200
	diam = 1.3
	icon = scope(1:1)
	colour = 'blue'

      else if( scope .eq. 'z' ) then
	site = 'Hereford-AZ'
	glat = +dms2d( 31, 27, 08. )
	glon = -dms2d( 110, 14, 15. )
	diam = 0.35
	icon = 'z'
	colour = 'teal'

      else if( scope .eq. 'l' ) then
	site = 'Lemmon'
	glat = +dms2d( 32, 26, 35. )
	glon = -dms2d( 110, 47, 20. )
	diam = 1.0
	icon = 'l'
	colour = 'silvergreen'
	colour = 'dark sea green'

      else if( scope .eq. 'm' ) then
	site = 'MDM'
	glat = +dms2d( 31, 57, 05. )
	glon = -dms2d( 111, 36, 56. )
	diam = 2.4
	icon = 'm'
	colour = 'cyan'

      else if( scope .eq. 'o' ) then
	site = 'P60'
	glat = +dms2d( 33, 21, 26. )
	glon = -dms2d( 116, 51, 36. )
	diam = 1.5
	icon = 'p'
	colour = 'orange'

      else if( scope .eq. 'r' ) then
	site = 'RegentLane'
	glat = -dms2d( 38, 37, 26.)
	glon = +dms2d( 117, 53, 29.)
	diam = 0.0
	icon = 'r'
	colour = 'lightblue'

      else if( scope .eq. 'd' ) then
	site = 'Possum'
	glat = -dms2d( 38, 37, 26. )
	glon = +dms2d( 177, 53, 29. )
	diam = 0.28
	icon = 'd'
	colour = 'amber'

      else if( scope .eq. 'a' ) then
	site = 'Auckland'
	glat = -dms2d( 36, 54, 22. )
	glon = +dms2d( 174, 46, 37. )
	diam = 0.4
	icon = 'a'
	colour = 'darkgreen'

      else if( scope .eq. 'h' ) then
	site = 'HuntersHill'
	glat = -dms2d( 35, 09, 45. )
	glon = +dms2d( 149, 06, 36. )
	diam = 0.35
	icon = 'h'
	colour = 'skin'

      else if( scope .eq. 't' ) then
	site = 'Tahiti'
	glat = -dms2d( 17, 33, 04. )
	glon = -dms2d( 149, 35, 15. )
	diam = 0.28
	icon = 't'
	colour = 'silver'
	colour = 'slate grey'

      else if( scope .eq. 'f' ) then
	site = 'FarmCove'
	glat = +dms2d( 36, 53, 37. )
	glon = +dms2d( 174, 53, 37. )
	diam = 0.35
	icon = 'f'
	colour = 'blue'

      else if( scope .eq. 'k' ) then
	site = 'Kumeu'
	glat = -dms2d( 36, 48, 23. )
	glon = +dms2d( 174, 31, 29. )
	diam = 0.35
	icon = 'k'
	colour = 'navy'

      else if( scope .eq. 'v' ) then
	site = 'VintageLane'
	glat = -dms2d( 41, 29, 30. )
	glon = +dms2d( 149, 35, 15. )
	diam = 0.4
	icon = 'v'
	colour = 'purple'

      else if( scope .eq. 'p' ) then
	site = 'PerthCBA'
	diam = 0.25
	icon = 'p'
	colour = 'magenta'

      else if( scope .eq. 'b' ) then
	site = 'Bronberg'
	glat = -dms2d( 25, 54, 32. )
	glon = +dms2d( 28, 26, 18. )
	diam = 0.35
	icon = 'b'
	colour = 'turquoise'

      else if( scope .eq. 'w' ) then
	site = 'Wise'
	glat = +dms2d( 30, 35, 50. )
	glon = +dms2d( 34, 45, 44. )
	diam = 1.0
	icon = 'w'
	colour = 'darkred'

      else if( scope .eq. 'i' ) then
	site = 'WiseSITe'
	glat = +dms2d( 30, 35, 50. )
	glon = +dms2d( 34, 45, 44. )
	diam = 1.0
	icon = 'i'
	colour = 'darkred'

      else if( scope .eq. 'x' ) then
	glat = -dms2d( 22, 57, 10. )
	glon = -dms2d( 68, 10, 49. )
	site = 'CampoCatino'
	diam = 0.5
	icon = 'x'
	colour = 'grey'

      else
	goto 999
      end if
      end if

* append filter
      if( filt .ne. 'I' ) then
	site = site(:len1(site)) // ':' // filt
      end if
      end if
* report
	write(*,*) '** cleansite(', sitein(:len1(sitein) ), ') **'
	write(*,*) 'Survey: ', survey, ' Field: ', field
     &	, ' Year: ', year, ' Event: ', seqnum
	write(*,*) 'Event name: ', event(:len1(event))
	write(*,*) 'Standard site: ', site(:len1(site))
     &	, ' Scope ', scope, ' Filter: ', filt, ' ', filter(:len1(filter))

  999	return
	end
