*--------------------
	subroutine covcalc
* parameter covariances
* 2008 Jul Keith Horne @ SAAO
	include 'plens.inc'
	real*8 sum, sum_p( maxparm ), sum_pp( maxparm * maxparm )
	real*8 hess_p( maxparm ), hess_pp( maxparm * maxparm )
	real*4 p_p( maxparm ), check_pp( maxparm * maxparm )
	common/ kpar / km0, kb0, kt0, kte, ky0, ksig, kerb
c	write(*,*)
c	write(*,*) 'covcalc *************', ndata, hjd0-mjd0, te, y0
* pspl derivatives
	call dpsplcalc
* dimensions and parameter indices
	nlenspar = 3

* count sites with 1 and more data points
	n1 = 0
	n = 0
      do l=1,nloc
      if( ndat_l(l) .eq. 1 ) then
	n1 = n1 + 1
      else
	n = n + 1
      end if
      end do
* dimension of covariance martix
	ncovdim = nlenspar + n1 + 2 * n

* assume all sites have more than 1 data point
	ncovdim = nlenspar + 2 * nloc

* short parameter names
	call shortparnames
* zero sums
	n = ncovdim
      do i = 1, n
	sum_p( i ) = 0.d0
      end do
      do i = 1, n * n
	sum_pp( i ) = 0.d0
      end do

* locations
      do l = 1, nloc
	it1 = it1_l( l )
	it2 = it2_l( l )
	ndat = it2 - it1 + 1
* data 
      do i = it1, it2
	sig = sigflx_t( i )
      if( sig .gt. 0.d0 ) then
	fs = fs_l( l )
	fb = fb_l( l )
	f0 = fb + fs
	kfs = nlenspar + (l-1)*2 + 1
	kf0 = kfs + 1
	d = datflx_t(i) - preflx_t(i)
	w = 1. / ( sig * sig )
* loop over parameters
      do k = 1, n
* pattern is derivative of predicted data
* with respect to the respective parameter
* y0
      if( k .eq. ky0 ) then
	p = fs * dpspl_dy0_t( i )
* t0
      else if( k .eq. kt0 ) then
	p = fs * dpspl_dt0_t( i )
* te
      else if( k .eq. kte ) then
	p = fs * dpspl_dte_t( i )
* fs
      else if( k .eq. kfs ) then
	p = a_t( i ) - 1. 
* f0 = fs + fb
      else if( k .eq. kf0  ) then
	p = 1.
      else
	p = 0.
      end if
* stow
	p_p( k ) = p
* accumulate
      if( p .ne. 0. ) then
	pw = p * w
	sum_p( k ) = sum_p( k ) + pw * d
	jk = ( k - 1 ) * n
      do j = 1, k
	jk = jk + 1
	sum_pp( jk ) = sum_pp( jk ) + pw * p_p( j )
      end do
      end if
* next parameter
      end do
* next data point
      end if
      end do
* next site
      end do

* stow symmetric normalised hessian matrix
      do k = 1, n
	kk = k + ( k - 1 ) * n
	sum_p( k ) = dsqrt( sum_pp( kk ) )
      do j = 1, k
	jk = j + ( k - 1 ) * n
	kj = k + ( j - 1 ) * n
	sum_pp( jk ) = sum_pp( jk ) / ( sum_p(j) * sum_p(k) )
	sum_pp( kj ) = sum_pp( jk )
      end do
      end do
* report
      if( .false. ) then
	write(*,*) 'Normalised Hessian Matrix:'
      do k=1,n
	i = (k-1) * n
	write(*,'(30f7.3)') ( sum_pp(j+i), j=1,n )
      end do
      end if

* invert the matrix here ( incorrect ) for the moment

      do i=1, n * n
	hess_pp( i ) = sum_pp( i )
      end do
	call matinv( sum_pp, n, det )

* report
	write(*,*) 'Hessian Determinant', det
      if( det .lt. 0. ) then
	write(*,*) '** WARNING: NEGATIVE HESSIAN DETERMINANT :((((.'
      else if( det .eq. 0. ) then
	write(*,*) '** WARNING: SINGULAR HESSIAN MARTIX :((((.'
      end if

* check
	bad = 0.
      do k = 1, n
      do j = 1, n
	sum = 0.d0
      do i = 1, n
	ki = k + (i-1)*n
	ij = i + (j-1)*n
	sum = sum + hess_pp( ki ) * sum_pp( ij )
      end do
	kj = k + (j-1)*n
	check_pp( kj ) = sum
	if( j .eq. k ) sum = sum - 1.d0
	bad = max( bad, real( dabs( sum ) ) )
      end do
      end do
* report
      if( bad .le. 1.e-5 ) then
	write(*,*) 'Unit matrix:  Max error', bad, ' OK :)'
      else
	write(*,*) '** WARNING: Unit matrix Max error', bad
     &		, ' TOO LARGE :((((.'
      do k=1,n
	i = (k-1)*n
	write( *, '(i3, 30f8.4)' ) k, ( check_pp( j+i ) , j=1,n )
      end do
      end if

* rescale the inverted matrix
* is this correct ?
      do k = 1, n
      do j = 1, n
	i = j + (k-1) * n
	cov = 0.
	div = sum_p( j ) * sum_p( k )
	if( div .ne. 0. ) cov = sum_pp(i) / div
	cov_pp( i ) = cov
      end do
      end do

* extract parameter sigmas
      do k = 1, n
	kk = k + ( k - 1 ) * n
	var = cov_pp( kk )
	sig_p( k ) = sqrt( var )
      end do

* normalise covariance to sigmas
      do k = 1, n
	sigk = sig_p( k )
      do j = 1, k
	sigsig = sigk * sig_p( j )
	jk = j + ( k - 1 ) * n
	kj = k + ( j - 1 ) * n
	cov = 0.
      if( sigsig .ne. 0. ) then
	cov = cov_pp( jk )
	cov = cov / sigsig
      end if
	cov_pp( jk ) = cov
	cov_pp( kj ) = cov
      end do
      end do


* stow parameter error bars
	kfs = nlenspar + 1
	kf0 = kfs + 1
      do k = 1, n
	sig = sig_p( k )
      if( k .eq. kte ) then
	sigte = sig
      else if( k .eq. kt0 ) then
	sigt0 = sig
      else if( k .eq. ky0 ) then
	sigy0 = sig
      else if( k .eq. kfs ) then
	sigfs = sig
      else if( k .eq. kf0 ) then
	sigf0 = sig
      end if
      end do
* dependent parameter sigmas
	siga0 = sigy0 * abs( dpspl( y0 ) )
	sigm0 = 2.5 * alog10( exp( 1. ) ) * sigf0 / f0
	return
	end
