*--------------------
	subroutine cuagrid( split )
* define a grid in logu vs azimuth spanning all data points
*    split = factor by which to sub-divide nominal pixels
* 1998 Sep Keith Horne @ St-Andrews
* 2007 Aug KDH change to degrees
* 2009 May KDH argument split
* 2009 Jul KDH @ StA - roundoff
	include 'plens.inc'
	write(*,*) 'cuagrid(', split, ' ) *************'
* default range
	ulog1 = -1.05
	ulog2 = 1.05
	tiny = 0.01
	deg1 = -90.
	deg2 = 270.
* expand lnu range
	repl = sqrt( qpl )
	extra = alog10( 1. + repl )
	add = 10. * extra
      do i=1,ndata
	ulog = alog10( u_t(i) )
	ulog1 = min( ulog1, ulog - add )
	ulog2 = max( ulog2, ulog + add )
      end do
	write(*,*) 'data range of log r/Re', ulog1, ulog2
* round logs (helps to prevent re-calculation)
	round = 0.05
	call roundoff( ulog1, round )
	call roundoff( ulog2, round )
	write(*,*) 'round by', round, ' to', ulog1, ulog2
* number of pixels
	nup = nint( split * ( ulog2 - ulog1 ) / extra )
	nap = nup
	nup = min( nup, max1d )
	nap = min( nap, max1d )
* azimuths
      do i = 1, nap
	p = float( i - 1 ) / max( 1, nap - 1 )
	ap_a(i) = deg1 + p * ( deg2 - deg1 )
      end do
* log u
      do i=1,nup
	p = float( i - 1 ) / max( 1, nup - 1 )
	ulog_u( i ) = ulog1 + p * ( ulog2 - ulog1 )
      end do
* report
	dlogu = ( ulog_u( nup ) - ulog_u( 1 ) ) / max( 1, nup - 1 )
	dadeg = ( ap_a( nap ) - ap_a( 1 ) ) / max( 1, nap - 1 )
	write(*,*) 'logu:', ulog_u( 1 ), ulog_u( nup ), nup, dlogu
	write(*,*) 'adeg:', deg1, deg2,  nap, dadeg
	return
	end
