*--------------------
	subroutine cxygrid(
     &	xx1, xx2, yy1, yy2, bigx1, bigx2, bigy1, bigy2, split )
* define grid to cover all data points with sufficient resolution
* Sep 1998 Keith Horne @ St-Andrews
* Jul 2003 KDH @ St-And - use detection zone scaling to expand grid
* Jul 2003 KDH @ St-And - x1 bigx1, etc defines min and max grid
* Sep 2003 KDH @ St-And - fix crash x1=xx1 etc
* Jul 2009 KDH @ St-A - round to 0.1
* Jul 2009 KDH @ St-A - premag(t) -> premag(hjd)
	include 'plens.inc'
	write(*,*) 'cxygrid(', split, ' ) *************'
	x1 = xx1
	x2 = xx2
	y1 = yy1
	y2 = yy2
	repl = sqrt( qpl )
	static = qpl / sqrt( delchi2 )
	big1 = 0.
	big2 = 0.
* data points
      do i = 1, ndata
* assumes pre-calculated values by lcurv
	xp = xp_t( i )
	yp = yp_t( i )
	xm = xm_t( i )
	ym = ym_t( i )
	ap = ap_t( i )
	am = am_t( i )
	pmag = premag( hjd_t( i ) )
	emag = erbmag( i, pmag )
	factor = static / emag
      do j = 1, 2
* image position and detection zone area
      if( j .eq. 1 ) then
	xc = xp
	yc = yp
	dza = factor * ( ap + ap - 1. )
      else
	xc = xm
	yc = ym
	dza = factor * ( am + am )
      end if
* size of detection zone
	size = sqrt( dza )
* inside the big box ?
	inside = 1
      if( bigx2 .gt. bigx1 .and. bigy2 .gt. bigy1 ) then
	add = 2. * size
	if( xc + add .lt. bigx1 ) inside = 0
	if( xc - add .gt. bigx2 ) inside = 0
	if( yc + add .lt. bigy1 ) inside = 0
	if( yc - add .gt. bigy2 ) inside = 0
      end if
      if( inside .gt. 0 ) then
	if( j .eq. 1 ) big1 = max( big1, size )
	if( j .eq. 2 ) big2 = max( big2, size )
	x1 = min( x1, xc - add )
	x2 = max( x2, xc + add )
	y1 = min( y1, yc - add )
	y2 = max( y2, yc + add )
      end if
* next j image
      end do
* next i data point
      end do
* 
	extra = 10.*repl
	x1 = x1 - extra
	x2 = x2 + extra
	y1 = y1 - extra
	y2 = y2 + extra

* force grid inside big box
      if( bigx1 .lt. bigx2 ) then
	x1 = max( x1, bigx1 )
	x2 = min( x2, bigx2 )
      end if
      if( bigy1 .lt. bigy2 ) then
	y1 = max( y1, bigy1 )
	y2 = min( y2, bigy2 )
      end if

* round to 0.1
	round = 0.1
	call roundoff( x1, round )
	call roundoff( x2, round )
	call roundoff( y1, round )
	call roundoff( y2, round )

* split the grid box to resolve the planet zones
	if( split .le. 0. ) split = 2.
	nxp = 1 + nint( split * abs( x2 - x1 ) / repl )
	nyp = 1 + nint( split * abs( y2 - y1 ) / repl )
* enforce max grid dimensions
	nxp = min( nxp, max1d )
	nyp = min( nyp, max1d )

* reduce for fast debugging test
c	nxp = 10
c	nyp = 10

* x and y values for the grid
      do i = 1, nxp
	part = float(i-1)/max(1,nxp-1)
	xp_x( i ) = x1 + part * ( x2 - x1 )
      end do
      do i = 1, nyp
	part = float(i-1)/max(1,nyp-1)
	yp_y( i ) = y1 + part * ( y2 - y1 )
      end do
* spacing
	dx = ( xp_x(nx) - xp_x(1) ) / max( 1, nxp-1 )
	dy = ( yp_y(ny) - yp_y(1) ) / max( 1, nyp-1 )
* report
	write(*,*) 'A:', atotl( y0 )
     &	, ' dzsize:', big1, big2, ' rpl:', repl
	write(*,*) 'X:', nxp, x1, x2, dx, nint( repl / dx )
	write(*,*) 'Y:', nxp, y1, y2, dy, nint( repl / dy )
	return
	end
