*------------------------------
	subroutine desafe( pval )
* retrieve parameters from the "safe" values
* input:	r4 pval(*)
* 1998 Sep Keith Horne @ St.Andrews
* 2000 Oct KDH @ St.And - fix bug smag -> smag0
* 2002 Nov KDH @ St.And - b0
* 2002 Nov KDH @ St.And - iuseam1
* 2003 Jul KDH @ St.And - x,y,q
* 2003 Jul KDH @ St.And - y0min
* 2007 Apr KDH @ St.And - fit 5 = with blending
* 2007 Apr KDH @ St.And - parameter index
* 2007 Aug KDH @ LaSilla - plpos
* 2009 Jul KDH @ StA - common/ safety / iuseam1, y0min, neart0
* 2009 Jul KDH @ StA - t0 -> hjd0
* 2010 Mar KDH @ LCO - report t0 round-off errors > 11s
	real*4 pval(*)
	include 'plens.inc'
* parameter index (0=> skip linear parameters)
	common/ kpar / km0, kb0, kt0, kte, ky0, ksig, kerb
	common/ kparp / kqp, kxp, kyp, kup, kap, ktp, kfp
	common/ safety / iuseam1, y0min, neart0
	common/ nonlinpar / nonlinpar

	if( npfit .le. 0 ) return
* desafe parameters
* m0
	if( km0 .gt. 0 ) smag0 = pval( km0 )
	if( npfit .le. 1 ) goto 10
* hjd0, t0
	hjd0 = mjd0 + neart0 + dble( pval( kt0 ) )
	t0 = hjd0 - mjd0

	check = t0 - ( neart0 + pval( kt0 ) )
	onesec = 1./(24.*3600.)
	errsec = check / onesec
      if( abs(errsec) .gt. 50. ) then
	write(*,*) '** WARNING desafe( t0 )'
     &	, neart0, ' +', pval( kt0 ), ' -', t0 - neart0, ' =', check
     &	, ' =', nint(errsec), ' s'
      end if
	if( npfit .le. 2 ) goto 10
* te
	te = 10. ** pval( kte )
	if( npfit .le. 3 ) goto 10

* a0 or y0
      if( iuseam1 .ne. 0 ) then
	amp = 1.d0 + 10. ** pval( ky0 )
	y0 = ainv( amp )
      else
	y0 = 10. ** pval( ky0 )
      end if
	y0 = max( y0, y0min )
c	y0 = sqrt( y0 * y0 + y0min * y0min )
	a0 = atotl( y0 )
	if( npfit .le. 4 ) goto 10
* b0
	if( kb0 .gt. 0 ) b0 = 10. ** pval( kb0 )
	if( npfit .le. 5 ) goto 10

* sigmag0
	sigmag0 = 10.** pval( ksig )
	sigmag0_l( 1 ) = sigmag0
	if( npfit .le. 6 ) goto 10

* error bar scale
	erbscl = 10.** pval( kerb )
	erbscl_l( 1 ) = erbscl
	if( npfit .le. 7 ) goto 10

* planet position (3 options)
      if( plpos .eq. 'UA' ) then
	upl = exp( pval( kup ) )
	apl = pval( kap )
      else if( plpos .eq. 'TF' ) then
	tpl = pval( ktp )
	fpl = exp( pval( kfp ) )
      else if( plpos .eq. 'XY' ) then
	xpl = pval( kxp )
	ypl = pval( kyp )
      end if
* set the planet
	call setplpos
	if( npfit .le. 9 ) goto 10

* mass ratio
	qpl = 10. ** pval( kqp )
	if( npfit .le. 10 ) goto 10

* stow site-dependent parameters
c   10	call stowsite( 1 )
   10	return
	end
