*------------------------------
	subroutine editparms
* edit parameters
* 2002 Nov KDH @ St-And
* 2003 Jul KDH @ St-And - multi-site
* 2003 Sep KDH @ St-And - prior(f)
* 2007 Mar KDH @ Goettingen -- syserr
* 2007 Aug KDH @ La Silla -- xy or ua or tf
* 2008 Jul KDH @ StA - avoid b/(b-1) if b=-1.
* 2008 Jul KDH @ SAAO - editsite
	include 'plens.inc'

    5	call showpar
	title = 'Try also: lens '
      if( nloc .gt. 1 ) then
	call append( title, ', or 1 -' )
	call append_i( title, nloc )
	call append( title, ' to edit a specific site.' )
      end if
	write(*,*) title(:len1(title))

   10	call inq( 'What to change ? ', 'OK', reply )
	call upcase( reply, reply )
	if( reply .eq. 'OK' ) return

	call setsite( 1 )

* lens
      if( reply(1:2) .eq. 'LE' ) then
	call editlens
* t0
      else if( reply(1:2) .eq. 'T0' ) then
	t0 = hjd0 - mjd0
	write(*,*) 'hjd0', hjd0, ' =', mjd0, ' +', t0
* THIS MIGHT NEED REAL*8
	call inqr( 'mid-time t_0', t0, t0 )
	hjd0 = mjd0 + dble( t0 )
	write(*,*) mjd0, ' +', t0, ' =', hjd0
* te
      else if( reply(1:2) .eq. 'TE' ) then
	call inqr( 'time to cross Einstein radius t_E', te, val )
	if( val .gt. 0. ) te = val

* a0
      else if( reply .eq. 'A' .or. reply(1:2) .eq. 'A0') then
	val = atotl( y0 )
	call inqr( 'peak magnification A_0', val, val )
      if( val .gt. 1. ) then
	y0 = ainv( val )
	a0 = atotl( y0 )
      end if
* y0
      else if( reply .eq. 'Y0' .or. reply .eq. 'U0' ) then
	call inqr( 'impact parameter y_0', y0, val )
      if( val .gt. 0. ) then
	y0 = val
	a0 = atotl( y0 )
      end if
* m-m0
      else if( reply .eq. 'M-M0' .or. reply .eq. 'M-M' ) then
	call fitfsfb
* m0
      else if( reply .eq. 'M' .or. reply .eq. 'M0' ) then
	call inqr( 'baseline mag', smag0, smag0 )
* q
      else if( reply .eq. 'Q' ) then
	call inqr( 'planet/star mass ratio q', qpl, val )
	if( val .ge. 0. ) qpl = val
* x y
      else if( reply .eq. 'X' .or. reply .eq. 'Y' 
     &	.or. reply .eq. 'XY' .or. reply .eq. 'XP'
     &	.or. reply .eq. 'YP'
     &	) then
	call editplanet( 'XY' )
* t f
      else if( reply .eq. 'T' .or. reply .eq. 'F'
     &	.or. reply .eq. 'TP' .or. reply .eq. 'FP' ) then
	call editplanet( 'TF' )
* u a
      else if( reply .eq. 'U' .or. reply .eq. 'UP'
     &	.or. reply .eq. 'AP' .or. reply .eq. 'AL' ) then
	call editplanet( 'UA' )

* b0
      else if( reply .eq. 'B' ) then
	write(*,*) 'b = Fb/Fs ( blend flux / source flux ).'
	call inqr( 'blend flux b', b0, val )
	b0 = val
	fb = fs * b0

* sigmag0
      else if( reply .eq. 'S' ) then
	val = sigmag0 * 100.
	call inqr( 'Sig0 = baseline flux error (%) ', val, val )
	if( val .ge. 0. ) sigmag0 = val / 100.
* erbscl
      else if( reply .eq. 'E' ) then
	call inqr( 'Error bar scale f ', erbscl, val )
	if( val .gt. 0. ) erbscl = val
* sys err
      else if( reply .eq. '%' ) then
	val = syserr * 100.
	call inqr( 'Percent systematic error', val, val )
	if( val .ge. 0. ) syserr = val / 100.
* clip
      else if( reply .eq. 'C' ) then
	call inq2r( 'Clip thresholds: lo,hi ', cliplo, cliphi )
* priors
      else if( reply(1:1) .eq. 'P' ) then
* logf
	val1 = avglogf
	val2 = siglogf
	write(*,*) 'Pr( log10( f ) ) = Gaussian'
	call inq2r( '<logf> and sig(logf)', val1, val2 )
	avglogf = val1
	siglogf = val2
* logte
	val1 = avglogte
	val2 = siglogte
	write(*,*) 'Pr( log10( tE ) ) = Gaussian'
	call inq2r( '<logtE> and sig(logtE)', val1, val2 )
	avglogte = val1
	siglogte = val2
* loga0
	val = sigloga0
	write(*,*) 'Pr( log10( A0 ) ) = Exponential'
	call inqr( '<logA0>', val, val )
	sigloga0 = val

* delchi2
      else if( reply .eq. 'D' ) then
	call inqr( 'detection threshold DelChi2', delchi2, val )
	if( val .gt. 0. ) delchi2 = val 

* see/sky corrections
      else if( reply .eq. 'K' ) then
	ival1 = ksee
	ival2 = ksky
	call inq2i( 'see/sky corrections (1,2,3=flx,mag,eta)'
     &		, ival1, ival2 )
	if( ival1 .ge. 0 .and. ival1 .le. 3 ) ksee = ival1
	if( ival2 .ge. 0 .and. ival2 .le. 3 ) ksky = ival2

* multi-site parameters
      else
	read( reply, *, end = 50, err = 50 ) l
	if( l .lt. 1 .or. l .gt. nloc ) goto 50
	call editsite( l )
      end if
	call stowsite( 1 )

* update planet position
	call setplpos
* stow site parameters
	call stowsite( 1 )

	goto 5
* oops
   50	write(*,*) '** please try again.'
	goto 10
	end
