*---------------------------------------------
	subroutine editsite( l )
* Edit parameters of specific site
* 2008 Keith Horne @ SAAO
* 2009 Jul KDH @ St-And - invalid site warning
	include 'plens.inc'

      if( l .le. 0 .or. l .gt. nloc ) then
	write(*,*) '** INVALID SITE editsite(', l, ' )'
     &		, loc, nloc, maxloc
	return
      end if


* set site
   10	call setsite( l )
* display site parameters
 	write(*,*) '** editsite *********', loc, ndat_l(loc)
     &		, ' ', site(:len1(site))
	call showsite

* command
	reply = ' '
	call inq( 'What to change ?', reply, reply )
	call upcase( reply, reply )

* finish up
      if( reply .eq. ' ' ) then
	call stowsite( l )
	call setsite( 1 )
	return
      end if

* sigmag0
      if( reply .eq. 'S' ) then
	val = sigmag0 * 100.
	call inqr( 'Sig0 = Baseline flux error (%) ', val, val )
	if( val .ge. 0. ) sigmag0 = val / 100.
* erbscl
      else if( reply .eq. 'E' ) then
	call inqr( 'Error bar scale f', erbscl, val )
	if( val .ge. 0. ) erbscl = val

* systematic error
      else if( reply .eq. '%' ) then
	val = syserr * 100.
	call inqr( 'Percent systematic error', val, val )
	if( val .ge. 0. ) syserr = val / 100.

* seeing factor
      else if( reply .eq. 'C' ) then
	call inqr( 'Seeing factor c', seefac, seefac )

* baseline mag 
      else if( reply .eq. 'M' ) then
	call inqr( 'm-m0', addmag, val )
	addmag = val
* convert to source and blend flux
	fac = 10.**(0.4*addmag)
	fs = fs_l(1) * fac
	fb = fb_l(1) * fac - b0

* blending
      else if( reply .eq. 'B' ) then
	call setsite( l )
	write(*,*) 'b = Fb/Fs ( blend flux / source flux ).'
	call inqr( 'blend flux b', b0, b0 )
	fb = fs * b0
* source and blend flux
c	fac = 10.**(0.4*addmag)
c	fs = fs_l(1) * fac
c	fb = fb_l(1) * fac - b0

* latitude
      else if( reply .eq. 'LA' ) then
	val = glat
	call inqr( 'North Latitude (degrees) ', val, val )
	if( val .ge. -90. .and. val .le. 90. ) glat = val
* longitude
      else if( reply .eq. 'LO' ) then
	val = glon
	call inqr( 'East Longitude (degrees) ', val, val )
	if( val .ge. -180. .and. val .le. 360. ) glon = val
* elevation
      else if( reply .eq. 'H' ) then
	val = elev
	call inqr( 'Height (metres) ', val, val )
	elev = val
* diam
      else if( reply .eq. 'D' ) then
	call inqr( 'Diameter (m) ', diam, diam )
      else
	write(*,*) '** Please try again.'
	goto 10
      end if
	call stowsite( l )
	goto 10
	end
