*------------------------------
	subroutine eplot
* plot normalized residuals
* 1998 Aug Keith Horne @ St-Andrews
* 2002 Nov KDH @ St-And - plot vs x/RE 
* 2003 Jul KDH @ St-And - cormag, multi-site, tbeg,tend, pgxys
* 2006 Feb KDH @ St-And - timeaxis
* 2006 Mar KDH @ St-And - marknow
	include 'plens.inc'
	write(*,*) 'eplot ****************'

* time axis
	call timeaxis( xmn, xmx, xlabel )

* gather data
      if( ndata.gt.0 ) then      
	call xcalc
      do i=1,ndata
	plot1(i) = eta_i(i)
	plot2(i) = x_t(i)
	if( hjdaxis ) plot2(i) = t_t(i)
      end do
      end if

* window
	ymx = 5.
	ymn = - ymx
      if( ndata .gt. 0 ) then
	rmn = ymn
	rmx = ymx
      do i=1,ndata
      if( plot2(i) .ge. xmn .and. plot2(i) .le. xmx ) then
	rmn = min( plot1(i), rmn )
	rmx = max( plot1(i), rmx )
      end if
      end do
c	call mnmx( ndata, plot1, rmn, rmx )
	add = max( 0.5, abs( rmx - rmn ) * 0.05 )
	ymn = min( ymn, rmn - add )
	ymx = max( ymx, rmx + add )
      end if
	write(*,*) 'x:', xmn, xmx, ' y:', ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )

* verticals
	call pgsci( kolor_model )
	call pgsls(4)
	call marktime( ymn, ymx )
	call pgsls(1)
* horizontals
      do k=-2,2
	call pgsls(4)
	if( k.eq.0 ) call pgsls(1)
	call pgmove( xmn, float(k) )
	call pgdraw( xmx, float(k) )
      end do
	call pgsls(1)
* now
	call pgsci( kolor_now )
	call marknow( ymn, ymx )

* labels
	ylabel = '( data - model ) / sigma'
      if( ndata .eq. 0 ) then
	title = 'Normalised Residuals'
      else
	title = ' '
	call title_event( title )
      end if

	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )
	call legend

* residuals
	call peqc( ndata, plot3, 0. )
	call pgxys( plot2, plot1, plot3, plot3 )

* report
	ndof = ndfit-npfit
	iunit = 21
	write( iunit, 
     &	'(1x, a, i5, i3, f10.4, f10.5 f8.2, 2f8.1)')
     &	datfile(:len1(datfile)), 
     &	ndfit, npfit, sigmag0, erbscl,
     &	chi2fit/max(1,ndof), etalo, etahi

	return
	end
