
*---------------------------
	function erbflx( i, pflx )
* flux error bar (for given predicted flux)
* 2007 Apr KDH @ St.A - adapt from erbmag
* 2009 Jun KDH @ St.A - use mag_to_flx
	include 'plens.inc'

* location-specific noise parameters
	l = loc_t( i )
	syserr = syserr_l( l )
	sigmag0 = sigmag0_l( l )
	erbscl = erbscl_l( l )

* original error bar, scaled
	erbflx = sigflx_t( i ) * erbscl
* check without scaling because some pts come out with huge error bars.
c	erbflx = sigflx_t( i )
* fudged error bar
c	erbflx = erbflx_t( i )
	var = 0.

* systematic error
      if( syserr .gt. 0. ) then
	sig = syserr * pflx
	var = var + sig * sig
      end if

* baseline flux error
      if( sigmag0 .gt. 0. ) then
* DO WE NEED SITE-DEPENDENT BASELINE MAG HERE ???
	flx = smag0
	sig = sigmag0
	call mag_to_flx( flx, sig )
c	flx = toflx( smag0 )
c	sig = flx * ( 10.**( 0.4 * sigmag0 ) - 1. )
	var = var + sig * sig
      end if
	if( var .gt. 0. ) erbflx = sqrt( erbflx * erbflx + var )
  
* restore noise parameters from site 1
	syserr = syserr_l( 1 )
	sigmag0 = sigmag0_l( 1 )
	erbscl = erbscl_l( 1 )
	return
	end
