*--------------------
	subroutine fitfsfb_l( l )
* find source and blend flux 
* 2003 Jul Keith Horne @ St-Andrews
* 2007 Apr KDH @ St.And - verbose
* 2008 Jul KDH @ SAAO - linear fit with fixed blending (not b=0)
* 2009 Jun KDH @ StA - fit constant b0 rather than constant fb.
* 2009 Jun KDH @ StA - fixb0
	include 'plens.inc'
	common/ linearpar / linearpar
	logical verbose/.false./
c	logical verbose/.true./

	np = npfit
	nd = ndat_l( l )
	i = it1_l( l )
      if( verbose ) then
	write(*,*) '** fitfsfb_l(', l, ' )  npfit:', np, ' ndat', nd
      end if

	fs = 1.
	fb = 0.
	apiv = 0.
	sigfb = 0.
	sigfs = 0.
	linearpar = 0

* linear fit of source and blend flux
      if( np .ge. 5 .and. nd .ge. 2 
     &		.and. .not. ( l .eq. 1 .and. fixb0 ) ) then
	linearpar = 2
	call fitline( nd, a_t(i), datflx_t(i), erbflx_t(i)
     &		, apiv, fpiv, fs, sigfb, sigfs )
	fb = fpiv - fs * apiv

* fit source flux fs (with blend flux fb= fs*b0)
* source flux fs scales (A+b0) to fit data
      else if( np .ge. 1 .and. nd .ge. 1 ) then
	linearpar = 1
	call peqpac( nd, a_t(i), a_t(i), +b0 )
	call optscl( nd, datflx_t(i), erbflx_t(i), a_t(i), fs, sigfs )
	call peqpac( nd, a_t(i), a_t(i), -b0 )
	fb = fs * b0
	sigfb = 0.
      end if

* debug report site with single data-point
      if( .false. ) then
      if( nd .eq. 1 ) then
	site = site_l(l)
	write(*,*) ' site', l, ' np', np, ' nd', nd, ' fs', fs
     &	, ' ', site(:len1(site))
	write(*,*) ' mag', datmag_t(i), ' +/-', sigmag_t(i), erbmag_t(i)
	f = datflx_t(i)
	a = a_t(i)
	write(*,*) ' flx', f, ' +/-', sigflx_t(i), erbflx_t(i)
	write(*,*) 't(', i, ' )', t_t(i), ' A', a, ' f/A', f/a 
	call showfsfb_l( l )
      end if
      end if

* reject negative source flux
      if( fs .le. 0. ) then
* fit fs with fb=0 (forgot who needs this)
      if( .true. ) then
	linearpar = 1
	fb = 0.
	sigfb = 0.
	apiv = 0.
	call optscl( nd, datflx_t(i), erbflx_t(i), a_t(i), fs, sigfs )
* fit fb with fs=0 (gridblend needs this)
      else
	linearpar = 1
	fs = 0.
	sigfs = 0.
	apiv = 0.
	call optavg( nd, datflx_t(i), erbflx_t(i), fb, sigfb )
      end if
      end if

* stow
	call stowfsfb_l( l )
* report
      if( verbose ) then
	call showfsfb_l( l )
	write(*,*) ' m0', tomag( abs( fs + fb )), ' b0', fb/fs
     &		, ' linear parameters:', linearpar
      end if

	return
	end
