*------------------------------
	subroutine fitlens( npf )
* fit lens model to lightcurve data
* Input:
*	npf	i4 number of parameters to fit
*
* 1998 Aug Keith Horne @ St-Andrews
* 1998 Sep KDH @ St.And - change to a 6-parameter max likelihood fit
* 2002 Nov KDH @ St.And - b0 
* 2003 Jul KDH @ St.And - loose, xyq fits 
* 2003 Nov KDH @ St.And - nloop=1,2,3->1, nits=1000->500,1000,2000
* 2007 Apr KDH @ St.And - fit 5 = with blending
* 2009 Jul KDH @ St.A - t0 -> hjd0
* 
	include 'plens.inc'
	character*75 model
	write(*,*) 'fitlens ****************', npf

* Note: need to generalize this to more flexible way to
* decide which parameters are free vs fixed.
      if( npf .le. 0 ) then
	write(*,*) 'Fit parameters:'
	write(*,*) 1, loose(1), smag0
     &	,	' m0 = baseline magnitude'
	write(*,*) 2, loose(2), hjd0, hjd0-mjd0
     &	,	' t0 = epoch of peak magnification'
	write(*,*) 3, loose(3), te
     &	,	' te = event duration (einstein radii)'
	write(*,*) 4, loose(4), y0
     &	,	' y0 = impact parameter'
	write(*,*) 5, loose(5), b0
     &	,	' b = blend flux'

* error bar fudge factors
	write(*,*) 6, loose(6), sigmag0
     &	,	' sig0 = background noise (mags)'
	write(*,*) 7, loose(7), erbscl
     &	,	' f = error bar scale'

* planet parameters
	call setplpos
	write(*,*) 8, loose(8), rad2deg( apl )
     &	,	' theta = azimuth of planet (deg)'
	write(*,*) 9, loose(9), upl
     &	,	' u = lens-planet separation (R_E=1)'
	write(*,*) 10, loose(10), qpl
     &	,	' q = planet mass ratio q'

* fit options
	npf = max( 5, npfit )

* default loops
      if( nloop .le. 0 ) then
	nloop = 1
	if( npf .ge. 4 ) nloop = 3
	if( npf .ge. 5 ) nloop = 3
	if( npf .ge. 6 ) nloop = 3
	if( npf .ge. 7 ) nloop = 3
	if( npf .ge. 8 ) nloop = 3
	if( npf .ge. 9 ) nloop = 3
	if( npf .ge. 10 ) nloop = 3
      end if

	ifit = npf
	loop = nloop
	call inq2i( 'Fit Parameters and Loops', ifit, loop )

      if( ifit .lt. 1 .or. ifit .gt. 10 .or. loop .le. 0 ) then
	write(*,*) '** FIT ABORTED.'
	return
      else
	npf = ifit
	nloop = loop
	write(*,*) 'Fit parameters', npf, ' loops', nloop
      end if
      end if

* loop with fits
	call fitloops( npf, nloop )

* report final fit
	call chi2calc( chi2fit, ndfit )
	call fitsummary( 20 )

	return
	end
