*----------------------------------------------
	subroutine fitloops( npf, nloop )
* nloop fits of npf parameters
* 2009 May Keith Horne @ St.Andrews - from fitlens
	include 'plens.inc'

	write(*,*) 'fitloops ****************', ndata, npf, nloop

	write(*,*) 'te', te, ' t0', t0, ' y0', y0, ' a0', a0, ' b0', b0

* mark loose parameters (t0,te,y0,x,y,q) + nloc*(fs,fb,sig0,erbscl)
	nparm = 6 + nloc * 4
      do i=1,nparm
	loose( i ) = 0
	if( npf .ge. i ) loose( i ) = 1
      end do

* loops
      do i=1,nloop
	write(*,*)
* fit
	call fit1( nits, npf, bof )
c	write(*,*) 'after fit1 sigmag0', sigmag0, ' erbscl', erbscl

* relative probability
	if( i .eq. 1 ) best = bof
	best2 = best
	best = min( best, bof )
	relbof = bof - best
	relprob = exp( -0.5 * min( 100., relbof ) )

* report
	title = '** Fit'
	call append_f( title, npf+0.1*i, '(f10.1)' )
	call append( title, 'nits' )
	call append_i( title, nits )
	l = len1(title)
	write( title(l+1:), * ) ' -2lnL', best
* relative probability
      if( i .gt. 1 ) then
	call append( title, ' +' )
	call append_f( title, relbof, '(f10.3)' )
	call append( title, ' P' )
	call append_n( title, relprob, 4 )
      end if
	call append( title, '**' )
	call noeqbl( title )
	write(*,*) title(:len1(title))
	title = ' '
* report parameters
	call title_lens( title )
	if( npf .ge. 5 ) call title_b( title )
	if( npf .ge. 6 ) call title_sig0( title )
	if( npf .ge. 7 ) call title_f( title )
	if( npf .ge. 8 ) call title_x( title )
	if( npf .ge. 9 ) call title_y( title )
	if( npf .ge. 10 ) call title_q( title )
	call noeqbl( title )
	write(*,*) title(:len1(title))
	call multisitereport
* save the best fit
      if( bof .le. best ) then
	npfsave = npf
	call savepar( npfsave )
	write(*,*) '** Best fit', npfsave, ' parmeters saved.'
     &	, ' Del(-2lnL) =', best2 - best
      end if

* next loop
      end do

* restore the best fit
      if( best .lt. bof ) then
	relbof = bof - best
	relprob = exp( -0.5 * min( 100., relbof ) )
	write(*,*)
	write(*,*) '** WARNING: Final BoF', best
     &		, ' +', relbof, ' P', relprob
	write(*,*) '** THIS IS NOT THE BEST FIT.   :((((.'
	call restorepar( npfsave )
	call badness( bof, nd, np )
* report parameters
	title = ' '
	call title_lens( title )
	if( npf .ge. 5 ) call title_b( title )
	if( npf .ge. 6 ) call title_sig0( title )
	if( npf .ge. 7 ) call title_f( title )
	if( npf .ge. 8 ) call title_x( title )
	if( npf .ge. 9 ) call title_y( title )
	if( npf .ge. 10 ) call title_q( title )
	call noeqbl( title )
	write(*,*) title(:len1(title))
	call multisitereport
	write(*,*) '** BEST FIT RESTORED BoF', bof, '   :)'
      end if
	write(*,*)
	return
	end
