*------------------------------
	subroutine fitsummary( iunit )
* summarize fit
* 1998 Aug Keith Horne @ St-Andrews
* 2002 Nov KDH @ St.And - b0
* 2008 Jun KDH @ St.And - save loc-dependent params
	include 'plens.inc'
	real*4 save( maxparm )
	ib0 = 1
	isigmag0 = 2
	ierbscl = 3
	iaddmag = 4
	isitefac = 5
	iaddflx = 6
	nperloc = max( ib0, isigmag0, ierbscl
     &		, iaddmag, isitefac, iaddflx )
	write(*,*) 'nperloc =', nperloc
	nalways = 0

      if( .false. ) then
	write(*,*)
	write(*,*) 'fitsummary ****************', iunit
     &	, ' sigmag0', sigmag0
      end if
* event
	title = ' '
	call title_event( title )
c	title = datfile(:len1(datfile))
	i = index( title, '.dat' )
	if( i .gt. 1 ) title = title(:i-1)
* mid-time
	write( number, '(f14.3)' ) hjd0
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* duration
	write( number, '(f14.2)' ) te
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* baseline mag
	write( number, '(f14.2)' ) smag0
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* magnification in mags
	write( number, '(f14.2)' ) 2.5 * alog10( atotl( y0 ) )
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* blend fraction
	add = max( 0., b0 )
	write( number, '(f14.2)' ) add / ( 1. + add )
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* stow all parameters
	call stowall

* number of parameters to fit
c	write(*,*) 'data', ndfit, ' parameters', npfit
	nloop = min( 7, npfit )
      do npf = 4, nloop

      if( npf .eq. 4 ) then
* stow parameters
	holdb = b0
	holds = sigmag0
	holdf = erbscl
	nhold = npfit

* stow site-dependent values
	last = nalways
      do i=1,nloc
	save( last + ib0 ) = b0_l( i )
	save( last + isigmag0 ) = sigmag0_l( i )
	save( last + ierbscl ) = erbscl_l( i )
	save( last + iaddmag ) = addmag_l( i )
	save( last + isitefac ) = sitefac_l( i )
	save( last + iaddflx ) = addflx_l( i )
	last = last + nperloc
      end do

* reset parameters 5-7, blending and error bar fudge factors.
* DON'T RESET ERROR BAR FUDGE FACTORS HERE
* IF YOU WANT TO USE THE FUDGED ERROR BARS FROM PREVIOUS FIT
	b0 = 0.
	sigmag0 = 0.
	erbscl = 1.
      do i=1,nloc
	b0_l( i ) = 0.
	addflx_l( i ) = 0.
	sigmag0_l( i ) = 0.
	erbscl_l( i ) = 1.
      end do

* data points
	write( number, * ) ndfit
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* fit params
	write( number, * ) npfit
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* b0
      else if( npf .eq. 5 ) then
	write(*,*) 'b0 =', b0, '=>', holdb
	b0 = holdb
	last = nalways
      do i=1,nloc
	b0_l( i ) = save( last + ib0 )
	addflx_l( i ) = save( last + iaddflx )
	last = last + nperloc
      end do

	write( number, '(f14.2)' ) b0
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* sig0
      else if( npf .eq. 6 ) then

* restore values
	write(*,*) 'sigmag0 =', sigmag0, '=>', holds
	sigmag0 = holds
	last = nalways
      do i=1,nloc
	b0_l( i ) = save( last + ib0 )
	addflx_l( i ) = save( last + iaddflx )
	sigmag0_l( i ) = save( last + isigmag0 )
	last = last + nperloc
      end do

	write( number, '(f14.2)' ) sigmag0
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)

* chi scale 
      else if( npf .eq. 7 ) then
	write(*,*) 'erbscl =', erbscl, '=>', holdf
	erbscl = holdf
	last = nalways
      do i=1,nloc
	b0_l( i ) = save( last + ib0 )
	addflx_l( i ) = save( last + iaddflx )
	sigmag0_l( i ) = save( last + isigmag0 )
	erbscl_l( i ) = save( last + ierbscl )
	last = last + nperloc
      end do

	write( number, '(f14.2)' ) erbscl
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)
      end if

* chi2
	call fit1( nits, npf, bof )
	call chi2calc( bof, ndf )
	bofr = bof / max( 1, ndf - npf )
	write(*,*) nits, '-------- Chi^2=', bof
     &		, ' /(', ndf, ' -', npf, ' )=', bofr
	write( number, '(f14.2)' ) bofr
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ' ' // number(l1:l2)
      end do

	write( iunit, * ) title(:len1(title))

* restore all parameters
	call restoreall

	return
	end
