*===========================================
	subroutine fsfbplot
* plot source and blend flux fits
* 2007 Apr Keith Horne @ St.And
* 2008 Jun KDH @ StA - use setsfsb_l
* 2009 Jul KDH @ StA - site-specific colours
* 2009 Jul KDH @ StA - divide by source flux
	include 'plens.inc'
	write(*,*) 'fsfbplot **********'
* divide data by f_s ?
	idiv = 1

* window
	call psplcalc
	call mnmx( ndata, a_t, xmn, xmx )
	xmn = 0.
	xmx = max( 1., xmx ) + 0.2
      if( idiv .eq. 0 ) then
	call mnmx( ndata, datflx_t, ymn, ymx )
      else
	ymn = -0.1
	ymx = xmx
      end if
      do i=1,nloc
	y = fb_l( i )
	div = fs_l( i )
	if( idiv .ne. 0 .and. div .gt. 0. ) y = y / div
	ymn = min( ymn, y )
	ymx = max( ymx, y )
      end do
	add = 0.1 * abs( ymx - ymn )
	ymn = min( 0., ymn - add )
	ymx = max( 0., ymx + add + add )
	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
* fiducials
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
	call pgmove( 0., ymn )
	call pgdraw( 0., ymx )
	call pgmove( 1., ymn )
	call pgdraw( 1., ymx )
* labels
	title = ' '
	call title_event( title )
	call title_apm( title )
	call title_priority( title )
	call noeqbl( title )

	xlabel = 'magnification A'
      if( idiv .eq. 0 ) then
	ylabel = 'f\dobs\u ~ f\db\u + f\ds\u A'
      else
	ylabel = 'f\dobs\u/f\ds\u ~ b + A'
      end if
	call pgsci( kolor_label ) 
	call pglabel( xlabel, ylabel, title )
	call legend

* data (not divided by fs)
c      if( idiv .eq. 0 ) then
c	call pgxys( a_t, datflx_t, erbflx_t, erbflx_t )
c      end if

* models first, then data
	loopmod = 1
	loopdat = 2
      do loop=1,2

* locations
      do i=1,nloc
	i1 = it1_l( i )
	i2 = it2_l( i )
	n = i2-i1+1
	isymb = isymb_l( i )
	k = kolor_l( i )
* special site-specific colour index
	call siteci( i, k )
	call pgsci( k )
* report
	call showfsfb_l( i )

* scale parameters for this site
	call setfsfb_l( i )
c	fs = fs_l( i )
c	fb = fb_l( i )
c	sigfs = sigfs_l( i )
c	sigfb = sigfb_l( i )
c	apiv = apiv_l( i )

* vertical scale factor
	fac = 1.
	if( idiv .ne. 0 .and. fs .gt. 0. ) fac = 1./fs

* data (with error bars)
      if( loop .eq. loopdat ) then
      if( .false. ) then
	call peqp( n, plot1, a_t(i1) )
	call peqpmc( n, plot2, datflx_t(i1), fac )
	call peqpmc( n, plot3, erbflx_t(i1), fac )
	call pgerrb( 2, n, plot1, plot2, plot3, 1. )
	call pgerrb( 4, n, plot2, plot2, plot3, 1. )
	call pgpoint( n, plot1, plot2, isymb )
      else
      do j=i1,i2
	x = a_t(j)
	y = datflx_t(j) * fac
	e = erbflx_t(j) * fac
	call pgerrb( 2, 1, x, y, e, 1. )
	call pgerrb( 4, 1, x, y, e, 1. )
	call pgpoint( 1, x, y, isymb )
      end do
      end if
      end if

* models (with error range)
      if( loop .eq. loopmod ) then
	np = 200
      do j=1,np
	p = float(j-1)/max(1,np-1)
	a = xmn * (1.-p) + xmx * p
	vb = 0.
	vs = 0.
	if( sigfb .gt. 0. ) vb = sigfb * sigfb
	if( sigfs .gt. 0. ) vs = ( sigfs * ( a-apiv ) )**2
	plot1(j) = a
	plot2(j) = ( fb + fs * a ) * fac
	plot3(j) = ( sqrt( vb + vs ) ) * fac
      end do
      do k=-1,1
      do j=1,np
	plot4(j) = plot2(j) + k * plot3(j)
      end do
	if( k .ne. 0 ) call pgsls( 2 )
	call pgline( np, plot1, plot4 )
	call pgsls( 1 )
      end do
      end if

* restore values of fs,fb,etc
	call setfsfb_l( 1 )
* next loc
      end do
* next loop
      end do

	return
	end
