*------------------------------
	subroutine gridblend
* grid fit blend 
* 2002 Nov Keith Horne @ St-Andrews
* 2003 Jul KDH @ StA - legend in separate window, confidence regions
* 2003 Jul KDH @ StA - confidence intervals and bayesian avg rms
* 2007 Apr KDH @ StA - fit 5 = with blending
* 2008 Jul KDH @ SAAO - inq number of blends
* 2008 Jul KDH @ SAAO - use a prior
* 2008 Aug KDH @ StA - blendoption, command menu
* 2009 May KDH @ StA - split-gaussian prior
* 2009 May KDH @ StA - fitloops
* 2009 Jul KDH @ StA - fixb0, blenprioron/off
* 2009 Jul KDH @ StA - quantiles, plotdone
* 2009 Jul KDH @ StA - t0 -> hjd0
* 2009 Jul KDH @ SAAO - enable 5,6,7 parameter fits
* 2009 Dec KDH @ StA - dirty bug fix by repeating ix=1 
	include 'plens.inc'
	logical pgagain
	character*1 blendoption
	logical plotdone
	logical firstcall/.true./

      if( firstcall ) then
	firstcall = .false.
* grid specs
	blendoption = 'L'
	n_b = 51
	blogmn = -2.
	blogmx = 2.
	bmn = -1.
	bmx = 10.
	fmn = 0.
	fmx = 1.
* split-gaussian prior
	b0prior = cenb
	sigb0pos = sigbpos
	sigb0neg = sigbneg
      end if

	write(*,*) 'gridblend ****************', ndata
	if( ndata .le. 0 ) return

* report initial fit
	call fitsummary( 20 )

* save fit
	npfsave = max( 5, npfit )
	npfitin = npfit
	npfgrid = 0
	call savepar( npfit )
	write(*,*) npfit, ' parameters saved.'

* restore grid size
	plotdone = .false.
	n_1 = n_b

* menu
   10	write(*,*)
	write(*,*) 'Bayesian Blend Analysis :', npfgrid, npfsave
	write(*,*) ' N ... Number of grid values:', n_1
	write(*,*) ' B ... B=fb/fs     ', bmn, bmx
	write(*,*) ' L ... L=log(fb/fs)', blogmn, blogmx
	write(*,*) ' F ... F=fb/(fb+fs)', fmn, fmx
	write(*,*) ' P ... Prior(fb/fs) avg', b0prior
     &		, ' sig(-/+)', sigb0neg, sigb0pos

      if( blendoption .eq. 'B' ) then
	write(*,*) ' G ... GO with ', blendoption
     &		, ' = fb/fs', bmn, bmx, n_1
      else if( blendoption .eq. 'L' ) then
	write(*,*) ' G ... GO with ', blendoption
     &		, ' = log(fb/fs)', blogmn, blogmx, n_1
      else if( blendoption .eq. 'F' ) then
	write(*,*) ' G ... GO with ', blendoption
     &		, ' = fb/(fb+fs)', fmn, fmx, n_1
      else
	write(*,*) ' G ... GO with ', blendoption
      end if

      if( plotdone ) then
	write(*,*) ' A ... plot Again'
      end if
	write(*,*) ' Q ... Quit.'

* command
   20	reply = ' '
	call inq( 'Blend grid option:', reply, reply )
	call upcase( reply, reply )

* quit
      if( reply .eq. 'Q' ) then
	write(*,*) '** gridblend fini.', npfgrid, npfsave
	nb = n_1
	return

* go
      else if( reply .eq. 'G' ) then
	goto 50
* plot again
      else if( plotdone .and. reply .eq. 'A' ) then
	goto 100

* B = Blend/Source
      else if( reply .eq. 'B' ) then
	plotdone = plotdone .and. blendoption .eq. 'B'
	blendoption = 'B'
	val1 = bmn
	val2 = bmx
	call inq2r( 'Blend/Source: B=fb/fs', val1, val2 )
      if( val1 .ne. val2 ) then
	bmn = min( val1, val2 )
	bmx = max( val1, val2 )
	bmn = val1
	bmx = val2
      end if

* L = log(Blend/Source)
      else if( reply .eq. 'L' ) then
	plotdone = plotdone .and. blendoption .eq. 'L'
	blendoption = 'L'
	val1 = blogmn
	val2 = blogmx
	call inq2r( 'Log(Blend/Source):', val1, val2 )
      if( val1 .ne. val2 ) then
	plotdone = plotdone .and. blogmn .eq. val1
	plotdone = plotdone .and. blogmx .eq. val2
	blogmn = min( val1, val2 )
	blogmx = max( val1, val2 )
	blogmn = val1
	blogmx = val2
      end if

* F = Blend/Baseline
      else if( reply .eq. 'F' ) then
	plotdone = plotdone .and. blendoption .eq. 'F'
	blendoption = 'F'
	val1 = fmn
	val2 = fmx
	call inq2r( 'Blend/Baseline: F=fb/(fb+fs)', val1, val2 )
      if( val1 .ne. val2 ) then
	plotdone = plotdone .and. fmn .eq. val1
	plotdone = plotdone .and. fmx .eq. val2
	fmn = min( val1, val2 )
	fmx = max( val1, val2 )
	fmn = val1
	fmx = val2
      end if

* number of grid points
      else if( reply .eq. 'N' ) then
	if( n_1 .le. 0 ) n_1 = 51
	ival = n_1
	call inqi( 'Number of grid points', n_1, ival )
	if( n_1 .ne. ival ) plotdone = .false.
	if( ival .gt. 0 ) n_1 = ival
	n_b = n_1

* split gaussian prior
      else if( reply .eq. 'P' ) then
	write(*,*) 'Split Gaussian prior on B=fb/fs.'
	val1 = b0prior
	val2 = sigb0neg
	val3 = sigb0pos
	call inq3r( 'Mean, Sig-, Sig+', val1, val2, val3 )
      if( val2 .gt. 0. .and. val3 .gt. 0. ) then
	plotdone = plotdone .and. val1 .eq. b0prior
	plotdone = plotdone .and. val2 .eq. sigb0neg
	plotdone = plotdone .and. val3 .eq. sigb0pos
	b0prior = val1
	sigb0neg = val2
	sigb0pos = val3
      else
	write(*,*) '** ERROR: Sig-=', val2, ' Sig+=', val3
     &		, ' must be positive :((((.'
      end if

* bad command
      else
c	write(*,*) '** INVALID COMMAND. :(((   Please try again.'
      end if

* next command
	goto 10

* parameter grid
   50	logx = 0
	if( blendoption .eq. 'L' ) logx = 1
      if( blendoption .eq. 'B' ) then
	xmn = bmn
	xmx = bmx
      else if( blendoption .eq. 'F' ) then
	xmn = fmn
	xmx = fmx
      else if( blendoption .eq. 'L' ) then
	xmn = blogmn
	xmx = blogmx
      end if
	write(*,*) 'Option ', blendoption, ' range', xmn, xmx
      do i=1,n_1
	p = (i-0.5) / max(1,n_1)
	x = xmn * (1.-p) + xmx * p
	par_1( i ) = x
      end do
	write(*,*) n_1, par_1(1), par_1(n_1)

* set cpu
	call cpu( dcpu )
* grid search
	ibest = 1

* 2009-dec-01 yianni bug bb gives b0 NAN test NAN after fit 6 on ob03188
* loop gives NAN first time around, so dirty fix is to do it twice :(
c      do ix = 1, n_1
      do ixx = 0, n_1
	ix = max( 1, ixx )

c	call restorepar( npfsave )

* fix b0 and db/dx
	x = par_1( ix )
      if( blendoption .eq. 'F' ) then
	b0 = x / ( 1. - x )
	db_dx = 1. / ( 1. - x )**2
      else if( blendoption .eq. 'B' ) then
	b0 = x
	db_dx = 1.
      else if( blendoption .eq. 'L' ) then
	b0 = 10. ** x
	db_dx = alog(10.) * b0
      end if
	bgrid = b0

c	write(*,*) ix, x, ' b0', b0
	call stowsite( 1 )
* stow

* split gaussian prior
	db_dx = abs( db_dx )
	sigb0prior = sigb0pos
	if( b0 .lt. b0prior ) sigb0prior = sigb0neg
	eta = ( b0 - b0prior ) / sigb0prior
	ee = eta * eta
	priorb0 = exp( -0.5 * ee  ) * db_dx
	chi2prior = ee - 2. * alog( db_dx )

* turn off internal blend prior
	call blendprioroff

* fit npfit = 5,6, or 7 parameters but with b0 fixed
	fixb0 = .true.
	npfit = max( 5, npfitin )

* loops (to test consistency)
	nloop = 1
* diagnose yianni bug bb gives b0 NAN test NAN after fit 6 on ob03188
c      if( ix .le. 2 ) then
c	nloop = 3
c	mutefit0 = 0
c	muteamoeba = 0
c      end if

      do loop=1,nloop
	call fit1( nits, npfit, test )
      if( nloop .gt. 1 ) then
	write(*,*) loop, b0, ' fit1(', nits, npfit, test, ' )'
      end if
      end do

c	mutefit0 = 1
c	muteamoeba = 1

* free b0
	fixb0 = .false.

c	write(*,*) 'fit1(', nits, npfit, test, ' )'
c	write(*,*) ix, x, ' b0', b0

* turn on internal blend prior and free b0
	call blendprioron

c	write(*,*) ix, x, ' b0', b0

	test = test + chi2prior
      if( b0 .ne. bgrid ) then
	change = ( b0 - bgrid ) / sqrt( 1.e-8 + b0*b0 +bgrid*bgrid )
      if( change .gt. 0.01 ) then
	write(*,*) '** WARNING: fit1(', npfit,' ) changed b0',
     &		bgrid, ' =>', b0
	b0 = bgrid
      end if
      end if
* best
	if( ix .eq. 1 ) best = test
      if( test .le. best ) then
	best = test
	ibest = ix
	npfsave = 7
	call savepar( npfsave )
      end if
* stow
	bof_1( ix ) = test
	prior_1( ix ) = priorb0

	hjd0_i( ix ) = hjd0
	t0 = hjd0 - mjd0
	te_i( ix ) = te
	y0_i( ix ) = y0
	a0_i( ix ) = a0
	b0_i( ix ) = b0
	smag0_i( ix ) = smag0

	sigmag0_i( ix ) = sigmag0
	erbscl_i( ix ) = erbscl
	
* report
	fblend = b0 / ( 1. + b0 )
c	write( title, * ) ix, n_1, nits
	title = ' '
	call append_i( title, ix )
	call append( title, '/' )
	call append_i( title, n_1 )
	call append( title, 'its' )
	call append_i( title, nits )
	call append( title, 'b' )
	call append_n( title, b0, 3 )
	call append( title, 'f' )
	call append_n( title, fblend, 3 )
	call append( title, 'A0' )
	call append_n( title, a0, 3 )
	call append( title, 'tE' )
	call append_n( title, te, 3 )
	call append( title, 't0' )
	call append_f( title, t0, '(f15.3)' )
	call append( title, '-2lnL' )
	call append_f( title, best, '(F15.2)' )
	call append( title, '+' )
	call append_f( title, test-best, '(F15.2)' )
	call append( title, 'P' )
	p = exp(-0.5*min(50.,test-best))
	call append_f( title, p, '(f15.3)' ) 
	write(*,*) title(:len1(title))

* report b for all sites
      if( nloc .gt. 1 ) then
	title = 'b(1-'
	call append_i( title, nloc )
	call append( title, '):' )
	call nospace( title )
      do l=1,nloc
	b = fb_l( l ) / fs_l( l )
	call append_n( title, b, 3 )
      end do
	write(*,*) '     ', title(:len1(title))
      end if

* next ix
      end do

* best fit
	write(*,*) 'restoring best fit parameters:', npfsave
	call restorepar( npfsave )
	write(*,*) 'split-gaussian blend prior:'
	write(*,*) 'old Cen', cenb, ' Sig-', sigbneg, ' Sig+', sigbpos
	write(*,*) 'new Cen', b0prior, ' Sig-', sigb0neg, ' Sig+', sigb0pos

	nloop = 2
      do loop=1,nloop
	fblend = b0 / ( 1. + b0 )
	a0 = atotl( y0 )
	write(*,*) '-----------------------------------'
	write(*,*) 'grid best', best, ' b', b0, ' f', fblend
	write(*,*) 'te', te, ' t0', t0, ' y0', y0, ' A', a0
	gridbest = best

* DO WE NEED THIS?
      if( loop .lt. nloop ) then
	npfit = 4
	write(*,*) 'refit parameters:', npfit
	call fit1( nits, npfit, test )
	write(*,*) 'this refit should have changed nothing.'
      end if

* adopt the new prior
      if( loop .eq. 1 ) then
	cenb = b0prior
	sigbneg = sigb0neg
	sigbpos = sigb0pos
	write(*,*) 'adopt new split-gaussian blend prior:'
	write(*,*) 'Cen', cenb, ' Sig-', sigbneg, ' Sig+', sigbpos
      end if
* next loop
      end do


* final refinement

	write(*,*)
	write(*,*) 'Final fits.  Blend parameters b=fs/fb, f=fs/(fs+fb)'
	call showpar

	npfit = 7
	npfit = min( npfit, max( 5, npfitin ) )
	nloop = 3
	if( npfit .gt. 5 ) nloop = 5

	npf = npfit
	call fitloops( npf, nloop )

      if( .false. ) then
      do loop = 1, nloop
	call fit1( nits, npfit, test )
      if( test .lt. best ) then
	best = test
	call savepar( npfsave )
      end if
* report
	p = exp(-0.5*min(50.,test-best))
	title = ' '
	call append_i( title, npfit )
	call append( title, '.' )
	call append_i( title, loop )
	call nospace( title )
	write(*,*) 'Fit ', title(:len1(title) )
     &	,' b', b0, ' f', b0/(1.+b0)
     &	,' -2lnL', best, ' +', test-best, ' P', p
      end do
	call restorepar( npfsave )
      end if

* cpu check
	call cpu( dcpu )
	write(*,*) 'Total CPU used for the grid......'
     &		, dcpu, nint( dcpu ), ' s'
	write(*,*)
	cpubb = dcpu

* report final fit
	call fitsummary( 20 )

* relative and cumulative probability
	sum = 0.d0
      do i = 1, n_1
	pln = 0.5 * ( best - bof_1( i ) )
	pln = max( pln, -50. )
	p = exp( pln )
	sum = sum + p
	post_1( i ) = p
	cum_1( i ) = sum
      end do
* normalise cumulative distribution
	fac = 1./sum
	call peqpmc( n_1, cum_1, cum_1, fac )
* scale the prior (for plots)
	div = prior_1( ibest )
	write(*,*) 'Rescale by prior(', ibest, ' )=', div
	if( div .gt. 0. ) call peqpmc( n_1, prior_1, prior_1, 1./div )

* find quantiles
	ilo = 1
	imed = ( n_1 + 1 ) / 2.
	ihi = n_1
	cumlo = 0.16
	half = 0.5
	cumhi = 1. - cumlo
      do i = 1, n_1 - 1
	cum = cum_1( i )
	cump = cum_1( i + 1 )
      if( cump .ge. cumlo .and. cum .lt. cumlo ) then
	ilo = i
	partlo = ( cumlo - cum ) / ( cump - cum )
      end if
      if( cump .ge. half .and. cum .lt. half ) then
	imed = i
	partmed = ( half - cum ) / ( cump - cum )
      end if
      if( cump .ge. cumhi .and. cum .lt. cumhi ) then
	ihi = i
	parthi = ( cumhi - cum ) / ( cump - cum )
      end if      
      end do
	xlo = par_1( ilo ) * (1.-partlo) + partlo * par_1( ilo+1 )
	xhi = par_1( ihi ) * (1.-parthi) + parthi * par_1( ihi+1 )
	xmed = par_1( imed ) * (1.-partmed) + partmed * par_1( imed+1)

      if( blendoption .eq. 'L' ) then
	blo = 10. ** xlo
	bhi = 10. ** xhi
	bned = 10. ** xmed
      else if( blendoption .eq. 'B' ) then
	blo = xlo
	bhi = xhi
	bmed = xmed
      else if( blendoption .eq. 'F' ) then
	blo = xlo / ( 1. - xlo )
	bhi = xhi / ( 1. - xhi )
	bmed = xmed / ( 1. - xmed )
      end if
* sanity check

* report
	write(*,*) '1-sigma range of b=fb/fs:', blo, bhi
      if( b0 .lt. blo .or. b0 .gt. bhi ) then
	write(*,*) '** WARNING: b0', b0, ' outside 1-sigma range', blo, bhi, ' :(((('
      end if
	write(*,*) 'b=', b0, ' +', bhi-b0, ' -', b0-blo
	write(*,*) 'corresponding range:'
	write(*,*) 'logb=', alog10( b0 )
     &	, ' +', alog10( bhi / b0 ), ' -', alog10( b0 / blo )

	write(*,*) 'logb=', alog10( b0 )
     &	, ' +', alog10( bhi / b0 ), ' -', alog10( b0 / blo )


* format
  100	nxpan = 2
	nypan = 4
	npan = 8
	iprob = 0
	iyb = 0

	imag = 1
	imb = 3
	isb = 5
	ifb = 7
	ipb = 2
	iab = 4
	itb = 6
	it0b = 8
	ilegend = 0
* open
	call pgstart( nxpan, nypan, new )
	call pgkolors
	csize = 1.5
	call pgsch( csize )
	lwide = 1
	call pgslw( lwide )
* panels
      do ipan = 1, npan

* lightcurve plot
      if( ipan .eq. imag ) then
	call magplot( y0, y0, 1 )
      else


* default mag and log options for y axis
	magy = 0
	logy = 1
	ncurve = 1

* gather data for plot
* x axis
	call peqp( n_1, plot1, par_1 )

* y axis
* prob vs b
      if( ipan .eq. ipb ) then
	logy = 0
	call peqp( n_1, plot2, post_1 )
	ylabel = 'Relative Probability'
	ybest = 1.

* baseline mag vs b
      else if( ipan .eq. imb ) then
	logy = 0
	magy = 1
	ylabel = 'baseline mag m\d0\u'
	call peqp( n_1, plot2, smag0_i )
	ybest = smag0
* source mag vs b
	ncurve = 2
      do i=1,n_1
	plot3(i) = smag0_i(i) + 2.5 * alog10( 1. + b0_i(i) ) 
      end do
	ybest2 = smag0 + 2.5 * alog10( 1. + b0 )

* te vs b
      else if( ipan .eq. itb ) then
	ylabel = 't\dE\u'
	call peqp( n_1, plot2, te_i )
	ybest = te

* t0 vs b
      else if( ipan .eq. it0b ) then
	logy = 0

* t0 ( modulo iround )
	iround = 1000
	mjdt0 = iround * int( hjd0 / iround )
	write(*,*) 'hjd0', hjd0, ' it0', it0
	ylabel = 'HJD -'
	call append_i( ylabel, mjdt0 )
      do i=1,n_1
	plot2(i) = hjd0_i(i) - mjdt0
      end do
	ybest = hjdt0 - mjdt0

* y0 vs b
      else if( ipan .eq. iyb ) then
	call peqp( n_1, plot2, y0_i )
	ylabel = 'y\d0\u'
	ybest = y0

* sig0 vs b
      else if( ipan .eq. isb ) then
	call peqp( n_1, plot2, sigmag0_i )
	ylabel = 'baseline rms \gs\d0\u'
	ybest = sigmag0

* f vs b
      else if( ipan .eq. ifb ) then
	call peqp( n_1, plot2, erbscl_i )
	ylabel = 'error bar scale f'
	ybest = erbscl

* A0 vs b
      else if( ipan .eq. iab ) then
	call peqp( n_1, plot2, a0_i )
	ylabel = 'A\d0\u'
	ybest = a0
      end if 

* logs
	call mnmx( n_1, plot2, ymn, ymx )
	if( ymn .le. 0. .or. ymx .le. 0. ) logy = 0
      if( logy .ne. 0 ) then
      do i=1,n_1
	plot2(i) = alog10( plot2(i) )
      end do
	ybest = alog10( ybest )
      end if

* window
	call mnmx( n_1, plot2, ymn, ymx )
	ymx = max( ymx, ybest + 0.4*(ybest-ymn) )
      if( ncurve .gt. 1 ) then 
	call mnmx( n_1, plot3, smn, smx )
	ymn = min( ymn, smn )
	ymx = max( ymx, smx )
      end if
	add = 0.05 * ( ymx - ymn )
	if( logy .ne. 0 ) add = max( 0.2, add )
	ymn = ymn - add
	ymx = ymx + 4 * add
      if( ipan .eq. ipb ) then
	ymn = 0.
	ymx = 1.49
      end if
	iaxis = logx * 10 + logy * 20
	if( ipan .eq. ilegend ) iaxis = -2
* mags
      if( magx .ne. 0 ) then
	write(*,*) 'scale inverted for mags on x axis'
	hold = xmn
	xmn = xmx
	xmx = hold
      end if
      if( magy .ne. 0 ) then
	write(*,*) 'scale inverted for mags on y axis'
	hold = ymn
	ymn = ymx
	ymx = hold
	ymx = min( ymx, ybest + 0.4*(ybest-ymn) )
      end if

      if( ymn .eq. ymx ) then
	add = 0.1
	ymn = ymn - add
	ymx = ymx + add
      end if

	write(*,*) 'pgenv(', xmn, xmx, ymn, ymx, ' )'
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, iaxis )
	call pgsci( 4 )
	call pgplens( 'C' )

* legend
      if( ipan .eq. ilegend ) then
	call pgsci( kolor_label )
	call legend
      else

* horizontals
      if( logy .eq. 0 ) then
	call pgsci( kolor_window )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )
      end if

* labels

      if( blendoption .eq. 'F' ) then
	xlabel = 'blend fraction f\db\u / (f\db\u+f\ds\u)'
      else
	xlabel = 'blend ratio b = f\db\u / f\ds\u'
      end if
	title = ' '
	call title_event( title )
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )

* report Chi^2 and number of data points

	label = ' '
	call title_chi2( label )
	call pgmtxt( 'T', 0.5, 0., 0., label )

* report cpu
	label = 'CPU'
	call append_n( label, cpubb, 3 )
	call pgsch( 0.8 * csize )
	call pgsci( 4 )
	call pgmtxt( 'R', 1.2, 0., 0., label ) 
	call pgsch( csize )

* simplify labels for later use
      if( blendoption .eq. 'F' ) then
	xlabel = 'f\db\u / (f\db\u+f\ds\u)'
      else
	xlabel = 'b'
      end if
	if( ipan .eq. imb ) ylabel = 'm\d0\u'
	if( ipan .eq. ifb ) ylabel = 'f'
	if( ipan .eq. isb ) ylabel = '\gs\d0\u'
	if( ipan .eq. it0b ) ylabel = 't\d0\u'

* extra loop for second variable on same plot
      do loop = 1, ncurve
      if( loop .eq. 2 ) then
	call peqp( n_1, plot2, plot3 )
	ylabel = 'm\ds\u'
	ybest = ybest2
      end if

* curve
	call pgsci( kolor_label )
	call pgline( n_1, plot1, plot2 )
c	if( ipan .eq. imb ) call pgline( n_1, plot1, plot10 )

* prior
      if( ipan .eq. ipb ) then
	call pgsls( 4 )
	call pgsci( kolor_label )
	call pgline( n_1, plot1, prior_1 )
* cumulative
	call pgsls( 2 )
	call pgsci( kolor_label )
	call pgline( n_1, plot1, cum_1 )
	call pgsls( 1 )
      end if

* symbol area proportional to relative probability
	call pgsci( 4 )
	call pgqch( csave )
      do i=1,n_1
	temp = csave * 2. * sqrt( post_1( i ) )
	call pgsch( temp )
	call pgpoint( 1, plot1(i), plot2(i), 23 )
      end do
	call pgsch( csave )

* best grid point
	xb = plot1( ibest )
	yb = plot2( ibest )
	temp = csave * 2. * sqrt( post_1( ibest ) )
	call pgsch( temp )
	call pgsci( 2 )
	call pgpoint( 1, xb, yb, 3 )
	call pgsch( csave )

* best fit
	if( blendoption .eq. 'B' ) xb = b0
	if( blendoption .eq. 'L' ) xb = alog10( b0 )
	if( blendoption .eq. 'F' ) xb = b0 / ( 1. + b0 )
	yb = ybest
	call pgsls( 4 )
	call pgmove( xb, ymn )
	call pgdraw( xb, ymx )
	temp = csave * 2. * sqrt( post_1( ibest ) )
	call pgsch( temp )
	call pgsls( 1 )
	call pgpoint( 1, xb, yb, 12 )
	call pgsch( csave )


* 1-sigma confidence limits
	xlo = plot1( ilo ) * ( 1.-partlo ) + partlo * plot1( ilo+1 )
	xhi = plot1( ihi ) * ( 1.-parthi ) + parthi * plot1( ihi+1 )
	ylo = plot2( ilo ) * ( 1.-partlo ) + partlo * plot2( ilo+1 )
	yhi = plot2( ihi ) * ( 1.-parthi ) + parthi * plot2( ihi+1 )
	xmed = plot1( imed ) * ( 1.-partmed ) + partmed * plot1( imed+1 )
	ymed = plot2( imed ) * ( 1.-partmed ) + partmed * plot2( imed+1 )
* report
	write(*,*)
	write(*,*) 'X:', xlabel(:len1(xlabel))
	write(*,*) 'Y:', ylabel(:len1(ylabel))
	write(*,*) 'x:', xlo, xhi, xb, ' +', xhi - xb, ' -', xb - xlo
	write(*,*) 'y:', ylo, yhi, yb, ' +', yhi - yb, ' -', yb - ylo
* mark quantiles
	call pgsci( kolor_sigma )
	call pgsls( 2 )
	call pgmove( xlo, ymn )
	call pgdraw( xlo, ymx )
	call pgmove( xhi, ymn )
	call pgdraw( xhi, ymx )
	call pgmove( xmed, ymn )
	call pgdraw( xmed, ymx )
      if( ipan .ne. ipb ) then
	call pgmove( xmn, ylo )
	call pgdraw( xmx, ylo )
	call pgmove( xmn, yhi )
	call pgdraw( xmx, yhi )
	call pgmove( xmn, ymed )
	call pgdraw( xmx, ymed )
      end if
	call pgsls( 1 )

* bayesian avg and rms
	call avgrmspdf( n_1, post_1, plot1, avgx, rmsx )
      if( logx .ne. 0 ) then
	avglogx = avgx
	rmslogx = rmsx
	write(*,*) '<logx>=', avglogx, '+/-', rmslogx
      do i=1,n_1
	plot0(i) = 10.** plot1(i)
      end do
	call avgrmspdf( n_1, post_1, plot0, avgx, rmsx )
      end if
	write(*,*) '<x>=', avgx, '+/-', rmsx
	write(*,*) '<y>=', avgy, '+/-', rmsy

* mean and rms y value
	call avgrmspdf( n_1, post_1, plot2, avgy, rmsy )

* mark avg value
      if( ipan .ne. ipb ) then
	call pgsls( 2 )
	call pgsci( kolor_data )
	call pgmove( xmn, avgy )
	call pgdraw( xmx, avgy )
	call pgsls( 1 )
      end if

      if( logy .ne. 0 ) then
	avglogy = avgy
	rmslogy = rmsy
	write(*,*) '<logy>=', avglogy, '+/-', rmslogy
      do i=1,n_1
	plot0(i) = 10.** plot2(i)
      end do
	call avgrmspdf( n_1, post_1, plot0, avgy, rmsy )
      end if
	write(*,*) '<y>=', avgy, '+/-', rmsy

* report confidence limits

	call pgsci( kolor_label )
      if( loop .eq. 1 ) then
	disp = -2.0
	ddisp = -1.5
	coord = 0.95

* report blend prior
      if( ipan .eq. ipb ) then
	title = 'Prior(b) ='
	call append_n( title, b0prior, 2 )
      if( sigb0pos .eq. sigb0neg ) then
	call append( title, '\(2233)' )
	call append_n( title, sigb0pos, 2 )
      else
	call append( title, '+' )
	call append_n( title, sigb0pos, 2 )
	call append( title, '-' )
	call append_n( title, sigb0neg, 2 )
      end if
	call nospace( title )
	call pgmtxt( 't', disp, coord, 1., title )
      end if

	disp = -2.0
	coord = 0.05
      end if
	
      if( ipan .eq. ipb ) then

	title = ' '
	if( logx .ne. 0 ) title = 'log('
      if( blendoption .eq. 'F' ) then
	call append( title, 'f' )
      else
	call append( title, 'b' )
      end if
	if( logx .ne. 0 ) call append( title, ')' )
	call append( title, '=' )
	call append_f( title, xlo, '(f10.2)' )
	call append( title, '-' )
	call append_f( title, xhi, '(f10.2)' )
	call append( title, '=' )
	call append_f( title, xb, '(f10.2)' )
	call append( title, '+' )
	call append_f( title, max(xhi,xlo)-xb, '(f10.2)' )
	call append( title, '-' )
	call append_f( title, xb - min(xhi,xlo), '(f10.2)' )

      if( logx .ne. 0 ) then
	title = '< log('
	call append( title, xlabel )
	call append( title, ') > =' )
	call append_f( title, avglogx, '(f10.2)' )
	call append( title, '\(2233)' )
	call append_f( title, rmslogx, '(f10.2)' )

	call nospace( title )
	call pgmtxt( 't', disp, coord, 0., title )
	disp = disp + ddisp
      end if

	fmt = '(f10.2)'
	title = '<'
	call append( title, xlabel )
	call append( title, '> =' )
	call append_f( title, avgx, fmt )
	call append( title, '\(2233)' )
	call append_f( title, rmsx, fmt )

	call nospace( title )
	call pgmtxt( 't', disp, coord, 0., title )
	disp = disp + ddisp

      else
	
	title = ' '
	if( logy .ne. 0 ) title = 'log('
	call append( title, ylabel )
	if( logy .ne. 0 ) call append( title, ')' )
	call append( title, '= (' )
	call append_f( title, ylo, '(f10.2)' )
	call append( title, ',' )
	call append_f( title, yhi, '(f10.2)' )
	call append( title, ') =' )
	call append_f( title, yb, '(f10.2)' )
	call append( title, '+' )
	call append_f( title, max(yhi,ylo)-yb, '(f10.2)' )
	call append( title, '-' )
	call append_f( title, yb - min(yhi,ylo), '(f10.2)' )

      if( logy .ne. 0 ) then
	title = '< log('
	call append( title, ylabel )
	call append( title, ') > =' )
	call append_f( title, avglogy, '(f10.2)' )
	call append( title, '\(2233)' )
	call append_f( title, rmslogy, '(f10.2)' )

	call nospace( title )
	call pgmtxt( 't', disp, coord, 0., title )
	disp = disp + ddisp
      end if

	fmt = '(f10.2)'
      if( ipan .eq. it0b ) then
	fmt = '(f15.4)'
	avgy = avgy + mjdt0 - mjd0
      end if
	title = '<'
	call append( title, ylabel )
	call append( title, '> =' )
	call append_f( title, avgy, fmt )
	call append( title, '\(2233)' )
	call append_f( title, rmsy, fmt )

	call nospace( title )
	call pgmtxt( 't', disp, coord, 0., title )
	disp = disp + ddisp

      end if
* next loop
      end do

      end if
      end if
* next panel
      end do
* close
	call pgstop
	plotdone = .true.
* again
	if( pgagain() ) goto 100
* summarize fit
	call fitsummary( 20 )
	goto 10
	end
