
*------------------------------
	subroutine gridsigma
* grid fit sig0 and erbscl
* 1998 Aug Keith Horne @ St-Andrews
* 1998 Sep KDH @ St-And - add chi scale factor
* 1998 Sep KDH @ St-And - max likelihood fit
* 2002 Apr KDH @ St-And - fix bugs
* 2002 Nov KDH @ St-And - change name to gridsigma
* 2002 Nov KDH @ St-And - prior(f)
* 2007 Apr KDH @ St.And - fit 5 = with blending
	include 'plens.inc'
	logical pgagain
	logical firstcall/.true./

	write(*,*) 'gridsigma ************', ndata
	if( ndata .le. 0 ) return

* initial parameters
      if( firstcall ) then
	loglog = 1
	nxfine = 51
	nyfine = 51
	nxrough = 21
	nyrough = 21
	nx = nxrough
	ny = nyrough
	cpufudge = 0.7
	firstcall = .false.
      end if

* initial fit
	call fitsummary( 20 )
* save fit
	npfsave = npfit
	call savepar( npfsave )
	write(*,*) npfsave, ' parameters saved.'

* quick fit sig0 with f=1
	call cpu( dcpu )
	cpudone = 0.0
	npfit = 6
	nloop = 1
      do i=1,nloop
	erbscl = 1.
	call stowsite( 1 )
	call fit1( nits, npfit, test )
	write(*,*) 'Fit-6:', test, ' sig0', sigmag0, ' f', erbscl
      end do
	testfit6 = test
	sigmag0fit6 = sigmag0
* cpu 
	call cpu( cpufit6 )
	cpufit6 = cpufit6 / max( 1, nloop )
	write(*,*) 'cpu/fit', cpufit6
	if( cpufit6 .le. 0. ) cpufit6 = 1. * ( ndata / 100. )

* quick fit sig0 and f
	npfit = 7
	nloop = 1
      do i=1,nloop
	call fit1( nits, npfit, test )
	write(*,*) 'Fit-7:', test, ' sig0', sigmag0, ' f', erbscl
      end do
	testfit7 = test
	sigmag0fit7 = sigmag0
	erbsclfit7 = erbscl
	call cpu( cpufit7 )
	cpufit7 = cpufit7 / max( 1, nloop )
	write(*,*) 'cpu/fit', cpufit7


* automatic parameter ranges
* linear grid
	ymn = 0.0
	ymx = max( 0.05, sigmag0fit6, sigmag0fit7 ) * 2.
	xmn = 0.0
	xmx = max( 1., erbsclfit7 ) * 2.
	write(*,*)'Linear grid auto-range:'
	write(*,*) 'X', xmn, xmx, ' f = error bar scale'
	write(*,*) 'Y', ymn, ymx, ' sig0 = baseline rms'
	xmnlin = xmn
	xmxlin = xmx
	ymnlin = ymn
	ymxlin = ymx
* log grid
	add = 0.5
	ymx = alog10( max( 0.01, sigmag0fit6 ) )
	ymn = alog10( max( 0.00001, sigmag0fit7 ) )
	ymx = nint( 3. * ymx ) / 3. + add
	ymn = nint( 3. * ymn ) / 3. - add

	xmn = alog10( min( 1., erbsclfit7 ) )
	xmn = nint( 3. * xmn ) / 3. - add
	xmx = alog10( max( 1., erbsclfit7 ) )
	xmx = nint( 3. * xmx ) / 3. + add
	write(*,*)'Log-Log grid auto-range:'
	write(*,*) 'X', 10.**xmn, 10.**xmx, ' f = error bar scale'
	write(*,*) 'Y', 10.**ymn, 10.**ymx, ' sig0 = baseline rms'
	xmnlog = xmn
	xmxlog = xmx
	ymnlog = ymn
	ymxlog = ymx

* command node

   10	write(*,*) '****************************************'
	write(*,*) 'Fit-6:', testfit6, ' sig0', sigmag0fit6
	write(*,*) 'Fit-7:', testfit7, ' sig0', sigmag0fit7, ' f', erbsclfit7
	write(*,*) 'Sigma grid options:'

      if( loglog .eq. 0 ) then
	write(*,*)' L ... Linear grid'
	xlabel = ' f = error bar scale'
	ylabel = ' sig0 = baseline rms'
	xmna = xmnlin
	xmxa = xmxlin
	ymna = ymnlin
	ymxa = ymxlin
      else
	write(*,*) ' L ... Log-Log grid'
	xlabel = ' Log( f = error bar scale )'
	ylabel = ' Log( sig0 = baseline rms )'
	xmna = xmnlog
	xmxa = xmxlog
	ymna = ymnlog
	ymxa = ymxlog
      end if
	write(*,*) ' N ... Nx Ny', nx, ny
	write(*,*) ' X ... X', xmn, xmx, xlabel(:len1(xlabel))
	write(*,*) ' Y ... Y', ymn, ymx, ylabel(:len1(ylabel))
	write(*,*) ' A ... Autorange X', xmna, xmxa, ' Y', ymna, ymxa
	cpuguess = cpufit6 * nx * ny * cpufudge
	write(*,*) ' G ... Go -- CPU guess:', nint(cpuguess), ' s'
	write(*,*) ' Q ... Quit'

   15	call inq( 'Sigma grid option ', ' ', reply )
	call upcase( reply, reply )

* finish
      if( reply(1:1) .eq. 'Q' ) then
	call fitsummary( 20 )
	return

* loglog vs linear
      else if( reply(1:1) .eq. 'L' ) then
	call inqi( 'Linear (0) or Log-Log (1) ', loglog, ival )
* linear
      if( ival .ne. loglog ) then
      if( ival .eq. 0 ) then
	loglog = 0
	xmx = 10. ** xmx
	xmn = 10. ** xmn
	ymx = 10. ** ymx
	ymn = 10. ** ymn
* loglog
      else if( ival .gt. 0 ) then
	loglog = 1
	xmx = alog10( max( 2., xmx ) )
	xmn = xmx - alog10( 4. )
	ymx = alog10( ymx )
	ymn = ymx - alog10( 4. )
      else
	write(*,*) '** INVALID REPLY. :(((.'
      end if
      end if

* x range
      else if( reply(1:1) .eq. 'X' ) then
	val1 = xmn
	val2 = xmx
	call inq2r( 'X range', val1, val2 )
      if( loglog .eq. 0 ) then
	xmn = max( 0., val1 )
	if( val2 .gt. xmn ) xmx = val2
      else
	xmn = val1
	xmx = val2
	if( xmn .eq. xmx ) xmx = xmx + 0.5
      end if

* y range
      else if( reply(1:1) .eq. 'Y' ) then
	val1 = ymn
	val2 = ymx
	call inq2r( 'Y range', val1, val2 )
      if( loglog .eq. 0 ) then
	ymn = max( 0., val1 )
	if( val2 .gt. ymn ) ymx = val2
      else
	ymn = val1
	ymx = val2
	if( ymn .eq. ymx ) ymx = ymx + 0.5
      end if

* auto range
      else if( reply(1:1) .eq. 'A' ) then
	xmn = xmna
	xmx = xmxa
	ymn = ymna
	ymx = ymxa

* Nx Ny
      else if( reply(1:1) .eq. 'N' ) then
	write(*,*) 'Rough grid Nx Ny', nxrough, nyrough
     &		, ' Finer grid Nx Ny', nxfine, nyfine
	ival1 = nx
	ival2 = ny
	call inq2i( 'Nx Ny', ival1, ival2 )
	if( ival1 .gt. 0 ) nx = ival1
	if( ival2 .gt. 0 ) ny = ival2

* proceed
      else if( reply(1:1) .eq. 'G' ) then
	goto 20

* bad command
      else
	write(*,*) '** Huh? Please try again. :(((.'
      end if
	goto 10


* 2d grid
   20	write(*,*) '************************************************'
      if( loglog .eq. 0 ) then
	write(*,*) ' Linear Grid Nx Ny', nx, ny
      else
	write(*,*) ' LogLog Grid Nx Ny', nx, ny
      end if
	write(*,*) ' X', xmn, xmx, xlabel(:len1(xlabel))
	write(*,*) ' Y', ymn, ymx, ylabel(:len1(ylabel))

* set cpu
	call cpu( dcpu )
	cpudone = 0.0
* x grid
      do i=1,nx
	part = (i-0.5) / max(1,nx)
	plot1(i) = xmn + part * ( xmx-xmn )
      end do
* y grid
      do i=1,ny
	part = (i-0.5) / max(1,ny)
	plot2(i) = ymn + part * ( ymx-ymn )
      end do

* grid search
	ibest = 1
	ixy = 0
      do iy = 1, ny
      do ix = 1, nx
	ixy = ixy+1
	call restorepar( npfsave )
	sigmag0 = plot2(iy)
	if( loglog.ne.0 ) sigmag0 = 10.**plot2(iy)
	erbscl = plot1(ix)
	if( loglog.ne.0 ) erbscl = 10.**plot1(ix)
	call stowsite( 1 )
* fit 5
	npfit = 5
	call fit1( nits, npfit, test )
* stow
	pic1( ixy ) = test
* best
	if( ixy .eq. 1 ) best = test
      if( test .lt. best ) then
	ibest = ixy
	npfsave = 7
	call savepar( npfsave )
	best = pic1( ibest )
      end if
* report
	p = ( ix + (iy-1)*nx ) * 100. / nx / ny
	write(*,*) ix, iy,' sig0', sigmag0, ' f', erbscl, ' -2lnL', best
     &		, nint(p), ' %'
      end do
* best
	call restorepar( npfsave )
	iybest = 1 + (ibest-1)/nx
	ixbest = ibest - nx * (iybest-1)
	xbest = plot1( ixbest )
	ybest = plot2( iybest )
      if( loglog .ne. 0 ) then
	xbest = 10.** xbest
	ybest = 10.** ybest
      end if
* check cpu
	call cpu( dcpu )
	cpudone = cpudone + dcpu
	cputogo = ( ny - iy ) * cpudone / iy
* report
	write(*,*) iy, ny, ' -2lnL', best,
     &	' f', xbest, ' sig0', ybest,
     &	' cpu:', nint( cpudone ), nint( cputogo )
      end do

* adjust cpu
	call cpu( dcpu )
	cpu2d = cpudone + dcpu
	nxy = max( 1, nx, ny )
	cpuperpix = cpu2d / nxy
	write(*,*) '2-D grid cpu', nint(cpu2d), '/', nxy, ' =', cpuperpix
	cpufudge = cpufudge * cpu2d / cpuguess

* 1-d grid search
      do i=1,nx
	erbscl = plot1( i )
	if( loglog .ne. 0 ) erbscl = 10.**erbscl
	call stowsite( 1 )
* fit 5 lens pars and sigmag0
	npfit = 6
	call fit1( nits, npfit, test )
* stow best sigmag0
	plot4( i ) = test
	plot3( i ) = sigmag0
	if( loglog .ne. 0 ) plot3(i) = alog10( sigmag0 )
      if( test .lt. best ) then
	best = test
	call savepar( npfsave )
      end if
* report
	write(*,*) i, nx, ' -2lnL', plot4(i)
     &	, ' f', erbscl, ' sig0', sigmag0
     &	, ' cpu:', nint( cpudone ), nint( cputogo )
      end do

* report best fits
	write(*,*) '----------------------------'
	call restorepar( npfsave )
	write(*,*) 'grid best', best
     &		, ' sig0', sigmag0, ' f', erbscl

* fit 5 lens and 2 error-bar params
	npfit = 7
	nloop = 3
      do i=1,nloop
	call fit1( nits, npfit, test )
	write(*,*) 'Fit-7:', test, sigmag0, erbscl
      if( test .lt. best ) then
	best = test
	call savepar( npfsave )
	write(*,*) 'fit7 best', best
     &		, ' sig0', sigmag0, ' f', erbscl
      end if
      end do
	call restorepar( npfsave )
* report
	call fitsummary( 20 )

* convert -2*log(prob) to prob
      do i=1,nx*ny
	pln = 0.5 * ( best - pic1(i) )
	pln = max( pln, -50. )
	pic1(i) = exp( pln )
      end do
      do i=1,nx
	pln = 0.5 * ( best - plot4(i) )
	pln = max( pln, -50. )
	plot4(i) = exp( pln )
      end do

* format
  100	nxpan = 1
	nypan = 2
	npan = 2
	i2d = 1
	i1d = 2
* open
	call pgstart( nxpan, nypan, new)
	call pgkolors
	csize = 1.5
	call pgsch( csize )
	lwide = 1
	call pgslw( lwide )
* panels
      do ipan = 1, npan

* 2D grid plot -------------------------------------------
      if( ipan .eq. i2d ) then
* window
	iaxis = 0
	if( loglog.ne.0 ) iaxis = 30
	write(*,*) xmn, xmx, ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, iaxis )
* labels
	xlabel = 'error bar scale f'
	ylabel = 'baseline rms \gs\d0\u'
	title = ' '
	call title_event( title )
c	title = datfile(:len1(datfile))
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )
* transform
	tr(6) = ( plot2(ny) - plot2(1) ) / max(1,ny-1)
	tr(5) = 0.
	tr(4) = plot2(1) - tr(6)
	tr(3) = 0.
	tr(2) = ( plot1(nx) - plot1(1) ) / max(1,nx-1)
	tr(1) = plot1(1) - tr(2)
* greyscale
	bg = 0.
	fg = 1.5
	write(*,*) nx, ny, ' bg', bg, pic1(ibest), ' fg', fg
	call pggray( pic1, nx,ny, 1,nx, 1,ny, fg, bg, tr )
* redraw ticks
	call pgsci( kolor_window )
	if( loglog.eq.0 ) call pgbox( 'bcst', 0., 0, 'bcst', 0., 0 )
	if( loglog.ne.0 ) call pgbox( 'bclst', 0., 0, 'bclst', 0., 0 )
* fiducials
	x = 0.
	if( loglog .eq. 0 ) x = 1.
	call pgsls( 4 )
	call pgmove( x, ymn )
	call pgdraw( x, ymx )
	call pgsls( 1 )

* best grid point
	xb = plot1( ixbest )
	yb = plot2( iybest )
	call pgsci( kolor_data )
	call pgpoint( 1, xb, yb, 5 )
      if( loglog.ne.0 ) then
	xb = 10. ** xb
	yb = 10. ** yb
      end if
	write(*,*) '2D grid:', xb, yb, best
* best fit
	xb = erbscl
	yb = sigmag0
      if( loglog.ne.0 ) then
	xb = alog10( xb )
	yb = alog10( yb )
      end if
	call pgpoint( 1, xb, yb, 24 )
	write(*,*) 'Fit-6:', erbscl, sigmag0, 1.0
* contours
      do i=1,3
	if( i.eq. 1 ) c = 2.3
	if( i.eq. 2 ) c = 6.17
	if( i.eq. 3 ) c = 11.8
	c = exp(-0.5*c)
	write(*,*) 'prob contour:', c
	if( i .eq. 1 ) call pgsci(1)
	if( i .eq. 2 ) call pgsci(4)
	if( i .eq. 3 ) call pgsci(3)
	call pgcont( pic1, nx,ny,1,nx,1,ny, c, 1, tr )
      end do
* ridge line
	call pgsls( 8 )
	call pgsci( kolor_model )
	call pgline( nx, plot1, plot3 )
	call pgsls(1)
* legend
	call pgsci( kolor_label )
	call legend

* mark prior(f)
      if( siglogf .gt. 0. ) then
	write(*,*) 'log(f)=', avglogf, ' +/-', siglogf
	call pgsci( kolor_window )
      do k=-1,1
	call pgsls( 2 )
	if( k .ne. 0 ) call pgsls( 4 )
	call pgmove( avglogf + k * siglogf, ymn )
	call pgdraw( avglogf + k * siglogf, ymx )
      end do
	call pgsls( 1 )
      end if


* 1D grid plot -------------------------------------------
	else if( ipan .eq. i1d ) then
* window
	iaxis = 0
	if( loglog.ne.0 ) iaxis = 10
	pmn = 0.
	pmx = 1.2
	write(*,*) xmn, xmx, pmn, pmx

	call pgsci( kolor_window )
	call pgenv( xmn, xmx, pmn, pmx, 0, iaxis )
* fiducials
	x = 0.
	if( loglog .eq. 0 ) x = 1.
	call pgsls( 4 )
	call pgmove( x, pmn )
	call pgdraw( x, pmx )
	call pgsls( 1 )
* labels
	call pgsci( kolor_label )
	call pglabel( xlabel, 'relative probability', title )
* probability 
	call pgsci( kolor_data )
	call pgline( nx, plot1, plot4 )
* best grid point
	xb = plot1( ixbest )
	yb = plot4( ixbest )
	call pgsci( kolor_data )
	call pgpoint( 1, xb, yb, 5 )
	if( loglog .ne. 0 ) xb = 10**xb
	write(*,*) '1D grid:', xb, yb
* best fit
	xb = erbscl
	yb = 1.
	if( loglog .ne. 0 ) xb = alog10( xb )
	call pgsci( kolor_window )
	call pgmove( xb, pmn )
	call pgdraw( xb, pmx )
	call pgsci( kolor_data )
	call pgpoint( 1, xb, yb, 24 )
	write(*,*) 'Fit-7:', erbscl, yb
* legend
	call pgsci( kolor_label )
	call legend

* next panel
      end if
      end do
* close
	call pgstop
* again
	if( pgagain() ) goto 100
	goto 10
	end
