*------------------------------
	subroutine griduq
* grid fit log(u) vs log(q)
* 2003 Jul KDH @ St-And
* 2011 Mar KDH @ StA - fix a few bugs
	include 'plens.inc'
	logical pgagain
	write(*,*) 'griduq ************', ndata
	if( ndata .le. 0 ) return
	data qlog1, qlog2, dlogq / -4., -1., 0.25 /
	data ulog1, ulog2, dlogu / -1., 1., 0.2 /
	data deg1, deg2, ddeg/ 0., 360., 6. /
	data ncalc/0/
* initial fit
	call fitsummary( 20 )
* save fit
	npfsave = npfit
	call savepar( npfsave )
	write(*,*) npfsave, ' parameters saved.'

* 2-d parameter grid
	loglog = 1

* log q grid
    5	nq = 1 + nint( abs( ( qlog2 - qlog1 ) / dlogq ) )
* log u grid
	nu = 1 + nint( abs( ( ulog2 - ulog1 ) / dlogu ) )
* azimuth grid
	naz = 1 + nint( abs( ( deg2 - deg1 ) / ddeg ) )
* menu
   10	write(*,*) ' U ... logU', ulog1, ulog2, dlogu, nu
	write(*,*) ' Q ... logQ', qlog1, qlog2, dlogq, nq
	write(*,*) ' Z ... aZimuth', deg1, deg2, ddeg, naz
	write(*,*) ' C ... Calculate'
      if( ncalc .gt. 0 ) then
	write(*,*) ' T ... Table'
	write(*,*) ' 2 ... 2D Plot'
	write(*,*) ' 1 ... 1D Plot'
	write(*,*) ' D ... Dump to disk'
      end if
	write(*,*) ' A ... Abort'
* command node
	call inq( 'What next ?', ' ', reply )
	call upcase( reply, reply )
	if( reply .eq. 'C' ) goto 200
	if( reply .eq. 'A' ) return
	if( reply .eq. 'U' ) goto 100
	if( reply .eq. 'Q' ) goto 105
	if( reply .eq. 'Z' ) goto 110
      if( ncalc .gt. 0 ) then
	if( reply .eq. 'T' ) goto 300
	if( reply .eq. '2' ) goto 500
	if( reply .eq. '1' ) goto 500
	if( reply .eq. 'D' ) goto 120
      end if
	goto 10

* separations
  100	call inq2r( 'logU range', ulog1, ulog2 )
	call inqr( 'log step', dlogu, dlogu )
	ncalc = 0
	goto 5
* mass ratios
  105	call inq2r( 'logq range', qlog1, qlog2 )
	call inqr( 'logq step', dlogq, dlogq )
	ncalc = 0
	goto 5
* separations
  110	call inq2r( 'azimuth range', deg1, deg2 )
	call inqr( 'azimuth step', ddeg, ddeg )
	goto 5


* dump to a file:
  120	write(*,*) 'write to 2d disk file:'
	file = ' '
	call inq( 'Output file ', file, file )
      if( file .ne. ' ' ) then
	call dump2d3( file, 3, nx, ny, plot1, plot2, pic1, pic2, pic3 )
      end if
	goto 10

* calculate
  200	xmn = ulog1
	xmx = ulog2
	nx = nu
	ymn = qlog1
	ymx = qlog2
	ny = nq
       do i = 1, nx
	part = (i-0.5) / max(1,nx)
	plot1(i) = xmn + part * ( xmx - xmn )
      end do
      do i=1,ny
	part = ( i - 0.5 ) / max( 1, ny )
	plot2(i) = ymn + part * ( ymx - ymn )
      end do

* open plot
	call pgstart( nx, ny, new )
	call pgkolors
	csize = 2.
	call pgsch( csize )

* set cpu
	call cpu( dcpu )
	cpudone = 0.0
* grid search
	ibest = 1

* log q loop
	ixy = 0
      do iy = 1, ny
	write(*,*) '-----------------------------'
     &	, ' q', iy, ' /', ny
* log u loop
      do ix = 1, nx
	write(*,*) '-----------------------------'
     &	, ' q', iy, ' /', ny, ' u', ix, ' /', nx

	ixy = ixy + 1
	call restorepar( npfsave )

	upl = plot1( ix )
	qpl = plot2( iy )
      if( loglog .ne. 0 ) then
	upl = 10.** upl
	qpl= 10.** qpl
      end if
	write(*,*) 'x', ix, nx, ' y', iy, ny, ' q', qpl, ' u', upl

* azimuth scan (ADAPTIVE SPACING ?)
	jbest = 1
      do j = 1, naz
	part = ( j - 0.5 ) / max( 1, naz )
	radian = twopi * part
	call ua2xy( upl, radian, xpl, ypl )
	apl = rad2deg( radian )
	write(*,*) '-----------------------------'
     &	, ' u', iy, ' /', ny, ' q', ix, ' /', nx
     &	, ' az', j, ' /', naz, nint( apl )
* fit 7 parameters
c	npfit = 7
* REDUCE FOR TESTING
	npfit = 5
	write(*,*) 'fit-', npfit
	call fit1( nits, npfit, test )
	write(*,*) 'fit-', npfit, ' -2lnL', best, ' +', test - best
* stow
	plot3( j ) = test
	plot4( j ) = xpl
	plot5( j ) = ypl
	plot6( j ) = apl
      if( test .le. plot3( jbest ) ) then
	jbest = j
	write(*,*) 'az:', j, naz, nint( apl ), ' -2lnL:', test
      end if
* next azimuth
      end do
* report
	write(*,*) '-----------------------------', ' az grid done.'
	best = plot3( jbest )
	xbest = plot4( jbest )
	ybest = plot5( jbest )
	call xy2deg( xbest, ybest, abest )
      do i = 1, naz
	call xy2deg( plot4(i), plot5(i), apl )
	write(*,*) i, ' az:', nint( apl )
     &	, ' -2lnL:', plot3(i), plot3(i) - best
      end do
	write(*,*) 'best az:', jbest, nint( abest ), ' -2lnL:', best

	call showpar
* plot
	call mnmx( naz, plot6, amn, amx )
	call mnmx( naz, plot3, bmn, bmx )
	add = 0.3 * abs( bmx - bmn )
	bmn = bmn - add
	bmx = bmx + add
	call pgsci( kolor_window )
	call pgenv( amn, amx, bmn, bmx, 0, 0 )
	call pgsci( kolor_label )
	call pgline( naz, plot6, plot3 )
	call pgsci( kolor_data )
	call pgpoint( 1, abest, best, 17 )

      if( .false. ) then
* check local minima
      do i=1,naz
	im = i - 1
	ip = i + 1
	if( im .lt. 1 ) im = im + naz
	if( ip .gt. naz ) ip = ip - naz
      if( plot3(i) .le. plot3(im) .and. plot3(i) .le. plot3(ip) ) then
	write(*,*) 'local minimum:'
	xpl = plot4( i )
	ypl = plot5( i )
	call xy2deg( xpl, ypl, apl )
	write(*,*) i, ' az', nint( apl )
     &	, ' -2lnL:', plot3(i), plot3(i)  - best
* launch fit from local minimum
c	npfit = 8
	nits = 2000
* REDUCE FOR TESTING
c	npfit = 4
c	nits = 300
	write(*,*) 'fit-', npfit, ' nits', nits
	call fit1( nits, npfit, test )
	call xy2deg( xpl, ypl, apl )
	write(*,*) i, ' az', nint( apl )
     &	, ' -2lnL:', test, test  - best
      if( test .le. best ) then
	best = test
	xbest = xpl
	ybest = ypl
	abest = apl
	write(*,*) 'best az:', nint( abest ), ' -2lnL:', best

      end if
	call showpar
      end if
      end do
	write(*,*) '-----------------------------','az minima done.'
      end if

* stow best
	pic1( ixy ) = best
	pic2( ixy ) = xbest
	pic3( ixy ) = ybest

	call pgsci( kolor_model )
	call pgmove( abest, bmn )
	call pgdraw( abest, bmx )

	xlabel = 'u='
	call append_f( xlabel, upl, '(f10.2)' )
	ylabel = 'logq='
	call append_f( ylabel, alog10(qpl), '(f10.2)' )
	title = '-2lnL='
	call append_i( xlabel, nint( best ) )
	call pglabel( xlabel, ylabel, title )
* best
	if( ixy .eq. 1 ) ibest = ixy
      if( ixy .eq. 1 .or. best .le. pic1( ibest ) ) then
	ibest = ixy
	npfsave = 9
	call savepar( npfsave )
* report
	write(*,*) ix, iy, ' q', qpl, ' u', upl
     &	, ' az', nint( apl ), ' -2lnL', best
      end if
* next u
      end do
	write(*,*) '-----------------------------', 'u grid done.'
* report
      do i = 1, nx
	j = ixy - nx + i
	test = pic1( j )
	upl = plot1( i )
	xpl = pic2( j )
	ypl = pic3( j )
	call xy2deg( xpl, ypl, apl )
	write(*,*) i, ' logu:', upl, ' az:', nint( apl )
     &	, ' -2lnL:', test, test - best
      end do

* best 
	call restorepar( npfsave )
	best = pic1( ibest )
	iybest = 1 + ( ibest - 1 ) / nx
	ixbest = ibest - nx * ( iybest - 1 )
	ubest = plot1( ixbest )
	qbest = plot2( iybest )
      if( loglog .ne. 0 ) then
	ubest = 10.** ubest
	qbest = 10.** qbest
      end if

* check cpu
	call cpu( dcpu )
	cpudone = cpudone + dcpu
	cputogo = ( ny - iy ) * cpudone / iy
* report
	write(*,*) ix, nx, ' -2lnL', best
     &	, ' q', qbest, ' u', ubest
     &	, ' cpu:', nint( cpudone ), nint( cputogo )
* next u
      end do
	write(*,*) '-----------------------------', 'u-q grid done.'

	call pgstop
	ncalc = 1
	goto 10

* report
  300	title = ' logu='
      do ix=1,nx
	call append_f( title, plot1(i), '(f10.2)' )
      end do
	write(*,*) title(:len1(title))
	ixy = 0
      do iy=1,ny
	title = ' '
	call append_f( title, plot2(iy), '(f10.2)' )
	call append( title, '|' )
      do ix=1,nx
	ixy = ixy + 1
	call append_f( title, pic1(ixy), '(f10.2)' )
      end do
	write(*,*) title(:len1(title))
      end do
	goto 10

  400	write(*,*) '----------------------------', 'u sweep.'
* 1-d grid search
	ixy = 0
      do i = 1, nx
	upl = plot1( i )
	if( loglog .ne. 0 ) upl = 10. ** upl
	write(*,*) '----------------------------'
     &	, ' q', i, nx, upl
	
* fit with q fixed
	npfit = 9
	write(*,*) 'fit-', npfit
	call fit1( nits, npfit, test )

* stow best result
	plot4( i ) = test
	upl = sqrt( xpl**2 + ypl**2 )
	call xy2deg( xpl, ypl, apl )
	plot3( i ) = upl
	if( loglog .ne. 0 ) plot3(i) = alog10( upl )
      if( test .lt. best ) then
	best = test
	call savepar( npfsave )
      end if

* check cpu
	call cpu( dcpu )
	cpudone = cpudone + dcpu
	cputogo = ( nx - i ) * cpudone / i
* report
	write(*,*) i, nx, ' q', qpl, ' u', upl, ' -2lnL', plot4(i)
     &	, ' cpu:', nint( cpudone ), nint( cputogo )
      end do
	write(*,*) '----------------------------', 'q sweep done'

* report best fits

	title = ' logq  logu -2lnL'
	write(*,*) title(:len1(title))
      do i=1,nx
	title = ' '
	call append_f( title, plot1(i), '(f10.2)' )
	call append_f( title, plot3(i), '(f10.2)' )
	call append_f( title, plot4(i), '(f10.2)' )
	write(*,*) title(:len1(title))
      end do

	call restorepar( npfsave )
	write(*,*) 'grid best', best
     &		, ' q', qpl, ' u', upl
	call showpar

* final fit
	npfit = 10
	nloop = 2
      do i = 1, nloop
	write(*,*) 'fit-', npfit
	call fit1( nits, npfit, test )
	write(*,*) 'Fit-10: -2lnL', test, ' q', qpl, ' u', upl
      if( test .lt. best ) then
	best = test
	call savepar( npfsave )
	write(*,*) 'fit10 -2lnL', best
     &		, ' q', qpl, ' u', upl
      end if
      end do
	call restorepar( npfsave )
	call showpar

* report
	call fitsummary( 20 )

* convert -2lnL to prob
      do i = 1, nx * ny
	pln = 0.5 * ( best - pic1(i) )
	pln = max( pln, -50. )
	pic1(i) = exp( pln )
      end do

      do i=1,nx
	pln = 0.5 * ( best - plot4(i) )
	pln = max( pln, -50. )
	plot4(i) = exp( pln )
      end do

* format
  500	nxpan = 1
	nypan = 2
	npan = 2
	i2d = 1
	i1d = 2
	if( reply .eq. '2' ) npan = 1
* open
	call pgstart( nxpan, nypan, new )
	call pgkolors
	csize = 1.5
	call pgsch( csize )
	lwide = 1
	call pgslw( lwide )
* panels
      do ipan = 1, npan

* 2D grid plot -------------------------------------------
      if( ipan .eq. i2d ) then
* window
	iaxis = 0
	if( loglog.ne.0 ) iaxis = 30
	write(*,*) xmn, xmx, ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, iaxis )
* labels
	xlabel = 'u'
	ylabel = 'q'
	title = ' '
	call title_event( title )
c	title = datfile(:len1(datfile))
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )
* transform
	tr(6) = ( plot2(ny) - plot2(1) ) / max(1,ny-1)
	tr(5) = 0.
	tr(4) = plot2(1) - tr(6)
	tr(3) = 0.
	tr(2) = ( plot1(nx) - plot1(1) ) / max(1,nx-1)
	tr(1) = plot1(1) - tr(2)
* greyscale
	bg = 0.
	fg = 1.5
	write(*,*) nx, ny, ' bg', bg, pic1(ibest), ' fg', fg
	call pggray( pic1, ny,nx, 1,ny, 1,nx, fg, bg, tr )
* redraw ticks
	call pgsci( kolor_window )
	if( loglog.eq.0 ) call pgbox( 'bcst', 0., 0, 'bcst', 0., 0 )
	if( loglog.ne.0 ) call pgbox( 'bclst', 0., 0, 'bclst', 0., 0 )

* best grid point
	xb = plot1( ixbest )
	yb = plot2( iybest )
	call pgsci( kolor_data )
	call pgpoint( 1, xb, yb, 5 )
      if( loglog.ne.0 ) then
	xb = 10. ** xb
	yb = 10. ** yb
      end if
	write(*,*) '2D grid:', xb, yb, best
* best fit
	xb = qpl
	yb = upl
      if( loglog.ne.0 ) then
	xb = alog10( xb )
	yb = alog10( yb )
      end if
	call pgpoint( 1, xb, yb, 24 )
	write(*,*) 'Fit-10:', qpl, upl, 1.0
* contours
      do i=1,2
	if( i.eq. 1 ) c = 0.1
	if( i.eq. 2 ) c = 0.01
	write(*,*) 'prob contour:', c
	call pgsci(3)
	call pgcont( pic1, nx,ny,1,nx,1,ny, c, 1, tr )
      end do
* ridge line
	call pgsls(2)
	call pgsci( kolor_model )
	call pgline( nx, plot1, plot3 )
	call pgsls(1)
* legend
	call pgsci( kolor_label )
	call legend


* 1D grid plot -------------------------------------------
	else if( ipan .eq. i1d ) then
* window
	iaxis = 0
	if( loglog.ne.0 ) iaxis = 10
	pmn = 0.
	pmx = 1.2
	write(*,*) xmn, xmx, pmn, pmx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, pmn, pmx, 0, iaxis )
* labels
	call pgsci( kolor_label )
	call pglabel( xlabel, 'relative probability', title )
* probability 
	call pgsci( kolor_data )
	call pgline( nx, plot1, plot4 )
* best grid point
	xb = plot1( ixbest )
	yb = plot4( ixbest )
	call pgsci( kolor_data )
	call pgpoint( 1, xb, yb, 5 )
	if( loglog .ne. 0 ) xb = 10**xb
	write(*,*) '1D grid:', xb, yb
* best fit
	xb = qpl
	yb = 1.
	if( loglog .ne. 0 ) xb = alog10( xb )
	call pgsci( kolor_model )
	call pgmove( xb, pmn )
	call pgdraw( xb, pmx )
	call pgsci( kolor_model )
	call pgpoint( 1, xb, yb, 24 )
	write(*,*) 'Fit-10:', qpl, yb
* legend
	call pgsci( kolor_label )
	call legend

* next panel
      end if
      end do
* close
	call pgstop
* again
	if( pgagain() ) goto 500
	goto 10

	end
