
*------------------------------
	subroutine hone
* launch a fit from each local minimum on the
* c_ua(nup,nap) = chi^2 map vs planet position
* assumes ulog_u(nup) and ap_a(nap) have been set,
* 2003 Sep KDH @ St-And
* 2007 Apr KDH @ St-And - fit 5 params (with blending)
* 2009 Jul KDH @ St-A t0 -> hjd0

	include 'plens.inc'
	logical fast/.true./

* NEED TO RE-CODE TO MAKE IT WORK FOR ANY OF THE OPTIONS
	opt = 'UA'

	write(*,*) 'hone( ', opt(:len1(opt)), ' ) ****************'

* lightcurve
	call xcalc
	call lcalc( ndata, x_t, y0 )
	repl = sqrt( qpl )
* chi2( logr, theta )
	write(*,*) 'GRID SCAN ON PLANET POSITION FOR Q=', qpl
* grid
	call gridbox( opt )
* Chi^2 map
	call chi2map( opt )

	write(*,*) 'HONE THE 2-LENS FIT FOR Q=', qpl

* stow
	call saveplanet
	npfsave = npfit
* ditch planet
	call noplanet
* fit 5 lens parameters
	npfit = 5
	call fit1( nits, npfit, bof ) 
* stow lens parameters
	call savepar( npfit )
* chi^2 with no planet
	call chi2calc( chi2min, ndf )
* degrees of freedom
	ndfit = ndata
	ndof = max( 0, ndfit - npfit )
* report reduced chi^2
	chi2red = chi2min / max(1,ndof)
	write(*,*) 'WITH NO planet, parameters:', npfit, ' bof:', bof
	write(*,*) 'chi2min:', chi2min,
     &	'/(', ndfit, '-', npfit, ')=', chi2red
* stow
	chi2fit = chi2min

* fit parameters
   10	call inqi( 'Parameters to tweak', 9, ival )
	npfit = max( 0, min( 9, ival ) )

* set cpu
	call cpu( dcpu )
	cpudone = 0.

* set planet and evaluate change in chi2
	call restoreplanet
c	qpl = qplsave
	repl = sqrt( qpl )

	ixy = 0
	ibest = 1
	iworst = 1

	iua = 0
	itry = 0
* azimuths
      do ia = 1, nap
	arad = ap_a( ia )
	adeg = rad2deg( arad )
* radii
      do iu = 1, nup
	iua = iua + 1
	upl = 10. ** ulog_u( iu )
	call ua2xy( upl, arad, xpl, ypl )

* local maximum ?

	iup = min( iu + 1, nup )
	ium = max( iu - 1, 1 )
	iap = min( ia + 1, nap )
	iam = min( ia - 1, nap )
	c0 = c_ua( iua )
	c1 = c_ua( iu + ( iam - 1 ) * nup )
	c2 = c_ua( iu + ( iap - 1 ) * nup )
	c3 = c_ua( ium + ( ia - 1 ) * nup )
	c4 = c_ua( iup + ( ia - 1 ) * nup )
	dbof = min( c1, c2, c3, c4 ) - c0
	test = chi2fit - c0
      if( test .gt. delchi2 .and. dbof .gt. 0. ) then
* report
	itry = itry + 1
	write(*,*) itry, iu, ia, ' x', xpl, ' y', ypl
     &		, ' -2lnL', c0, ' DChi2', chi2fit-c0, dbof
	call showpar

* evaluate badness of fit
	bof = chi2fit
* restore lens parameters
	call restorepar( npfit )
* evaluate fit
	call chi2calc( bof, ndf )
* loop
      do loop=1,1
* fit lens parameters with planet in place - only if necessary
      if( npfit .gt. 0 ) then
	test = abs( bof - chi2fit ) / delchi2
	bigtest = 0.02
      if( test .gt. bigtest ) then
c	nrefit = nrefit + 1
	call fit1( nits, npfit, bof ) 
	call chi2calc( bof, ndf )
      end if
      end if
* stow
	c_ua( iua ) = bof
* report
	write(*,*) itry, iu, ia, ' x', xpl, ' y', ypl
     &		, ' -2lnL', c0, ' DChi2', chi2fit-c0, dbof
	call showpar
* next loop
      end do
	write(*,*) '----------------------------------------'
	if( bof .lt. c_ua( ibest ) ) ibest = iua
	if( bof .gt. c_ua( iworst ) ) iworst = iua
      end if

* next radius
      end do
*
	needcua = .false.
* check cpu
	call cpu( dcpu )
	cpudone = cpudone + dcpu
	cputogo = ( nap - ia ) * cpudone / ia
	cputogo2 = ( nap - ia ) * dcpu
* report
      if( ia .eq. 1 .or. ia .eq. nap
     &	 .or. mod( ia, max( 1, nap / 10 ) ) .eq. 0 ) then
	call mnmx( nup, c_ua( iua - nup + 1 ), cmn, cmx )
	write(*,*) ia, nap, ntweak, nup, adeg, cmn, cmx,
     &	' cpu:', nint( cpudone ), nint( cputogo ), nint( cputogo2 )
      end if
* next azimuth
      end do

* report best chi2 with planet
	n_12 = nup * nap
	call mnmx( n_12, c_ua, chi2min, chi2max )
	nd = ndata
	np = max( npfsave, npfit ) + 2
	ndof = max( 0, nd - np )
	chi2red = chi2min / max( 1, ndof )
	write(*,*) 'WITH planet, parameters:', np
	write(*,*) 'chi2min:', chi2min, nd, np, chi2red

* report best
	ia = 1 + ( ibest - 1 ) / nup
	iu = ibest - nup * ( ia - 1 )
	ubest = 10. ** ulog_u( iu )
	abest = ap_a( ia )
	call ua2xy( ubest, abest, xbest, ybest )
	write(*,*) ' best ua:', ubest, abest
     &		, ' DelChi2:', c_ua( ibest ) - chi2fit
	write(*,*) ' best xy:', xbest, ybest

* stow
	smag0fit = smag0
	b0fit = b0
	hjd0fit = hjd0
c	t0fit = t0
	tefit = te
	a0fit = a0
	y0fit = y0
	
	upl = ubest
	xplfit = xbest
	yplfit = ybest
	qplfit = qpl
	dchi2fit = chi2fit - c_ua( ibest )
	
* report worst
	ia = 1 + ( iworst - 1 ) / nup
	iu = iworst - nup * ( ia - 1 )
	write(*,*) 'worst ua:', ulog_u( iu ), ap_a( ia )
     &		, ' DelChi2:', c_ua( iworst ) - chi2fit

* project
	call cumap( chi2fit + delchi2 )
	ibest = 1
	kbest = 1
      do i = 1, nup
	if( p_u( i ) .gt. p_u( kbest ) ) kbest = i
	if( pdet_u( i ) .gt. pdet_u( ibest ) ) ibest = i
      end do
	write(*,*) 'Prob(det|r)=', pdet_u( ibest )
     &		, ' at r/Re=', 10. ** ulog_u( ibest )
	write(*,*) 'Prob(det|a)=', p_u( kbest )
     &		, ' at a/Re=', 10. ** ulog_u( kbest )

* restore 
	call restoreplanet
	npfit = npfsave

* summarize chi map
	call cmapsummary( 20 )
	return
	end
