*------------------------------
	subroutine iplot( y1, y2, nloop )
* plot images
*	y1 and y2 and nloop specify impact parameters
* 1998 Aug Keith Horne @ St-Andrews

	include 'plens.inc'

	write(*,*) 'iplot ****************', y1, y2, nloop
* window
	xmx = 3.
	xmn = - xmx
	fac = 1.3
	ymx = max( uplus( 1.1 ), uplus( y0 + 0.3  ) ) * fac
	ymn = - fac
	write(*,*) xmn, xmx, ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 1, 0 )

* labels
	xlabel = 'x/R\dE\u'
	ylabel = 'y/R\dE\u'
      if( nloc .eq. 0 ) then
	title = 'Image Trajectories'
      else
	title = ' '
	call title_event( title )
	call title_q( title )
      end if
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )
* legend
	call legend_planet( 'T' )
* einstein ring
	call pgsci( kolor_window )
	call ering( 'XY' )
* planet 
	call pgsci( 3 )
	call planet( 'XY' )
	call pgsls( 2 )
      if( ypl .lt. ymx .and. ypl .gt. ymn
     &	.and. xpl .lt. xmx .and. xpl .gt. xmn ) then
	call pgmove( xmn, ypl )
	call pgdraw( xmx, ypl )
	call pgmove( xpl, ymn )
	call pgdraw( xpl, ymx )
      end if
	call pgsls( 1 )
* image trajectories
	call pgsci( kolor_model )
	call impaths( 4, 4 )
* image positions
	call pgsci( kolor_model )
c	call marksites( -1 )
	call marksites( 0 )
* other impact parameters
      if( nloop.gt.0 ) then
	nloops = nloop
	if( y2 .eq. y1 ) nloops=1
      do loop=1,nloop
	part = float(loop-1)/max(1,nloops-1)
	umin = y1 + (y2-y1)*part
	call lcalc( nplt, x_t, umin )

	call pgsls(2)
	call pgsci( kolor_window )
	call pgmove( xmn, umin )
	call pgdraw( xmx, umin )
	call pgsls(1)
	call pgsci( kolor_model )
	call pgline( nplt, xm_t, ym_t )
	call pgline( nplt, xp_t, yp_t )

      end do

      end if

	return
	end
