
*--------------------
	subroutine legend
* plot legend
* 1998 Aug Keith Horne @ St-Andrews
* 2003 Jul KDH @ St-And - multi-site, use append
* 2006 Jul KDH @ StA - skip title_chi2 if no data
* 2007 Aug KDH @ LaSilla - smaller text
* 2008 Jun KDH @ StA - add thalf
* 2009 Jul KDH @ St-A t0 -> hjd0
* 2010 May KDH @ St-A hjd0 -> t0
	include 'plens.inc'
	write(*,*) 'legend *************'

	call pgsch( 0.75 * csize )
	coord = 0.05
	disp = -0.5
	ddisp = -1.5

* chi2 analysis
      if( ndata .gt. 0 ) then
	title = ' '
	call title_chi2( title )
	disp = disp + ddisp
	call pgmtxt( 't', disp, coord, 0., title(:len1(title)) )
      end if

* t0
c	t0 = hjd0 - mjd0
c	write( number, '(f11.3)' ) hjd0
	write( number, '(f11.3)' ) hjd0 - dble(mjd0)
	call word1( number, l1, l2 )
	title = 't\d0\u= ' // number(l1:l2)

* te
	call append( title, 't\dE\u= ' )
	call append_f( title, te, '(f11.2)' )
	title = title(:len1(title)) // 'd'

* thalf
	call append( title, ' t\d1/2\u= ' )
	t = thalf( a0 ) * te
      if( t .lt. 1. ) then
	call append_f( title, t*24., '(f11.1)' )
	title = title(:len1(title)) // 'h'
      else
      if( t .lt. 100. ) then
	call append_f( title, t, '(f11.1)' )
      else
	call append_i( title, nint(t) )
      end if
	title = title(:len1(title)) // 'd'
      end if

	call noeqbl( title )
	disp = disp + ddisp
	call pgmtxt( 't', disp, coord, 0., title(:len1(title)) )
	title = ' '
* y0
	call append( title, 'u\d0\u= ' )
      if( y0 .lt. 0.01 ) then
	call append_f( title, y0, '(f11.4)' )
      else if( y0 .lt. 0.1 ) then
	call append_f( title, y0, '(f11.3)' )
      else
	call append_f( title, y0, '(f11.2)' )
      end if
c	call title_y0( title )
* a0
	a0 = atotl( y0 )
	call append( title, 'A\d0\u= ' )
      if( a0 .lt. 100. ) then
	call append_f( title, a0, '(f11.2)' )
      else if( a0 .lt. 1000. ) then
	call append_f( title, a0, '(f11.1)' )
      else
	call append_i( title, nint(a0) )
      end if
c	call title_a0( title )
* a0 (mag)
	delmag = 2.5 * alog10( a0 )
	call append( title, '= ' )
	call append_f( title, delmag, '(f11.2)' )
	call append( title, 'mag' )
	call noeqbl( title )
	disp = disp + ddisp
	call pgmtxt( 't', disp, coord, 0., title(:len1(title)) )
	title = ' '

* no sites
      if( nloc .le. 0 ) then
	call append( title, 'm\d0\u=' )
	call append_f( title, smag0, '(f11.2)' )
	call append( title, 'b=' )
	call append_f( title, b0, '(f11.2)' )
	disp = disp + ddisp
	call pgmtxt( 't', disp, coord, 0., title(:len1(title)) )
* sites
      else
      do i = 1, nloc
* site
      if( ndat_l( i ) .gt. 0 ) then
	call setsite( i )
	call append( title, site )
* m0
      if( i .eq. 1 ) then
	call append( title, 'm\d0\u=' )
	call append_f( title, smag0, '(f11.2)' )
* m-m0
      else
	call append( title, 'm-m\d0\u=' )
	call append_f( title, addmag, '(f11.2)' )
      end if

* b0
      if( b0 .ne. 0. ) then
	call append( title, 'b=' )
	call append_f( title, b0, '(f11.2)' )
      end if

* syserr
      if( syserr .ne. 0. ) then
      if( i .eq. 1 .or. syserr .ne. syserr_l( 1 ) ) then
	call append_f( title, syserr*100., '(f11.1)' )
	title = title(:len1(title)) // '%'
      end if
      end if
* sig0
      if( sigmag0 .ne. 0. ) then
	call append( title, '\gs\d0\u=' )
	call append_f( title, sigmag0, '(f11.2)' )
      end if
* f
      if( erbscl .ne. 1. ) then
	call append( title, 'f=' )
	call append_f( title, erbscl, '(f11.2)' )
* prior(f)
      if( siglogf .gt. 0. ) then
	call append( title, 'logf=' )
	if( avglogf .ne. 0. )
     &		call append_f( title, avglogf, '(f11.2)' )
	call append( title, '\(2233)' )
	call append_f( title, siglogf, '(f11.2)' )
      end if
      end if
* seecor
      if( ksee .ne. 0 ) then
	call append( title, 'c=' )
	call append_f( title, seefac_l( i ), '(f10.2)' )
      end if
	call noeqbl( title )
	disp = disp + ddisp

* symbol and colour
	call pgqci( kolor )
	k = kolor_l( i )
	call siteci( loc, k )
	call pgsci( k )
c	write(*,*) 'loc', loc, ' ', site(:len1(site)), k, kolor, colour_l(loc)
      if( nloc .gt. 1 ) then
c	call pgsci( kolor_l( i ) )
	call pgmtxt( 't', disp, coord, 0., char( isymb_l( i ) ) )
	title = ' ' // title(:len1(title))
      end if
	call pgmtxt( 't', disp, coord, 0., title(:len1(title)) )
	call pgsci( kolor )
	title = ' '
      end if
* next site
      end do
	call setsite( 1 )
      end if

* planet
	call legend_planet(  'B' )

* restore character size
	call pgsch( csize )
	return
	end
