*------------------------------
	subroutine magplot( y1, y2, nloop )
* plot magnifications on mag scale
*	y1 and y2 and nloop specify impact parameters
* 1998 Aug Keith Horne @ St-Andrews
* 2002 Nov KDH @ St-And - b0
* 2003 Jul KDH @ St-And - cormag, multi-site, tbeg,tend
* 2003 Nov KDH @ St-And - erbmag
* 2005 Aug KDH @ St-And - (t-t0)/te -> HJD
* 2005 Aug KDH @ St-And - timeaxis
* 2006 Mar KDH @ St-And - marknow
* 2008 Jun KDH @ St-And - label te and thalf
* 2008 Jun KDH @ St-And - trap mag of negative fluxes
* 2008 Jun KDH @ St-And - asymmetric error bars
* 2008 Jul KDH @ St-And - Priority
* 2009 Jun KDH @ St-And - kolor_window,kolor_label,kolor_model
* 2009 Jul KDH @ St-A  - t0 => hjd0, preflx(t)->preflx(hjd)
	include 'plens.inc'
	write(*,*) 'magplot **************** ndata', ndata
	t0 = hjd0 - mjd0
* time axis
	call timeaxis( xmn, xmx, xlabel )
* y range
	write(*,*) 'y0', y0, ' A0', a0, ' b0', b0, ' ndata', ndata
	if( a0 .le. 0. ) a0 = 5. 
	ymx = smag0 + 0.5
	ymn = smag0 + blendmag( a0 , b0 )
	ymn = min( ymn - 0.2, smag0 - 0.5 )

* prepare data for plot
      if( ndata .gt. 0 ) then
	bot = toflx( smag0 + 3. )
	call xcalc
      do i=1,ndata
	hjd = hjd_t(i)
* predicted flux
	pflx = preflx( hjd )
* observed flux corrected to site 1 source and blend flux
	flx = corflx( i )
* ends of error bar
c	sigflx = erbflx( i, pflx )
	sigflx = erbcorflx( i, pflx )
	fnt = flx - sigflx
	brt = flx + sigflx
* convert to mags
	cmag = tomag( max( bot, flx ) )
	emagp = tomag( max( bot, fnt ) ) - cmag
	emagm = cmag - tomag( max( bot, brt ) )
* stow
	plot0( i ) = x_t( i )
	if( hjdaxis ) plot0( i ) = hjd - mjd0
	plot1( i ) = cmag
	plot3( i ) = emagp 
	plot4( i ) = emagm 
      end do

* adjust window to include data
	call mnmx( ndata, plot0, tmn, tmx )
	call mnmx( ndata, plot1, dmn, dmx )
	write(*,*) 'Data times', tmn, tmx, ' mags', dmn, dmx 

	rmn = ymn
	rmx = ymx
	bot = smag0 + 1.
      do i=1,ndata
      if( plot0(i) .ge. xmn .and. plot0(i) .le. xmx ) then
	cmag = min( bot, plot1(i) )
	rmn = min( rmn, cmag )
	rmx = max( rmx, cmag )
      end if
      end do
	ymx = max( ymx, rmx + 0.2 )
	ymn = min( ymn, rmn - 0.2 )
      end if

* frame the plot (magnitudes increase downwards)
	faint = ymx
	bright = ymn
	write(*,*) 'pgenv(', xmn, xmx, faint, bright, ' )'
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, faint, bright, 0, 0 )

* verticals
	call pgsls( 4 )
	call pgsci( kolor_model )
	call marktime( ymn, ymx )
* horizontals
	call pgmove( xmn, smag0 )
	call pgdraw( xmx, smag0 )

      if( b0 .gt. 0. ) then
	amag0 = smag0 + blendmag( 1.-b0, b0 )
	bmag0 = smag0 + blendmag( 0., b0 )
	write(*,*) 'a', amag0, ' b', bmag0, ' a+b', smag0
	call pgsci( 2 )
	call pgmove( xmn, amag0 )
	call pgdraw( xmx, amag0 )
	call pgmove( xmn, bmag0 )
	call pgdraw( xmx, bmag0 )
      end if
	call pgsls(1)
* now
	call pgsci( kolor_now )
	call marknow( ymn, ymx )
* label
	ylabel = 'magnitude'
      if( nloc .ge. 1 ) then
	site = site_l(1)
	ylabel = site(:len1(site)) // ' mag'
      end if
* title
      if( nloc .ge. 1 ) then
	title = ' '
	call title_event( title )
	call title_apm( title )
	call title_priority( title )
      else
	title = 'Microlens Lightcurve'
      end if
	call noeqbl( title )
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )

	call legend

* label baseline and peak magnitude
	call pgsci( kolor_model )
	xadd = 0.01 * ( xmx - xmn )
	k2 = 2
      do k=1,k2
	x = xmx + xadd
	if( k .eq. 1 ) y = smag0
	if( k .eq. 2 ) y = smag0 + blendmag( a0, b0 )

      if( y .gt. bright .and. y .lt. faint ) then
	title = ' '
	call append_f( title, y, '(f10.1)' )
	call pgptxt( x, y, 0., 0., title )
      end if
      end do

* label A0
	y = smag0 + blendmag( a0, b0 )
      if( y .gt. bright .and. y .lt. faint ) then
	x = xmx - xadd
	title = ' '
      if( a0 .ge. 50. ) then
	call append_i( title, nint( a0 ) )
      else if( a0 .ge. 5. ) then
	call append_f( title, a0, '(f10.1)' )
      else
	call append_f( title, a0, '(f10.2)' )
      end if
	call pgptxt( x, y, 0., 1., title )	
      end if

* label te and thalf
      if( .false. ) then
	yadd = 0.01 * ( bright - faint )
      do j=1,2
      if( j .eq. 1 ) then
	t = te
	title = 't\dE\u='
      else
	t = te * thalf( a0 )
	call append( title, ' t\d1/2\u=' )
      end if
      if( t .lt. 9.95 ) then
	call append_f( title, t, '(f10.1)' )
      else
	call append_i( title, nint(t) )
      end if
	title = title(:len1(title)) // 'd'
      end do
	call noeqbl( title )

	x = min( xmx, t0 ) - 0.05 * (xmx-xmn)
	disp = -0.5
	call pgmtxt( 'B', disp, (x-xmn)/(xmx-xmn), 1., title )

      end if     

* data
      if( ndata .gt. 0 ) then
* move excluded data to edge of window
      do i=1,ndata
	plot1(i) = max( ymn, min( ymx, plot1(i) ) )
      end do
* plot data and error bars with site-dependent symbols/colours
	call pgxys( plot0, plot1, plot3, plot4 )
      end if

* predicted lightcurve
* with and without planet
	nq = 1
	if( qpl .gt. 0. ) nq = 2
* switch this off as it seems not to work correctly
* when the error-bar parameters sig0 and f are being adjusted.
	nq = 1
      do iq = 1, nq

* fit with no planet
      if( iq .eq. 2 ) then
	call stowall
	call noplanetfit
      end if

	nplt = 1000
      do i=1,nplt
	part = float(i-1) / max(1,nplt-1)
	plot0(i) = xmn + part * ( xmx - xmn )
	x_t(i) = plot0(i)
	if( hjdaxis ) x_t(i) = ( plot0(i) - t0 ) / te
      end do
	call lcalc( nplt, x_t, y0 )
      do i=1,nplt
	plot1(i) = smag0 + blendmag( a_t(i), b0 )
      end do
	call pgsci( kolor_model )
	call pgline( nplt, plot0, plot1 )

* blended lightcurve
      if( b0 .gt. 0. ) then
      do i=1,nplt
	plot2(i) = smag0 + blendmag( a_t(i)- b0, b0 )
      end do
	call pgsls( 2 )
	call pgsci( 2 )
	call pgline( nplt, plot0, plot2 )
	call pgsls( 1 )
      end if

* restore fit with planet
	if( iq .eq. 2 ) call restoreall
      end do

* other lightcurves

      if( nloop .gt. 0 ) then
	nloops = nloop
	if( y1 .eq. y2 ) nloops=1
      do loop = 1, nloops
	part = float(loop-1)/max(1,nloops-1)
	umin = y1 + (y2-y1) * part
	call lcalc( nplt, x_t, umin )

	floor =  10.**(-0.4*ymn)
      do i=1,nplt
	plot1(i) = smag0 + blendmag( a_t( i ), b0 )
	plot2(i) = smag0 + blendmag( ap_t( i ), b0 )
	plot3(i) = smag0 + blendmag( max( floor, am_t(i) ), b0 )
      end do
	call pgsls( 1 )
	call pgsci( kolor_model )
	call pgline( nplt, plot0, plot1 )

* major and minor images
	call pgsls( 2 )
	call pgsci( 2 )
	call pgline( nplt, plot0, plot2 )
	call pgline( nplt, plot0, plot3 )
	call pgsls(1)

      end do
      end if

	return
	end
