*------------------------------
	subroutine marknow( ymn, ymx )
* mark current time on plot
* 2006 Feb Keith Horne @ St.Andrews
* 2008 Jun KDH @ StA t-t0
* 2008 Jun KDH @ StA report A(tnow) and mag(tnow)
* 2009 Jul KDH @ St-A  - t0 => hjd0
	include 'plens.inc'

* calculate tnow, anow, smagnow
	call now( iy, im, id, ith, itm, its )

* UT time label
	write( title, '( a, i4, 5( a, i2.2 ) )' )
     &	'UT ', iy, '-', im, '-', id,
     &	' ', ith, ':', itm, ':', its

* delta time
c	t = tnow - t0
	t = hjdnow - hjd0
	inhours = 0
      if( abs(t) .le. 1.0 ) then
	inhours = 1
	t = t * 24.
      end if
	call append( title, ' = t\d0\u' )
	i1 = len1(title)
	if( t .ge. 0. ) call append( title, ' +')
	if( t .lt. 0. ) call append( title, ' -')
	t = abs(t)
      if( t .gt. 9.9 ) then
	call append_i( title, nint( t ) )
      else if( t .gt. 0.99 ) then
	call append_f( title, t, '(f14.1)' )
      else
	call append_f( title, t, '(f14.2)' )
      end if
      if( inhours .ne. 0 ) then
	title = title(:len1(title)) // 'h'
      else
	title = title(:len1(title)) // 'd'
      end if
	call nospace( title( i1: ) )

* report
	write(*,*) 'Now:', tnow, xnow, ' ', title(:len1(title))
* mark
      if( ymx .ne. ymn ) then
	call pgqwin( x1, x2, y1, y2 )
	xp = xnow
	if( hjdaxis ) xp = tnow
      if( xp .ge. x1 .and. xp .le. x2 ) then
	call pgmove( xp, ymn )
	call pgdraw( xp, ymx )	

* label
      if( .false. ) then
	angle = 90.
	fjust = 0.
	xp = xp - 0.01 * ( x2 - x1 )
	yp = y2 - 0.05 * ( y2 - y1 )
	call pgsch( 0.7 * csize )
	call pgptxt( xp, yp, angle, fjust, title )
	call pgsch( csize )
      else

* report current time along top of plot
	disp = 0.3
	coord = 1.0
	if( x2 .ne. x1 ) coord = ( xp - x1 ) / ( x2 - x1 )
	fjust = 1.
	fjust = coord
	call pgsch( 0.7 * csize )
	call pgmtxt( 'T', disp, coord, fjust, title )
	call pgsch( csize )

* report current magnitude
	add = 0.01
	disp = -0.8
	title = ' '
	call append_f( title, smagnow, '(f14.1)' )
	if( coord .lt. 0.9 ) call append( title, 'mag' )
	call pgmtxt( 'B', disp, coord + add, 0., title )
	write(*,*) 'Inow', smagnow, '  :', title(:len1(title))

* report Anow
	title = 'A='
      if( anow .lt. 2. ) then
	call append_f( title, anow, '(f14.2)' )
      else if( anow .lt. 10. ) then
	call append_f( title, anow, '(f14.1)' )
      else
	call append_i( title, nint( anow ) )
      end if
	call noeqbl( title )
	call pgmtxt( 'B', disp, coord - add, 1., title )
	write(*,*) 'Anow', anow, '  :', title(:len1(title))
	
      end if
      end if
      end if

	return
	end
