
*------------------------------
	subroutine marksiteal( azmn, azmx, azadd, iopt )
* iopt = 0  mark k-sigma detection regions
* iopt = 1  mark each data point with symbol iopt
* iopt < 0  mark each data point with site-dependent symbol
* 1998 Aug Keith Horne @ St-Andrews
* 2002 Nov KDH @ St-And - adapt from marksites
* 2007 Aug KDH @ LaSilla -- xy2la, azmn, azmx, azadd
* 2007 Aug KDH @ LaSilla - iopt
	include 'plens.inc'
	write(*,*) 'marksiteal ****************'
	
      if( ndata.gt.0 ) then
	add = abs( azadd )
	if( add .eq. 0. ) add = 360.
	call xcalc
	call lcalc( ndata, x_t, y0 )
* convert x-y to u-a
	call peqc( ndata, plot0, 0. )
      do i=1,ndata
	call xy2ua( x_t(i), y0, plot1(i), az )
	plot2(i) = rad2deg( az )
	call xy2ua( xp_t(i), yp_t(i), plot3(i), az )
	plot4(i) = rad2deg( az )
	call xy2ua( xm_t(i), ym_t(i), plot5(i), az )
	plot6(i) = rad2deg( az )
      end do
	call fixangles( ndata, plot1, azmn, azmx, add )
	call fixangles( ndata, plot3, azmn, azmx, add )
	call fixangles( ndata, plot5, azmn, azmx, add )
* specified symbol
      if( iopt .gt. 0 ) then
	isymb = iopt
	call pgpoint( ndata, plot1, plot2, isymb )
	call pgpoint( ndata, plot3, plot4, isymb )
	call pgpoint( ndata, plot5, plot6, isymb )
* site-dependent symbol
      else if( iopt .lt. 0 ) then
	call pgxys( plot1, plot2, plot0, plot0 )
	call pgxys( plot3, plot4, plot0, plot0 )
	call pgxys( plot5, plot6, plot0, plot0 )
* ellipses
      else
	repl = sqrt( qpl )
      do i=1,ndata
	smag = sigmag_t( i )
	xs = x_t( i )
	ys = y0
	xp = xp_t( i )
	xm = xm_t( i )
	yp = yp_t( i )
	ym = ym_t( i )
	up = up_t( i )
	um = um_t( i )
	ap = ap_t( i )
	am = am_t( i )
	a = a_t( i )

* planet einstein ring
c	sep = sqrt( xs * xs + ys * ys )
c	rlog = alog10( sep )
c	call xy2deg( xs, ys, az )
c	call xy2la( 1, xs, ys, rlog, az )
c	az = rad2deg( az )
* force angle to be within range (should attend to multiples)
	az = fixangle( az, azmn, azmx, add )

	az = plot2( i )
	sep = plot1( i )
	rlog = alog10( sep )
	eps = repl / sep
	dlogr = alog10( 1. + eps )
	dadeg = rad2deg( eps )

	call pgsci( 3 )
	call pgellipse( rlog, az, dlogr, dadeg )
	
* K-sigma perturbations
	call pgsls(1)
	factor = 2. * qpl / ( sqrt( delchi2 ) * smag )
	thresh = 10.** ( 0.4 * sqrt( delchi2 ) * smag )
      do im = 1, 2
* centre and area
      if( im .eq. 1 ) then
	sep = plot3(i)
	az = plot4(i)
	aim = abs( ap )
	area = ( aim - 0.5 ) * factor
      else
	sep = plot5(i)
	az = plot6(i)
	aim = abs( am )
	area = aim * factor
      end if
      if( aim .gt. 0. ) then
	rlog = alog10( sep )
	size = repl * ainv( 1. + (thresh-1.) * a / aim )
	eps = size / sep
	dlogr = alog10( 1. + eps )
	dadeg = rad2deg( eps )
* ellipse
	call pgsci( kolor_model )
	call pgellipse( rlog, az, dlogr, dadeg )
      end if
* next im
      end do
* next data
      end do
      end if
      end if
	return
	end
