*------------------------------
	subroutine marksites( iopt )
* iopt = 0  mark k-sigma detection regions
* iopt = 1  mark each data point with symbol iopt
* iopt < 0  mark each data point with site-dependent symbol
* 1998 Aug Keith Horne @ St-Andrews
* 2007 Aug KDH @ LaSilla - iopt
	include 'plens.inc'
	write(*,*) 'marksites(', iopt, ' ) ****************'

      if( ndata.gt.0 ) then
* lightcurve
	call xcalc
	call lcalc( ndata, x_t, y0 )
* site-dependent symbols
      if( iopt .lt. 0 ) then
	call peqc( ndata, plot0, 0. )
	call pgxys( xs_t, ys_t, plot0, plot0 )
	call pgxys( xp_t, yp_t, plot0, plot0 )
	call pgxys( xm_t, ym_t, plot0, plot0 )
* specified symbol
      else if( iopt .gt. 0 ) then
	isymb = iopt
	call pgpoint( ndata, xs_t, ys_t, isymb )
	call pgpoint( ndata, xm_t, ym_t, isymb )
	call pgpoint( ndata, xp_t, yp_t, isymb )
* circles with detection zone area
      else
	repl = sqrt( qpl )
      do i = 1, ndata
	smag = sigmag_t( i )
	xs = x_t( i )
	ys = y0
	xp = xp_t( i )
	xm = xm_t( i )
	yp = yp_t( i )
	ym = ym_t( i )
	ap = ap_t( i )
	am = am_t( i )
	a = a_t( i )
* planet einstein ring
	call pgsls(1)
	call pgsci(3)
	call pgcirc( xs, ys, repl )
* K-sigma perturbations
	call pgsls(1)
	call pgsci( kolor_model )
	thresh = 10.** ( 0.4 * sqrt( delchi2 ) * smag )
      if( ap .gt. 0. ) then
	rdraw = repl * ainv( ( thresh * a - am ) / ap )
	call pgcirc( xp, yp, rdraw )
      end if
	call pgsci( kolor_model )
      if( am .gt.0. ) then
	rdraw = repl * ainv( ( thresh * a - ap ) / am )
	call pgcirc( xm, ym, rdraw )
      end if
* next data point
      end do
      end if
      end if
	return
	end
