*------------------------------
	subroutine newdata
* new data from a file
* 1998 Aug Keith Horne @ St-Andrews
* 2002 Mar KDH @ St-And - loadlc -> loadlc3
* 2003 Jul KDH @ St-And - site-dependent parameters
* 2003 Jul KDH @ St-And - load data from multiple files
* 2003 Nov KDH @ St-And - read seeing, sky, dwell
* 2007 Aug KDH @ La Silla - LOADLCNT, and format loop
* 2008 Jul KDH @ StA - head and tail each data file
* 2008 Jul KDH @ StA - fix bug detecting format of 1-epoch data files
* 2009 Jul KDH @ StA - sort times
* 2009 Jul KDH @ StA - format(8,3), recover ogle format (3->5).  
	include 'plens.inc'
	integer*4 i_t( maxdata )
	real*8 hold_t( maxdata )

	logical aok
	write(*,*) 'newdata ***********************************'
	write(*,*) 'Enter the name of a lightcurve data file'
	write(*,*) 'or @name for a list of files in name.lis'
* new datfile ?
	if( datfile .ne. ' ' )
     &	write(*,*) 'Old file: ', datfile(:len1(datfile) )
	call inq( 'New file: ', ' ', file )
	if( file .eq. ' ' ) return
	datfile = file

* how many data files ?
	call word1( datfile, l1, l2 )
      if( datfile(l1:l1) .ne. '@' ) then
	nfile = 1
	datfile_l( 1 ) = datfile
      else
	nfile = maxloc
	call loadlist( datfile, nfile, datfile_l )
* strip .lis from datfile
c	datfile = datfile(l1+1:)
	l = index( datfile, '.lis' )
	if( l .gt. 0 ) datfile = datfile(:l-1)
      end if
	write(*,*) 'datfiles:', nfile
      do i=1,nfile
	file = datfile_l( i )
	write(*,*) 'datfile', i, ': ', file(:len1(file))
      end do

* loop thru data files
	ndata = 0
	nloc = 0
      do ifile = 1, nfile
* report data file name
	file = datfile_l( ifile )
	write(*,*) '------------------------------------------'
	write(*,*) 'datfile', ifile, ': ',  file(:len1(file))
      do i=1,3
	if( i .eq. 1 ) title = 'ls -l'
	if( i .eq. 2 ) title = 'head -n 3'
	if( i .eq. 3 ) title = 'tail -n 3'
	call append( title, file(:len1(file)) )
	call spawn( title )
      end do
	i1 = ndata + 1
	more = maxdata - ndata

* TRY A HIERARCHY OF DATA FORMATS UNTIL ONE WORKS
	iform84 = 1
	iform83 = 2
	iform73 = 3
	iform6 = 4
	iform5 = 5
	iform4 = 6
	iform3 = 7
	nform = 7
	iform = 0
	aok = .false.
      do while( .not. aok .and. iform .lt. nform )
	iform = iform + 1
	new = more
	write(*,*)

* 8 columns with HJD in column 4
      if( iform .eq. iform84 ) then
	write(*,*) '** Format 8,4=( N mag err HJD see sky code dwell )'
	call loadlc8t( file, 8, 4, new, hjd_t(i1)
     &	, plot1(i1),  datmag_t(i1), sigmag_t(i1)
     &	, see_t(i1), sky_t(i1), code_t(i1), dwell_t(i1) )

* sanity check
	aok = new .gt. 0
      if( aok ) then
	tiny = 1.e-4
	i = i1
	last = i1 + new - 1
      do while( aok .and. i .le. last )
	aok = aok .and. abs( plot1(i) - nint( plot1(i) ) ) .lt. tiny
	i = i + 1
      end do
	if( .not. aok ) write(*,*) '** FIRST COLUMN NOT SEQUENCE NUMBERS.'
      end if

* 8 columns with HJD in column 3
      else if( iform .eq. iform83 ) then
	write(*,*) '** Format 8,3=( mag err HJD see sky air dwell code )'
	call loadlc8t( file, 8, 3, new, hjd_t(i1)
     &	, datmag_t(i1), sigmag_t(i1)
     &	, see_t(i1), sky_t(i1), air_t(i1), dwell_t(i1), code_t(i1) )
	aok = new .gt. 0

* 7 columns with HJD in column 3
      else if( iform .eq. iform73 ) then
	write(*,*) '** Format 7,3=( mag err HJD see sky code dwell )'
	call loadlc7t( file, 7, 3, new, hjd_t(i1)
     &	, datmag_t(i1), sigmag_t(i1)
     &	, see_t(i1), sky_t(i1), code_t(i1), dwell_t(i1) )
	aok = new .gt. 0

* 6 columns = ( HJD, mag, err, see, sky, dwell )
      else if( iform .eq. iform6 ) then
	write(*,*) '** Format 6=( HJD mag err see sky dwell )'
	new = more
	call loadlc6( file, 6, new, hjd_t(i1)
     &		, datmag_t(i1), sigmag_t(i1)
     &		, see_t(i1), sky_t(i1), dwell_t(i1) )
	aok = new .gt. 0

* 5 columns = ( HJD, mag, err, see, sky )
      else if( iform .eq. iform5 ) then
	write(*,*) '** Format 5=( HJD mag err see sky ) MISSING dwell.'
	new = more
	call loadlc5( file, 5, new, hjd_t(i1)
     &		, datmag_t(i1), sigmag_t(i1)
     &		, see_t(i1), sky_t(i1) )
	aok = new .gt. 0

* Look for additional 3-column data (e.g. early OGLE data lack see and sky )
      if( aok ) then
	n5 = new
	new = more
	call loadlc3( file, 3, new, hold_t(i1)
     &		, plot1(i1), plot2(i1) )
	n3 = new - n5 + 1
      if( n3 .gt. n5 ) then
	write(*,*)
	write(*,*) '** MIXED 3+5=( HJD mag err )+( HJD mag err see sky ) MISSING dwell.'
	write(*,*) '   3-column data', n3, ' 5-column data', n5, ' Total', new
	call peqc( new, plot3(i1), -1. )
	call peqc( new, plot4(i1), -1. )
	k = i1
	last = i1 + new - 1
      do i = i1, last
      if( hold_t(i) .eq. hjd_t(k) ) then
	plot3(i) = see_t(k)
	plot4(i) = sky_t(k)
	k = k + 1
      end if
      end do
	k = k - i1
	if( k .ne. n5 ) write(*,*) '** ERROR found', k, ' of', n5, ' lost', n5-k+1
      do i = i1, last
	hjd_t(i) = hold_t(i)
	datmag_t(i) = plot1(i)
	sigmag_t(i) = plot2(i)
	see_t(i) = plot3(i)
	sky_t(i) = plot4(i)
      end do
      end if
	call peqc( new, dwell_t(i1), -1. )
      end if

* 4 columns = ( time, mag, err, see, sky )
      else if( iform .eq. iform4 ) then
	write(*,*) '** FORMAT 4 =( HJD mag err see ) MISSING sky dwell.'
	new = more
	call loadlc4( file, 4, new, hjd_t(i1)
     &		, datmag_t(i1), sigmag_t(i1)
     &		, see_t(i1) )
	aok = new .gt. 0
      if( aok ) then
	call peqc( new, dwell_t(i1), -1. )
	call peqc( new, sky_t(i1), -1. )
      end if

* 3 columns = ( time, mag, err )
      else if( iform .eq. iform3 ) then
	write(*,*) '** Format 3=( HJD mag err ) MISSING see sky dwell.'
	new = more
	call loadlc3( file, 3, new, hjd_t(i1)
     &		, datmag_t(i1), sigmag_t(i1) )
	aok = new .gt. 0
      if( aok ) then
	call peqc( new, dwell_t(i1), -1. )
	call peqc( new, sky_t(i1), -1. )
	call peqc( new, see_t(i1), -1. )
      end if
      end if

* validate HJD (permit 0. but reject later)
      if( aok ) then
	i = i1
	last = i1 + new - 1
      do while( aok .and. i .le. last )
	hjd = hjd_t(i)
	aok = aok .and. ( hjd .gt. 1000.d0
     &	.or. hjd .eq. 0.d0
     &	.or. ( dabs(hjd_t(i)-dble(2450000)) .lt. 0.1d0 )
     &	)
	if( .not. aok ) write(*,*) '** INVALID HJD(', i, ' ) ', hjd_t(i), '  :('
	i = i + 1
      end do
      end if

* accept/reject data format
      if( aok ) then
	write(*,*) '** DATA FORMAT ACCEPTED **  :)'
      else
	write(*,*) '** DATA FORMAT REJECTED **  :('
      end if
* next data format
      end do

* reject bad data points
      if( aok ) then
	n = i1
	nz = 0
	nbadt = 0
	i2 = i1 + new - 1
      do i=i1,i2
	sig = sigmag_t(i)
	hjd = hjd_t(i)
      if( sig .le. 0. .or. hjd .le. 0.d0 ) then
      if( sig .le. 0. ) then
	nz = nz + 1
	write(*,*) '** INVALID ERROR BAR :((((.'
      end if
      if( hjd .le. 0.d0 ) then
	nbadt = nbadt + 1
	write(*,*) '** INVALID HJD       :((((.'
      end if
	write(*,*) i, ' hjd', t_t(i), ' mag', datmag_t(i), ' +-', sig
      else
	hjd_t(n) = hjd_t(i)
	datmag_t(n) = datmag_t(i)
	sigmag_t(n) = sigmag_t(i)
	see_t(n) = see_t(i)
	sky_t(n) = sky_t(i)
	dwell_t(n) = dwell_t(i)
	n = n + 1
      end if
      end do
	n = n - i1
      if( nz .le. 0 .and. nbadt .le. 0 ) then
	write(*,*) '** All ', new, ' data points accepted :)'
      else
	write(*,*) '** Invalid error bars:', nz, ' Invalid HJD:', nbadt
	write(*,*) '** Rejected data:', new-n, ' Ndat=', new, '=>', n
	new = n
      end if
      end if

* check HJD increasing
      if( aok ) then
	last = i1 + new - 1
	nloop = 3
      do loop=1,nloop
      if( loop .eq. 1 .or. nbad .gt. 0 ) then
	nbad = 0
	nsame = 0
      do i = i1, last
      if( i .eq. i1 ) then
	j = i1
      else if( hjd_t(i) .gt. hjd_t(j) ) then
	j = i
      else if( hjd_t(i) .eq. hjd_t(j) ) then
	nsame = nsame + 1
	write(*,*) ' HJD(', j, ' ) =', hjd_t( j )
     &		,  ' HJD(', i, ' ) =', hjd_t( i )
     &	, ' IDENTICAL TIMES   :((((  '
      else
	nbad = nbad + 1
	write(*,*) ' HJD(', j, ' ) =', hjd_t( j )
     &		,  ' HJD(', i, ' ) =', hjd_t( i )
     &	, '    :((((  ', hjd_t(i)-hjd_t(j)
      end if
      end do
* report
      if( nbad .eq. 0 .and. nsame .eq. 0 ) then
	write(*,*) '** HJD strictly increase.   :)'
      else if( nbad .eq. 0 ) then
	write(*,*) '** WARNING: HJD NOT STRICTLY INCREASING.   :('
	write(*,*) 'Identical time pairs', nsame
      else
	write(*,*) '** WARNING: HJD NOT STRICTLY INCREASING.   :('
	write(*,*) 'Identical time pairs', nsame, ' reversed', nbad

* stow for sort
	k = 0
	kk = 0
	i = 0
      do ii = i1, last
	k = k + 1
	i = i + 1
	hold_t(k) = hjd_t(i)
	plot1(k) = datmag_t(i)
	plot2(k) = sigmag_t(i)
	plot3(k) = see_t(i)
	plot4(k) = sky_t(i)
	plot5(k) = dwell_t(i)
      if( hold_t(k) .ne. hjd_t(i) ) then
	kk = kk + 1
	write(*,*) '** ', hold_t(k), ' not =', hjd_t(i), ' :((('
      end if
      end do

      if( kk .gt. 0 ) then
	call die
      end if

* sort for increasing times
	call quicksort8( k, hold_t, i_t )

* verify the sort
	kk = 0
      do i=1,k-1
      if( hold_t(i_t(i)) .gt. hold_t(i_t(i+1)) ) then
	kk = kk + 1
	write(*,*) i, hold_t(i_t(i)), ' not < ', hold_t(i_t(i+1)), ' :(('
      end if
      end do
      if( kk .gt. 0 ) then
	write(*,*) '** TIMES OUT OF ORDER', kk
	write(*,*) 'quicksort8 failed.  :((.'
	call die
      else
	write(*,*) 'quicksort8 results verified.'
      end if

      do i=1,k
	iget = i_t( i )
	iput = i1 + i - 1
	hjd_t( iput ) = hold_t( iget )
	datmag_t( iput ) = plot1( iget )
	sigmag_t( iput ) = plot2( iget )
	see_t( iput ) = plot3( iget )
	sky_t( iput ) = plot4( iget )
	dwell_t( iput ) = plot5( iget )
      end do
	write(*,*) 're-order', k, ' times.', hold_t(1), hold_t(k)
      end if
      end if
* loop just to be sure
      end do
      if( nbad .gt. 0 ) then
	write(*,*) '** ERROR - TIME ORDERING FAILED.    :((('
	call die
      end if
      end if

* report error if no data
      if( new .le. 0 .or. .not. aok ) then
	write(*,*) 'times:', new
	write(*,*) '** NO DATA FROM ', file(:len1(file))

* stow data
      else

	i2 = i1 + new - 1
	ndata = i2
	write(*,*) 'HJD:', new, i1, i2, hjd_t(i1), hjd_t(i2)
	nloc = nloc + 1
	datfile_l( nloc ) = datfile_l( ifile )
	ndat_l( nloc ) = new
	it1_l( nloc ) = i1
	it2_l( nloc ) = i2

* site
	call cleansite( file, event,
     &		icon, colour, site, glat, glon, elev, diam )

* identify alias
	call eventalias( event, alias )

	site_l( nloc ) = site
	glat_l( nloc ) = glat
	glon_l( nloc ) = glon
	elev_l( nloc ) = elev
	diam_l( nloc ) = diam
	icon_l( nloc ) = icon
	colour_l( nloc ) = colour

* rebin MOA and OGLE data
      if( .false. ) then
      if(     site(1:len1(site)) .eq. 'MOA'
     &	 .or. site(1:len1(site)) .eq. 'OGLE'
     &		) then
	write(*,*) site(:len1(site)), ' data rebinning here!'
	binday = 7.
	binyear = 0.
	binte = 0.
	call lcrebin_l( nloc )
      end if
      end if

* automatic error bar scaling	
	scalerb_l( nloc ) = .true.
	if( nloc .gt. 1 ) scalerb_l( nloc ) = .false.

* tag data
      do i = i1, i2
	loc_t(i) = nloc
	seemag_t(i) = 0.
	seefac_t(i) = 1.
      end do

* mag stats
	call mnmx( new, datmag_t( i1 ), datlo, dathi )
	call avgrms( new, datmag_t( i1 ), datavg, datrms )
	datmed = xmedian( new, datmag_t( i1 ) )
	write(*,*) 'MAG lo', datlo, ' hi', dathi
     &	, ' med', datmed, ' avg', datavg, ' rms', datrms 

* sig stats
	call mnmx( new, sigmag_t( i1 ), siglo, sighi )
	call avgrms( new, sigmag_t( i1 ), sigavg, sigrms )
	sigmed = xmedian( new, sigmag_t( i1 ) )
	write(*,*) 'SIG lo', siglo, ' hi', sighi
     &	, ' med', sigmed, ' avg', sigavg, ' rms', sigrms 

* Trap data points with zero error bars
* Note this should not occur, as we have clipped invalid data above
      if( siglo .le. 0. ) then
	nz = 0
      do i=i1,i2
	sig = sigmag_t(i)
      if( sig .eq. 0. ) then
	nz = nz + 1
	write(*,*) '** ERROR: Vanishing error bar :((((.'
	write(*,*) i, ' hjd', t_t(i), ' mag', datmag_t(i), ' +-', sig
	sigmag_t(i) = -1.
      end if
      end do
      if( nz .gt. 0 ) then
	write(*,*) '** ', site(:len1(site)),
     &		' data with zero error bars:', nz
	n = i1
      do i=i1,i2
	sig = sigmag_t(i)
      if( sig .gt. 0. ) then
	hjd_t(n) = hjd_t(i)
	datmag_t(n) = datmag_t(i)
	sigmag_t(n) = sigmag_t(i)
	see_t(n) = see_t(i)
	sky_t(n) = sky_t(i)
	dwell_t(n) = dwell_t(i)
	n = n + 1
      end if
      end do
	i2 = n-1
	n = i2-i1+1
	write(*,*) '** Ndat=', new, '=>', n, ' Clipping', new-n
	new = n
	ndat_l( nloc ) = new
	it2_l( nloc ) = i2
      end if
      end if

* default source and blend flux
	fs_l( nloc ) = toflx( datavg )
	fb_l( nloc ) = 0.
      if( nloc .eq. 1 ) then
	smag0 = datavg
	fs_l( nloc ) = 1.
      end if
	call subsidiaries
	erbscl_l( nloc ) = 1.

* dwell stats
	call mnmx( new, dwell_t( i1 ), dlo, dhi )
	call avgrms( new, dwell_t( i1 ), avg, rms )
	xmed = xmedian( new, dwell_t( i1 ) )
	write(*,*) 'DWELL lo', dlo, ' hi', dhi
     &	, ' med', xmed, ' avg', avg, ' rms', rms 

* sky stats
      do i = i1, i2
      if( dwell_t( i ) .gt. 0. ) then
	sky_t( i ) = sky_t( i ) / dwell_t( i )
      end if
      end do
	call mnmx( new, sky_t( i1 ), skylo, skyhi )
	call avgrms( new, sky_t( i1 ), avg, rms )
	xmed = xmedian( new, sky_t( i1 ) )
	skyavg_l( nloc ) = avg
	skyrms_l( nloc ) = rms
	skymed_l( nloc ) = xmed
	skyfac_l( nloc ) = 0.
	write(*,*) 'SKY lo', skylo, ' hi', skyhi
     &	, ' med', xmed, ' avg', avg, ' rms', rms 

* seeing stats
	call mnmx( new, see_t( i1 ), seelo, seehi )
	call avgrms( new, see_t( i1 ), avg, rms )
	xmed = xmedian( new, see_t( i1 ) )
	seeavg_l( nloc ) = avg
	seerms_l( nloc ) = rms
	seemed_l( nloc ) = xmed
	seefac_l( nloc ) = 0.
	write(*,*) 'SEE lo', seelo, ' hi', seehi
     &	, ' med', xmed, ' avg', avg, ' rms', rms 

      end if

* next file
      end do
	write(*,*) '------------------------------------------'
	write(*,*) 'sites', nloc, ' total data points:', ndata

      if( ndata .le. 0 ) then
	write(*,*) '** WARNING -- No data.  :((('
      else

* summarise sites
      if( nloc .gt. 0 ) then
      do l=1,nloc
	site = site_l(l)
	write(*,*) 'site', l, ' Ndat', ndat_l(l), ' ', site(:len1(site))
      end do
      end if
c	call showsites

* time array
	call timearray
* clip array
      do i=1,ndata
	clip_t(i) = 1.
      end do

* flux data from magnitudes
	call dat_mag_to_flx

* rebin data before guesslens
C	call rebindata
c      do l=1, nloc
c	call lcrebin_l( l )
c      end do

* guess lens parameters
	call guesslens

* revise time array
	call timearray

* rebin data after guesslens
C	call rebindata

* evaluate chi2
	title = ' '
	call title_chi2( title ) 
	call nogreek( title )
	call noupdn( title )
	write(*,*) '** title_chi2( ', title(:len1(title)), ' )'

* revise default times
	tbeg = -5.
	tend = 0.

	write(*,*) '------------------------------------------'
	write(*,*) 'total data points:', ndata, ' sites:', nloc
c	call showsites

      end if

	return
	end
