*--------------------
	subroutine newpredat
* compute predicted data and fudged  error bars
* 2003 Jul Keith Horne @ St-Andrews
* 2003 Dec KDH @ St-And -- toflx
* 2008 Jul KDH @ StA - erbmag(i,pmag) -> erbflx(i,pflx)
* 2008 Jul KDH @ StA - use setfsfb_l
* 2009 Jul KDH @ StA - preamp(t)->preamp(hjd)
	include 'plens.inc'
c	call bugreport( 'top of newpredat' )
      do i = 1, ndata
* time
	hjd = hjd_t( i )
	t = hjd - mjd0
* location
	l = loc_t( i )
* source and background fluxes
	call setfsfb_l( l )
* magnification
	a = preamp( hjd )
* predicted flux
	pflx = fb + fs * a
* original flux error bar
c	eflx = sigflx_t( i )
* fudged flux error bar
	eflx = erbflx( i, pflx )

* predicted magnitude
	pmag = 47.
	alo = 0.999
* trap invalid magnification
      if( a .le. alo ) then
	write(*,*) '** ERROR in newpredat.  pflx=', pflx, ' A', a
	write(*,*) '** t(', i, ' )=', t, ' loc', l, ' fs', fs, ' fb', fb
	write(*,*) '** MAGNIFICATION A=', a, ' MUST BE >', alo
	call die
* trap negative predicted flux
      else if( pflx .le. 0. ) then
C	write(*,*) '** WARNING: INVALID FLUX pflx=', pflx, ' A', a
C	write(*,*) '** t(', i, ' )=', t, ' loc', l, ' fs', fs, ' fb', fb
      else
      if( pflx .le. 0. ) then
	write(*,*) '** ERROR newpredat. pflx=', pflx, '=', fb, ' +', fs, ' *', a
      end if
	pmag = min( pmag, tomag( pflx ) )
      end if

* original mag error bar
c	emag = sigmag_t( i )
* fudged mag error bar
	emag = erbmag( i, pmag )

* stow
	a_t( i ) = a
	preflx_t( i ) = pflx
	erbflx_t( i ) = eflx
	premag_t( i ) = pmag
	erbmag_t( i ) = emag
      end do
* restore
	call setfsfb_l( 1 )
c	call bugreport( 'bot of newpredat' )

	return
	end
