
*------------------------------
	subroutine oplot( aorbit )
* plot orbit map
* 1998 Sep Keith Horne @ St-Andrews
	include 'plens.inc'
	write(*,*) 'oplot ****************', aorbit
* window
	xmx = 3.
	xmn = - xmx
	ymx = max( uplus( 1.1 ), uplus( y0 + 0.3  ) )
	ymn = - 1.1
	write(*,*) xmn, xmx, ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 1, 0 )
* grid
* SHOULD USE SAME GRID AS CHI^2 MAPS
	call xcalc
	call lcalc( ndata, x_t, y0 )
	repl = sqrt( qpl )
	x1 = xmn
	x2 = xmx
	y1 = ymn
	y2 = ymx
	split = 3.
	nx = nint( split * abs( x2 - x1 ) / repl )
	ny = nint( split * abs( y2 - y1 ) / repl )
	nx = min( nx, max1d )
	ny = min( ny, max1d )
	write(*,*) 'nx,ny:', nx, ny

* projected orbit
      do i=1,nx
	part = float(i-1)/max(1,nx-1)
	x_x(i) = x1 + part * ( x2 - x1 )
      end do
      do i=1,ny
	part = float(i-1)/max(1,ny-1)
	y_y(i) = y1 + part * ( y2 - y1 )
      end do
	call ranorb( nx, ny, x_x, y_y, o_xy, aorbit )

* transform
	tr(6) = (y_y(ny) - y_y(1) ) / max(1,ny-1)
	tr(5) = 0.
	tr(4) = y_y(1) - tr(6)
	tr(3) = 0.
	tr(2) = (x_x(nx) - x_x(1) ) / max(1,nx-1)
	tr(1) = x_x(1) - tr(2)
* greyscale
	call mnmx( nx*ny, o_xy, bg, fg )
	bg = 0.

	call pgsci(1)
	call pggray( o_xy, nx,ny, 1,nx, 1,ny, fg, bg, tr )
	call pgsci( kolor_window )
	call pgwedg('r', 0.2, 3., fg, bg, ' ' )

	call pgsci( kolor_window )
	call pgbox( 'bcst', 0., 0, 'bcst', 0., 0 )
	call pgpoint( 1, 0., 0., 2 )

* labels
	xlabel = 'x/R\dE\u'
	ylabel = 'y/R\dE\u'
	title = 'Projected Orbit'
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )
c	call legend
* Einstein ring
	call pgsci( kolor_window )
	call ering( 'XY' )
* planet
	call pgsci( 3 )
	call planet( 'XY' )
* trajctories
	call pgsci( kolor_model )
	call impaths( 4, 4 )
* images
c	call pgsci( kolor_model )
c	call marksites( 0 )
c	call marksites( -1 )
	return
	end
