*------------------------------
	subroutine pgxys( x, y, sp, sm )
* plot multi-site data points with special symbols and colours
* error bars in y
* 2010 Jul Keith Horne @ St-Andrews
	real*4 x(*), y(*), sp(*), sm(*)
	include 'plens.inc'
	call pgxys1( x, y, sp, sm, 0 )
	return
	end
*------------------------------
	subroutine pgxsy( x, y, sp, sm )
* plot multi-site data points with special symbols and colours
* error bars in x
* 2010 Jul Keith Horne @ St-Andrews
	real*4 x(*), y(*), sp(*), sm(*)
	include 'plens.inc'
	call pgxys1( x, y, sp, sm, 1 )
	return
	end
*------------------------------
	subroutine pgxys1( x, y, sp, sm, noty )
* plot multi-site data points with special symbols and colours
*	noty = 0 for error bars in y, otherwise error bars in x
* 2003 Jul KDH @ St-And
* 2006 Jul KDH @ St-And - use clip_t
* 2008 Jun KDH @ St-And - asymmetric error bars
* 2009 May KDH @ St-And - plot larger error bars first
* 2010 Jul KDH @ St-A - noty for errors bars in x or y
	real*4 x(*), y(*), sp(*), sm(*)
	include 'plens.inc'
	real*4 sort_l( maxloc )
	integer*4 i_l( maxloc )

	if( ndata .lt. 1 ) return

* sort sites by median magnitude error bar
      if( nloc .eq. 1 ) then
	i_l( 1 )=1
      else
      do l = 1, nloc
	i = it1_l( l )
	n = ndat_l( l )
	call medmad( n, sigmag_t(i), smed, smad )
	sort_l(l) = smed
      end do
	call quicksort( nloc, sort_l, i_l )
* report
	write(*,*) 'Sites sorted by median magnitude error bar:'
      do lr = nloc, 1, -1
	l = i_l( lr )
	i = it1_l( l )
	n = ndat_l( l )
	site = site_l( l )
	call medmad( n, datmag_t(i), dmed, dmad )
	call medmad( n, sigmag_t(i), smed, smad )
	write(*,*) lr, l, ' dat', n, ' mag med', dmed, ' mad', dmad
     &		, ' sig', smed, ' ', site(:len1(site))
      end do
      end if

* locations
      do lr = nloc, 1, -1
	l = i_l( lr )
	i = it1_l( l )
	n = ndat_l( l )
	isymb = isymb_l( l )
	k = kolor_l( l )

* special site-specific colour index
	call siteci( l, k )

	write(*,*) lr, l, n, ' ', site_l(l)(:len1(site_l(l)))

	call pgsci( k )
      if( noty .eq. 0 ) then
	call pgerrb( 2, n, x(i), y(i), sp(i), 1. )
	call pgerrb( 4, n, x(i), y(i), sm(i), 1. )
      else
	call pgerrb( 1, n, x(i), y(i), sp(i), 1. )
	call pgerrb( 3, n, x(i), y(i), sm(i), 1. )
      end if
	call pgqch( csize )
	call pgsch( 0.7 * csize )
	call pgpoint( n, x(i), y(i), isymb )

* big red X on clipped points
      do j=i,i+n-1
	clip = clip_t(j)
      if( clip .lt. 1. ) then
	call pgsch( 2. * (1.-clip) * csize )
	call pgsci( 2 )
	call pgpoint( 1, x(j), y(j), 5 )
      end if
      end do
	call pgsch( csize )
* next location
      end do
	return
	end
