*------------------------------
	subroutine pplot
* probability plot
* 1998 Aug Keith Horne @ St-Andrews
* 2002 Nov KDH @ St-And more thresholds
* 2009 May KDH @ St-A add logq and edit output filename
* 2009 May KDH @ St-A use ranorb_u instead of ranorb_xy
* 2009 May KDH @ St-A use 100, 50, 25
* 2011 Mar KDH @ LCO use filenameq

	include 'plens.inc'
	real*8 sum
	real*4 eadd( 10 )
	real*8 esum( 10 )
	write(*,*) 'pplot ****************' 
	write(*,*) 'Mass ratio q', qpl, ' DelChi2:', delchi2	

* more thresholds
	more = 1
	eadd( 1 ) = delchi2
	write(*,*) 'Detection threshold', more, eadd( more )
      do i=1,3
	if( i .eq. 1 ) add = 100.
c	if( i .eq. 2 ) add = 60.
	if( i .eq. 2 ) add = 50.
	if( i .eq. 3 ) add = 25.
      if( add .ne. eadd( 1 ) ) then
	more = more + 1
	eadd( more ) = add
	write(*,*) 'Detection threshold', more, eadd( more )
      end if
      end do

	call filenameq( file, qpl )
	call append( file, '.plog' )
	call nospace( file )
* user edit
	call inq( 'Probability output file', file, file )

* window
	xmx = 2.
	xmn = -1.
	ymx = 0.
	ymn = -4.
	write(*,*) xmn, xmx, ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, 30 )
	call pgsls(4)
	call pgbox('g', 1., 0, 'g', 1., 0 )
	call pgsls(1)
* title
	title = ' '
	call title_event( title )
	call title_q( title )
	call title_delchi2( title )

* extra thresholds
      do i=2,more
	write( number, * ) nint( eadd( i ) )
	call word1( number, l1, l2 )
	title = title(:len1(title)) // ',' // number(l1:l2)
      end do
	write(*,*) title(:len1(title))

* labels
	xlabel = 'Orbit Radius a/R\dE\u'
	ylabel = 'Prob( Detection | a )'
	call pgsci( kolor_window )
	call pglabel( xlabel, ylabel, title )
* legend
c	call legend


* image positions, etc
	call xcalc
	call lcalc( ndata, x_t, y0 )
* grid
	call gridbox( 'UA' )
* chi^2 map
	call chi2map( 'UA' )

* orbits log(a/re)
	nplt = 200
      do j=1,nplt
	part = float(j-1)/max(1,nplt-1)
	orblog(j) = xmn + part * ( xmx - xmn )
      end do

* detection thresholds
	write(*,*) 'chi2fit=', chi2fit
      do loop = 1, more
	esum( loop ) = 0.d0
	add = eadd( loop )
c	thresh = chi2fit + add
	write(*,*)
	write(*,*) 'Loop', loop, ' Threshold =', chi2fit, ' +/-', add

* orbits
      do j=1,nplt
	aorbit = 10.** orblog( j )
	call ranorb_u( nup, ulog_u, p_u, aorbit )

* detection probability
	sum = 0.d0
      do iu=1,nup
	p = p_u(iu) / nap
	i = iu - nup
      do ia = 1, nap
	i = i + nup
	test = c_ua( i ) - chi2fit
      if( abs( test ) .gt. add ) then
	sum = sum + p
      end if
      end do
      end do
* stow
	esum( loop ) = esum( loop ) + sum
	prob = sum
	floor = 10.**( min( -10., ymn-0.1 ) )
	plog = alog10( max( prob, floor ) )

* detection at a=re
	jm = max( 1, j-1 )
      if( orblog(j) .gt. 0. .and. orblog(jm) .lt. 0. ) then
	pdet1 = prob
      end if
 
* stow
      if( loop .eq. 1 ) then
	prob_a(j) = prob
	plog_a(j) = plog
	call pgsci( kolor_data )
	call pgpoint( 1, orblog( j ), plog, 1 )
      end if
	if( loop .eq. 1 ) plot1( j ) = plog
	if( loop .eq. 2 ) plot2( j ) = plog
	if( loop .eq. 3 ) plot3( j ) = plog
	if( loop .eq. 4 ) plot4( j ) = plog

* next orbit
      end do
 
* plot curves
      if( loop .eq. 1 ) then
* prob(det|a)
	call pgsci( kolor_data )
	call pgbin( nplt, orblog, plot1, .true. )

* prob(det|a) for other thresholds
      else
	call pgsls( loop )
	call pgsci( kolor_window )
	if( loop.eq.2 ) call pgline( nplt, orblog, plot2 )
	if( loop.eq.3 ) call pgline( nplt, orblog, plot3 )
	if( loop.eq.4 ) call pgline( nplt, orblog, plot4 )
      end if

* total probability
	ptotal = esum( loop ) / nplt 

* report
	write(*,*) 'Detection prob', pdet1, ' for a = R_E'
	write(*,*) 'Detection prob', ptotal
     &		, ' for', xmn, ' < log(a/Re) < ', xmx

* mark on margins of plot
      if( ptotal .gt. 10. ** ymn ) then
	yy = alog10( ptotal )
	add = 0.1 * ( xmx - xmn )
	call pgmove( xmn, yy )
	call pgdraw( xmn + add, yy )
	call pgmove( xmx - add, yy )
	call pgdraw( xmx, yy )
      end if
	call pgsls( 1 )

* write detection probability log
	add = eadd( loop )
	iunit = 22
	write( iunit,
     &	'(1x, a, i4, f10.5, f10.6, f10.6, f10.3 )')
     &	datfile(:len1(datfile)), 
     &	nint( add ), qpl, pdet1, ptotal, alog10( ptotal )

* next threshold
      end do
	write(*,*) 'Detection probability logged on unit', iunit

* dump to ascii file

	write(*,*) 'Probability output file : '
     &		, file(:len1(file) )
	reply = file
	call upcase( reply, reply )
      if( reply .eq. ' ' .or. reply .eq. 'NONE' ) then
	write(*,*) 'ASCII output skipped.'
      else
      if( more .eq. 1 ) then
	call dump1d2( file, 2, nplt, orblog, plot1 ) 
      else if( more .eq. 2 ) then
	call dump1d3( file, 3, nplt, orblog, plot1
     &		, plot2 ) 
      else if( more .eq. 3 ) then
	call dump1d4( file, 4, nplt, orblog, plot1 
     &		, plot2, plot3 ) 
      else if( more .eq. 4 ) then
	call dump1d5( file, 5, nplt, orblog, plot1 
     &		, plot2, plot3, plot4 ) 
      end if
      end if

	return
	end
*--------------------------------------------
	subroutine filenameq( file, qqq )
* construct filename labelled by datafile and -log10(q)
* 2011 Mar Keith Horne @ LCOGT
	include 'plens.inc'
* name of file for ascii output
	file = ' '
	file = datfile
	l1 = index( file, '.' )
	if( l1.gt.0 ) file = file(:l1-1)
	file = file(:len1(file))
* append mass ratio
      if( qqq .gt. 0. ) then
	call append( file, '_q' )
	qlog = alog10( qqq )
	call append_i( file, nint( -100 * qlog ) )
      end if
	call nospace( file )
	return
	end

