*--------------------
	function preamp( hjd )
* compute predicted magnification for star+planet lens
* 1998 Aug Keith Horne @ St-Andrews
* 1998 Sep KDH @ St-And -- use asp for planet perturbation
* 2002 Nov KDH @ St-And -- use smag and b0
* 2003 Dec KDH @ St-And -- adapt preamp from premag
* 2009 Jul KDH @ StA -  t0 -> hjd0
	include 'plens.inc'
* point lens
	x0 = ( hjd - hjd0 ) / te
      if( qpl.le. 0. ) then
	u0 = sqrt( y0 * y0 + x0 * x0 )
	amp = atotl( u0 )
      else
	method = 2
      if( method.eq.2 ) then
	amp = asp( x0, y0, 1, xpl, ypl, qpl )
      else
	u0 = sqrt( y0**2 + x0**2 )
	cth = x0 / u0
	sth = y0 / u0
	u1 = uplus( u0 ) 
	u2 = uminus( u0 )
	a1 = aplus( u0 )
	a2 = aminus( u0 )
* include planet
	x1 = u1 * cth
	y1 = u1 * sth
	u1p = sqrt( ( (x1-xpl)**2 + ( y1-ypl)**2 ) / qpl )
	if( abs(u1p).le.10. ) a1 = a1 * ( aplus( u1p ) + aminus( u1p ) )

	x2 = u2 * cth
	y2 = u2 * sth
	u2p = sqrt( ( (x2-xpl)**2 + ( y2-ypl)**2 ) / qpl )
	if( abs(u2p).le.10. ) a2 = a2 * ( aplus( u2p ) + aminus( u2p ) )
	amp = a1 + a2
      end if
      end if

	preamp = amp

* report error
      if( amp .lt. 0.999 ) then
	write(*,*) '** ERROR in preamp.   A=', amp, ' :(((('
	write(*,*) '** hjd', hjd, ' hjd0', hjd0, ' te', te, ' x0', x0, ' y0', y0
	if( qpl .gt. 0. ) write(*,*) '** q', qpl, ' xp,yp', xpl, ypl
	if( method .eq. 2 ) write(*,*) 'asp(', x0, y0, xpl, ypl, qpl, ' )=', amp
	call die
      end if

	return
	end
