*------------------------------------------
	function prior()
* bayesian prior (-2lnP) adds to badness-of-fit
* 2004 Jun Keith Horne @ St.And
* 2008 Jun KDH @ StA - prior on t0
* 2008 Jun KDH @ StA - remove 1/A0
* 2008 Jun KDH @ StA - prior on b0
* 2009 May KDH @ StA - sigbpos sigbneg now in plens.inc
	include 'plens.inc'
	logical verbose/.false./
	aln2pi = alog( pi + pi )
	a0 = atotl( y0 )
* prior uniform in ln( scale parameters )
	p = 1.
	p = p/te
c	p = p/a0
	sum = -2. * alog( p )

* prior( f ) gaussian
      if( siglogf .gt. 0. ) then
	eta = ( alog10( erbscl ) - avglogf ) / siglogf
	add = eta * eta + 2. * alog( siglogf ) + aln2pi
	sum = sum + add
	if( verbose ) write(*,*) '-2lnP(f=', erbscl, ')=', add
      end if

* prior( te ) gaussian
      if( siglogte .gt. 0. ) then
	eta = ( alog10( te ) - avglogte ) / siglogte
	add = eta * eta + 2. * alog( siglogte ) + aln2pi
	sum = sum + add
	if( verbose ) write(*,*) '-2lnP(tE=', te, ')=', add
      end if

* prior( a0 ) exponential
      if( sigloga0 .ne. 0. ) then
	eta = alog10( a0 ) / sigloga0
	add = 2. * ( eta + alog( sigloga0 ) )
* gaussian
c	avgloga0 = 0.
c	eta = ( alog10( a0 ) - avgloga0 ) / sigloga0
c	add = eta * eta + 2. * alog( sigloga0 ) + aln2pi
	sum = sum + add
	if( verbose ) write(*,*) '-2lnP(a0=', a0, ')=', add
      end if

* prior( t0 ) 1-sided gaussian.
c	sig = max( 0.1, min( 1., thalf( a0 ) ) ) * te 
* above 0.1 te can be too long if te is large, e.g. 600d.
	sig = te
c	fac = 1.
	fac = max( 0.001, min( 1., thalf( a0 ) ) )
c	div = 1.
c	div = 5.
	div = 2.
	sig = sig * fac / div
	test = hjd0 - mjd0
	e1 = ( test - tlast ) / sig
	e2 = ( tfirst - test ) / sig
	e = max( e1, e2 )
      if( e .gt. 0. ) then
	add = e * e
	sum = sum + add
	if( verbose ) write(*,*) '-2lnP(t0)=', add
      end if

* prior( b0 ) split gaussian against negative blend flux

      if( sigbpos .gt. 0. .and. sigbneg .gt. 0. ) then
      do l=1,nloc
	b = fb_l(l) / fs_l(l)
	eps = b - cenb
	sigb = sigbpos
	if( eps .lt. 0. ) sigb = sigbneg
	eta = eps / sigb
	add = eta * eta
	sum = sum + add
	if( verbose ) write(*,*) '-2lnP(b)=', add
     &		, 'for site(',l,')=' // site_l(l)(:len1(site_l(l)))
      end do
      end if

	prior = sum
	return
	end
