*=================================================
	subroutine ranorb( nx, ny, x, y, p_xy, a )
* map a random orbit with radius a
* Sep 1998 Keith Horne @ St-Andrews
* 2009 May KDH @ StA make silent
	real*4 x(*)
	real*4 y(*)
	real*4 p_xy(*)
	real*8 sum

c	write(*,*) 'ranorb *************', a
	dx = abs( x(nx) - x(1) ) / max(1,nx-1)
	dy = abs( y(ny) - y(1) ) / max(1,ny-1)
	dxdy = dx * dy
	dr = min( 0.5*a, sqrt( dxdy ) )
	rlo = a - dr
	rhi = a + dr
	rrlo = rlo**2
	rrhi = rhi**2
	pi = 4. * atan2( 1., 1. )
	twopi = pi + pi
	aa = a*a
	dprob = dxdy / ( twopi * aa )

	sum = 0.d0
	i = 0
      do iy=1,ny
	yy = y(iy)**2
      do ix=1,nx
	i = i + 1
	p_xy(i) = 0.
      if( abs( x(ix) ) .le. a ) then
	rr = x(ix)**2 + yy
      if( rr .lt. rrhi ) then
      if( rr.gt.rrlo ) then
	part = ( rhi - sqrt(rr) ) / ( rhi - rlo )
	p_xy(i) = dprob * sqrt( part / ( 1. - rrlo / aa ) )
      else
	p_xy(i) = dprob / sqrt( 1. - rr / aa )
      end if
	sum = sum + p_xy(i)
      end if
      end if
      end do
      end do	
c	write(*,*) 'a:', a, ' sumprob:', sum

* normalize if orbit is entirely inside map
      if( min(  abs(x(1)), abs(x(nx)),
     &		abs(y(1)), abs(y(ny)) ) .gt. a ) then
      if( sum.gt.0.d0 ) then
	factor = 1./sum
      do i=1,nx*ny
	p_xy(i) = p_xy(i) * factor
      end do
      end if
      end if
	return
	end
