
*=================================================
	subroutine ranorb_u( nu, ulog, p_u, a )
* project a randomly oriented circular orbit with radius a
* onto a grid in log10( r/re )
* 2009 May Keith Horne @ St Andrews: adapt from x-y version
	real*4 ulog(*)
	real*4 p_u(*)
	real*8 sum

c	write(*,*) 'ranorb_u *************', a
	aloga = alog10( a )
	sum = 0.d0
      do i = 1, nu
* integration limits
	im = max( i - 1, 1 )
	ip = min( i + 1, nu )
      if( i .eq. 1 .or. i .eq. nu ) then
	add = 0.5 * ( ulog(ip) - ulog(im) ) / max( 1, ip - im )
	ulogp = ulog( i ) + add
	ulogm = ulog( i ) - add
      else
	ulogm = ( ulog( im ) + ulog( i ) ) * 0.5 - aloga
	ulogp = ( ulog( ip ) + ulog( i ) ) * 0.5 - aloga
      end if
* probability in this annulus
	p = 0.
* inner edge inside orbit radius
      if( ulogm .lt. 0. ) then
	uum = 10. ** ( ulogm + ulogm )
* outer edge outside orbit radius
      if( ulogp .gt. 0. ) then
	p = dsqrt( 1.d0 - uum )
* outer edge inside orbit radius
      else
	uup = 10. ** ( ulogp + ulogp )
	p = dsqrt( 1.d0 - uum ) - dsqrt( 1.d0 - uup )
      end if
      end if
* stow
	p_u( i ) = p
	sum = sum + p
* next radius
      end do
* report
c	write(*,*) 'a:', a, ' sumprob:', sum
	return
	end
