
*-------------------------------------------------
	subroutine rebindata
* rebin lightcurve baseline
* 2009 May Keith Horne @ St.Andrews
* 2009 Jul KDH @ St-A  - t0 => hjd0
	include 'plens.inc'
	logical firstcall/.true./
      if( firstcall ) then
	binday = 7.
	binsigclip = 2.
	binte = 1.
	binyear = 0.
	firstcall = .false.
      end if

	loc1 = 1
	loc2 = nloc

* site summary
   10	write(*,*)
	write(*,*) 'BASELINE REBINNING  Sites', nloc, ' Data', ndata
      do l=1,nloc
	i1 = it1_l(l)
	i2 = it2_l(l)
	ndat = ndat_l(l)
	site = site_l(l)
* mag stats
	call avgrms( ndat, datmag_t(i1), avg, rms )
	call medmad( ndat, datmag_t(i1), xmed, xmad )
* baseline stats
	f0 = fs_l(l) + fb_l(l)
	basemag = tomag( f0 )
	n = 0
      do i=i1,i2
      if( sigmag_t( i ) .gt. 0. ) then
	x = ( hjd_t( i ) - hjd0 ) / te
      if( abs( x ) .gt. 2.) then
	n = n + 1
	plot1( n ) = datmag_t(i)
      end if
      end if
      end do
	ipct = n * 100. / ndat
      if( n .gt. 0 ) then
	call avgrms( n, plot1, baseavg, baserms )
	call medmad( n, plot1, basemed, basemad )
      end if
* report
	write(*,*) 'Site', l, ' (', i1, i2, ' )=', ndat, ' ', site(:len1(site))
	write(*,*) 'Baseline fit', basemag, ' data:', n, ' =', ipct, ' %'
	write(*,*) 'All data avg', avg, ' rms', rms, ' bias', avg - basemag
	write(*,*) '         med', xmed, ' mad', xmad, ' bias', xmed - basemag
      if( n .gt. 0 ) then
	write(*,*) 'Baseline avg', baseavg, ' rms', baserms, ' bias', baseavg - basemag
	write(*,*) '         med', basemed, ' mad', basemad, ' bias', basemed - basemag
      end if
* next site
      end do

* edit rebin parameters
   20	write(*,*) ' S ... Sites to rebin', loc1, loc2, ' of', nloc
	write(*,*) ' D ... Days/bin', binday
	write(*,*) ' C ... CLIP', binsigclip, ' sigma'
	write(*,*) ' A ... AGE >', binyear, ' yr'
	write(*,*) ' O ... Outside', binte, ' t_E =', binte*te, ' days'
	write(*,*) ' P ... Plot lightcurve'
	write(*,*) ' T ... Time range on plot', tbeg, tend
	write(*,*) ' B ... Bin <', binday
     &		, ' d. Age >', binyear
     &		, ' yr. Outside', binte, ' t_E'
	write(*,*) ' Q ... Quit'

* command node
   30	call inq( 'Rebin >', ' ', reply )
	call upcase( reply, reply )
	if( reply .eq. 'Q' ) return

      if( reply .eq. 'P' ) then
	call mplot( 'MR' )

      else if( reply .eq. 'T' ) then
	call edittimes

      else if( nloc .gt. 1 .and. reply .eq. 'S' ) then
	ival1 = loc1
	ival2 = loc2
	call inq2i( 'First and Last site to rebin', ival1, ival2 )
      if( ival1 .ge. 1 .and. ival1 .le. nloc ) then
	loc1 = ival1
	loc2 = max( ival1, min( nloc, ival2 ) )
      end if

      else if( reply .eq. 'D' ) then
	call inqr( 'Days/bin', binday, val )
	if( val .gt. 0. ) binday = val

      else if( reply .eq. 'A' ) then      
	call inqr( 'Bin data older (years) than', binyear, val )
	if( val .ge. 0. ) binyear = val

      else if( reply .eq. 'C' ) then      
	call inqr( 'Bin data up to how many sigma of the baseline', binsigclip, val )
	if( val .ge. 0. ) binsigclip = val

      else if( reply .eq. 'O' ) then
	t0 = hjd0 - mjd0
	write(*,*) 't_0', t0, ' t_E', te
	call inqr( 'Bin data outside |X| = |(t-t_0)/t_E| > ', binte, val )
	if( val .ge. 0. ) binte = val

* bin the data

      else if( reply .eq. 'B' ) then
      do l=loc1, loc2
	call lcrebin_l( l )
	call timearray
      end do
* binned fluxes to mags
	call dat_flx_to_mag

      end if

	goto 10
	end
