*------------------------------
	subroutine safe( pval, pstep )
* stow "safe" parameter values
* output:	r4 pval(*)	safe parameter values
*		r4 pstep(*)	step sizes for the safe parameters
* 1998 Sep Keith Horne @ St-Andrews
* 2002 Nov KDH @ St-And - b0
* 2002 Nov KDH @ St-And - larger psteps
* 2002 Nov KDH @ St.And - iuseam1
* 2003 May KDH @ St.And - safe y0
* 2003 Jul KDH @ St.And - x,y,q
* 2003 Jul KDH @ St.And - y0min
* 2007 Apr KDH @ St.And - fit 5 = with blending
* 2007 Apr KDH @ St.And - parameter index
* 2007 Aug KDH @ LaSilla - plpos
* 2008 Jun KDH @ StA - try reduce step sizes and use thalf rather than te
* 2009 Jul KDH @ StA - common/ safety / iuseam1, y0min, neart0
* 2009 Jul KDH @ StA - t0 -> hjd0
	real*4 pval( * )
	real*4 pstep( * )
	include 'plens.inc'
	logical firstcall/.true./
* BE CAREFUL THAT THESE ARE NOT USED ELSEWHERE INADVERTENTLY
* parameter index (0=> skip linear parameters)
	common/ kpar / km0, kb0, kt0, kte, ky0, ksig, kerb
	common/ kparp / kqp, kxp, kyp, kup, kap, ktp, kfp
	common/ safety / iuseam1, y0min, neart0
	common/ nonlinpar / nonlinpar

      if( firstcall ) then

* linear parameters
	km0 = 0
	kb0 = 0
* non-linear parameters (in order)
	kt0 = 1
	kte = 2
	ky0 = 3

	ksig = 4
	kerb = 5

	kap = 6
	kup = 7
	kqp = 8
* alternative planet position parameters
	kxp = 6
	kyp = 7
	ktp = 6
	kfp = 7
* use geometric mean of y0 and y0min
c	y0min = 1.e-4
	y0min = 1.e-5
* use log( A - 1 ) as the parameter
	iuseam1 = 1
	firstcall = .false.
      end if

* prevent zero impact parameter
c	y0 = max( y0, y0min )
c	y0 = sqrt( y0 * y0 + y0min * y0min )

* number of non-linear parameters (omit linear parameters 1 and 5)
	n = max( 0, iabs( npfit ) )
	if( npfit .ge. 1 ) n = n - 1
	if( npfit .ge. 5 ) n = n - 1
	nonlinpar = n

* tiny (steps scale with this factor)
* note, should really estimate uncertainty in pspl parameters,
* using derivatives, and let parameter steps scale with that.
	tiny = 0.02
	tiny = 0.05

* no parameters to fit
	if( npfit .le. 0 ) return
* m0
      if( km0 .gt. 0 ) then
	pval( km0 ) = smag0
	pstep( km0 ) = tiny
      end if
	if( npfit .le. 1 ) goto 10
* t0
	t0 = hjd0 - mjd0
	neart0 = nint( t0 )
	pval( kt0 ) = t0 - neart0
	th = thalf( a0 )
	pstep( kt0 ) = te * th * tiny
	if( npfit .le. 2 ) goto 10
* te
	pval( kte ) = alog10( te )
	pstep( kte ) = tiny
	if( npfit .le. 3 ) goto 10

* y0 impact parameter
c	iuseam1 = 1
	y0safe = max( abs(y0), y0min )
c	y0safe = sqrt( y0 * y0 + y0min * y0min )
      if( iuseam1 .ne. 0 ) then
	am1 = atotl( y0safe ) - 1.d0
c	pval( ky0 ) = alog10( max( am1, y0min ) )
	pval( ky0 ) = alog10( am1 )
	pstep( ky0 ) = 0.1
      else
	pval( ky0 ) = alog10( y0safe )
	pstep( ky0 ) = max( tiny, tiny * y0safe )
      end if
	if( npfit .le. 4 ) goto 10

* b0 blending
      if( kb0 .gt. 0 ) then
	pval( kb0 ) = alog10( max( b0, 1.e-2 ) )
	pstep( kb ) = tiny
      end if
	if( npfit .le. 5 ) goto 10

* sigmag0
	pval( ksig ) = alog10( max( sigmag0, 1.e-2 ) )
	pstep( ksig ) = tiny
	if( npfit .le. 6 ) goto 10

* error bar scale
	pval( kerb ) = alog10( erbscl )
	pstep( kerb ) = 3. * tiny
	if( npfit .le. 7 ) goto 10

* planet azimuth and radial position
	rpl = sqrt( abs( qpl ) )
      if( plpos .eq. 'UA' ) then
	pval( kap ) = apl
	pstep( kap ) = rpl / max( rpl, upl ) * 5. * tiny
	if( npfit .le. 8 ) goto 10
	pval( kup ) = alog( upl )
	pstep( kup ) = pstep( ka )

* planet anomaly time and radial position relative to image
      else if( plpos .eq. 'TF' ) then
	pval( ktp ) = tpl
	pstep( ktp ) = rpl * te * 5. * tiny
	if( npfit .le. 8 ) goto 10
	pval( kfp ) = alog( fpl )
	pstep( kfp ) = rpl * 5. * tiny
* planet x y
      else if( plpos .eq. 'XY' ) then
	pval( kxp ) = xpl
	pstep( kxp ) = rpl * 5. * tiny
	if( npfit .le. 8 ) goto 10
	pval( kyp ) = ypl
	pstep( kyp ) = pstep( kxp )

      end if
	if( npfit .le. 9 ) goto 10

* mass ratio
	pval( kqp ) = alog10( qpl )
	pstep( kqp ) = 10. * tiny
	if( npfit .le. 10 ) goto 10
   10	return
	end
