
*------------------------------
	subroutine seeplot
* correlate residuals with seeing
* 2003 Nov KDH @ St-And
* 2010 Apr KDH @ StA - clip to valid see range
	include 'plens.inc'
	write(*,*) 'seeplot ******', ksee, seebot, seetop
	kseesave = ksee
	if( ksee .le. 0 ) ksee = 1

* plot seeing in arcsec vs normalised 
	iarcsec = 1

* gather data
      if( iarcsec .gt. 0 ) then
	call peqp( ndata, plot1, see_t )
      else
      do i=1,ndata
	plot1( i ) = eta_see( i )
      end do
      end if
	call resids( ksee, plot2, plot3 )

* clip to valid seeing range
	nlo = 0
	nhi = 0
	ng = 0
      do i=1,ndata
	see = see_t( i )
      if( see .le. seebot ) then
	nlo = nlo + 1
	plot3( i ) = - abs( plot3( i ) )
      else if( see .ge. seetop ) then
	nhi = nhi + 1
	plot3( i ) = - abs( plot3( i ) )
      else
	ng = ng + 1
	plot4( ng ) = plot1( i ) 
	plot5( ng ) = plot2( i ) 
      end if
      end do
* report
	i = ng * 100. / ndata
	write(*,*) ng, ' =', i, ' % in valid seeing range ', seebot, seetop
      if( nhi .gt. 0 ) then
	i = nhi * 100. / ndata
	write(*,*) nhi, ' =', i, ' % above', seetop
      end if
      if( nlo .gt. 0 ) then
	i = nlo * 100. / ndata
	write(*,*) nlo, ' =', i, ' % below', seebot
      end if

* stats
	call mnmx( ng, plot4, seelo, seehi )
	call avgrms( ng, plot4, avg, rms )
	write(*,*) 'SEE mn,mx,avg,rms:', seelo, seehi, avg, rms

	call mnmx( ng, plot5, errlo, errhi )
	call avgrms( ng, plot5, avg, rms )
	write(*,*) 'ERR mn,mx,avg,rms:', errlo, errhi, avg, rms

* window
	ymn = min( 0., errlo )
	ymx = max( 0., errhi )
	add = 0.05 * ( ymx - ymn )
	ymn = ymn - add
	ymx = ymx + add
      if( ksee .eq. 3 ) then
	ymx = max( ymx, 10. )
	ymn = min( ymn, -10. )
      else if( ksee .eq. 2 ) then
	hold = ymx
	ymx = ymn
	ymn = hold
      end if

	xmn = min( 0., seelo )
	xmx = max( 0., seehi )
	add = 0.05 * ( xmx - xmn )
	xmn = xmn - add
	xmx = xmx + add

	write(*,*) 'window', xmn, xmx, ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
* fiducials
	call pgmove( 0., ymn )
	call pgdraw( 0., ymx )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )

      if( ksee .eq. 3 ) then
	call pgsls( 4 )
      do k = -2, 2
      if( k .ne. 0 ) then
	yy = float( k )
	call pgmove( xmn, yy )
	call pgdraw( xmx, yy )
      end if
      end do
	call pgsls(1)
      end if

      if( iarcsec .eq. 0. ) then
	call pgsls(4)
      do k = -2, 2
      if( k .ne. 0 ) then
	xx = float( k )
	call pgmove( xx, ymn )
	call pgdraw( xx, ymx )
      end if
      end do
	call pgsls(1)
      end if

* labels
	xlabel = '( seeing - median ) / sigma'
	if( iarcsec .gt. 0 ) xlabel = 'seeing (arcsec)'
	if( ksee .eq. 1 ) ylabel = 'flux residual'
	if( ksee .eq. 2 ) ylabel = 'mag residual'
	if( ksee .eq. 3 ) ylabel = '( data - model ) / sigma'
	title = ' '
	call title_event( title )
c	title = datfile(:len1(datfile) )
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )
	call legend

* data
	call pgxys( plot1, plot2, plot3, plot3 )

* seeing correlations
	call seecor
      do l = 1, nloc
	call pgsci( kolor_l( l ) )
	call pgsls( l )
	avg = 0.
	if( iarcsec .gt. 0 ) avg = seemed_l( l )
	fac = seefac_l( l )
	write(*,*) l, ' see', avg, fac
	call pgmove( xmn, fac * ( xmn - avg ) )
	call pgdraw( xmx, fac * ( xmx - avg ) )

* best-fit line
	i1 = it1_l( l )
	n = ndat_l( l )
	call pgsls( 2 )
	call pgfitline( n, plot1(i1), plot2(i1), plot3(i1), xmn, xmx )
	call pgsls( 1 )
      end do

	call pgsls( 1 )

	ksee = kseesave
	return
	end
