
*-----------------------------
	subroutine setplanet( option, a1, a2 )
* set the planet
* options	XY  a1=x a2=y
*		UA  a1=log(u) a2=a(degrees)
*		TF  a1=t a2=f
*		FQ  a1=f a2=log(q)
* 2007 Aug Keith Horne @ LaSilla
* 2009 Jul KDH @ St-A  - t0 => hjd0
	character*(*) option
	include 'plens.inc'
	call upcase( option, opt )
* xy
      if( opt .eq. 'XY' ) then
	call setplxy( a1, a2 )
* ua
      else if( opt .eq. 'UA' ) then
	u = 10. ** a1
	arad = deg2rad( a2 )
	call setplua( u, arad )
* tf
      else if( opt .eq. 'TF' ) then
	call setpltf( a1, a2 )
* fq
      else if( opt .eq. 'FQ' ) then
	f = a1
	qlog = a2
	q = 10. ** qlog
	repl = sqrt( q )

* full grid search over angle ( will be slow )
c	deg1 = -90.
c	deg2 = 90.
* limit search to angles near planet fit from grid search
	x = xplfit
	y = yplfit
	u = sqrt( x * x + y * y )
      if( u .gt. 0.05 .and. u .lt. 20. ) then
	up = uplus( u )
	um = uminus( u )
	ap = aplus( u )
	am = aminus( u )
	sig = 0.01
	dza = q / sig
	dzap = ( ap + ap - 1. ) * dza
	dzam = ( am + am ) * dza
	dap = sqrt( dzap ) / abs( up )
	dam = sqrt( dzap ) / abs( um )
	da = max( dap, dam, repl )
	add = min( 180., rad2deg( da ) )
	call xy2t( x, y, t )
	call t2deg( t, deg )
	deg1 = deg - add
	deg2 = deg + add
      else
	up = uplus( y0 )
	extra = 5.
	add = extra * te
	t0 = hjd0 - mjd0
	call t2deg( t0 + add, deg2 )
	call t2deg( t0 - add, deg1 )
      end if
	drad = repl / up
	ddeg = rad2deg( drad )
	ndeg = 1 + nint( abs( deg2 - deg1 ) / ddeg )
	ddeg = abs( deg2 - deg1 ) / ndeg
      do i = 1, ndeg
	p = ( i - 0.5 ) / max( 1, ndeg )
	deg = deg1 * ( 1. - p ) + deg2 * p
	a = deg2rad( deg )
	call setplaf( a, f )
	call chi2calc( chi2, nd )
* stow
	c_a( i ) = chi2
* best angle
	if( i .eq. 1 ) best = chi2
      if( chi2 .le. best ) then
	ibest = i
	abest = a
	best = chi2
c	write(*,*) 'q', q, ' f', f, ' alp', i, rad2deg(a), ' chi2', chi2
      end if
* next angle
      end do

* parabolic fit near best point
* COULD DO THIS INSIDE LOOP FOR ALL LOCAL MAXIMA
	im = max( 1, ibest - 1 )
	i0 = im + 1
	ip = min( ndeg, i0 + 1 )
	cm = c_a( im )
	c0 = c_a( i0 )
	cp = c_a( ip )
	slope = ( cp - cm ) / 2.
	curv = cp + cm - c0 - c0
	add = 0.
	if( curv .gt. 0. ) add = - slope / curv
	add = max( -1., min( 1., add ) )
	abest = abest + add * deg2rad( ddeg )
* move planet to best position
	call setplaf( abest, f )
	qpl = q
	call chi2calc( chi2, nd )
* report
	degbest = rad2deg( abest )
	write(*,*) 'logQ', qlog, ' F', f
     &		, ' alp (', nint(deg2), ' -', nint(deg1), ' ) /', ndeg
     &		, ' best', i0+add, degbest, ' chi2min =', best

      else
	write(*,*) '** INVALID OPTION setplanet( ', opt, ' )'
	call die
      end if
	return
	end
