
*------------------------------
	subroutine skyplot
* correlate residuals with sky
* 2003 Nov KDH @ St-And
	include 'plens.inc'
	write(*,*) 'skyplot ****************', ksky

* gather data
	call peqp( ndata, plot1, sky_t )
	call resids( ksky, plot2, plot3 )
* report
	call mnmx( ndata, plot2, errlo, errhi )
	call avgrms( ndata, plot2, avg, rms )
	write(*,*) 'ERR mn,mx,avg,rms:', errlo, errhi, avg, rms

	call mnmx( ndata, plot1, skylo, skyhi )
	call avgrms( ndata, plot1, avg, rms )
	write(*,*) 'SKY mn,mx,avg,rms:', skylo, skyhi, avg, rms

* window
	ymn = errlo
	ymx = errhi
	add = 0.05 * ( ymx - ymn )
	ymn = ymn - add
	ymx = ymx + add
      if( ksky .eq. 3 ) then
	ymx = max( ymx, 10. )
	ymn = min( ymn, -10. )
      else if( ksky .eq. 2 ) then
	hold = ymx
	ymx = ymn
	ymn = hold
      end if

	xmn = skylo
	xmx = skyhi
	add = 0.05 * ( xmx - xmn )
	xmn = xmn - add
	xmx = xmx + add

	write(*,*) 'window', xmn, xmx, ymn, ymx
	call pgsci( kolor_window )
	call pgenv( xmn, xmx, ymn, ymx, 0, 0 )
	call pgmove( xmn, 0. )
	call pgdraw( xmx, 0. )

      if( ksky .eq. 3 ) then
	call pgsls(4)
      do k = -2, 2
	yy = float(k)
	call pgmove( xmn, yy )
	call pgdraw( xmx, yy )
      end do
	call pgsls(1)
      end if

* labels
	xlabel = 'sky (ADU/s)'
	ylabel = 'flux residual'
	if( ksky .eq. 1 ) ylabel = 'flux residual'
	if( ksky .eq. 2 ) ylabel = 'mag residual'
	if( ksky .eq. 3 ) ylabel = '( data - model ) / sigma'
	title = ' '
	call title_event( title )
c	title = datfile(:len1(datfile) )
	call pgsci( kolor_label )
	call pglabel( xlabel, ylabel, title )
	call legend

* data
	call pgxys( plot1, plot2, plot3, plot3 )

* sky correlations
	call skycor
      do l = 1, nloc
	call pgsci( kolor_l( l ) )
	call pgsls( l )
	avg = skymed_l( l )
	fac = skyfac_l( l )
	write(*,*) l, ' sky', avg, fac
	call pgmove( xmn, fac * ( xmn - avg ) )
	call pgdraw( xmx, fac * ( xmx - avg ) )

* best-fit line
	i1 = it1_l( l )
	n = ndat_l( l )
	call pgsls( 2 )
	call pgfitline( n, plot1(i1), plot2(i1), plot3(i1), xmn, xmx )
	call pgsls( 1 )
      end do

	return
	end
