
*------------------------------
	subroutine stowall
* stow all parameters for later use
* 2003 Jul KDH @ St.And
* 2004 Jun KDH @ St.And -- stack
* 2005 May KDH @ St.And -- restore from slot 1 if is=0
* 2007 Apr KDH @ St.And - fit 5 = with blending
* 2009 Jul KDH @ St.A - stowhjd0_i
* 2010 Apr KDH @ StA - setplpos -> setplxy
	include 'plens.inc'
	parameter ( maxstack = 1000 )
	real*4 stow_i( maxparm, maxstack )
	real*8 stowhjd0_i( maxstack )
	data is/0/

      if( is .ge. maxstack ) then
	write(*,*) '** ERROR stowall stack overflow.', is, maxstack
	call die
      else
	is = is + 1
      if( is .ge. maxstack ) then
	write(*,*) '** WARNING stowall stack is full.', is, maxstack
      end if
      end if

* number of parameters always stowed
	nalways = 9
* number of parameters per location
	nperloc = 5
	nstow = nalways + nperloc * nloc

* report
c	write(*,*) '** stowall to stack', is
c	write(*,*) '**', nalways, ' +', nperloc, ' x', nloc, '  =', nstow
c	write(*,*) ' stowall q', qpl, ' x', xpl, ' y', ypl

      if( nstow .gt. maxparm ) then
	write(*,*) '** ERROR maxparm', maxparm, ' exceeded.'
	write(*,*) '**', nalways, ' +', nperloc, ' x', nloc, '  =', nstow
     &		, ' > maxparm=', maxparm
	call die
      end if

	stowhjd0_i( is ) = hjd0
	stow_i( 1, is ) = t0
	stow_i( 2, is ) = te
	stow_i( 3, is ) = y0
	stow_i( 4, is ) = b0
	stow_i( 5, is ) = sigmag0
	stow_i( 6, is ) = erbscl
	stow_i( 7, is ) = xpl
	stow_i( 8, is ) = ypl
	stow_i( 9, is ) = qpl
	last = 9
      do i=1,nloc
	stow_i( last + 1, is ) = fs_l( i )
	stow_i( last + 2, is ) = fb_l( i )
	stow_i( last + 3, is ) = sigmag0_l( i )
	stow_i( last + 4, is ) = erbscl_l( i )
	stow_i( last + 5, is ) = syserr_l( i )
	last = last + 5
      end do
* report
      if( .false. ) then
	write(*,*) 'Parameters:', last, ' of', maxparm
     &		, ' stowed at slot', is, ' of', maxstack
	write(*,*) 'b0', b0, ' sig0', sigmag0, ' erbscl', erbscl
      end if
* oops
      if( last .ne. nstow ) then
	write(*,*) '** ERROR should have stowed'
	write(*,*) '**', nalways, ' +', nperloc, ' x', nloc, ' =', nstow
	call die
      end if

	return

* restore saved parameters
	entry restoreall
	is = max( 1, is )
c	write(*,*) '** restoreall from stack', is
c	write(*,*) '**', nalways, ' +', nperloc, ' x', nloc, '  =', nstow

	hjd0 = stowhjd0_i( is )
	t0 = stow_i( 1, is )
	te = stow_i( 2, is )
	y0 = stow_i( 3, is )
	b0 = stow_i( 4, is )
	sigmag0 = stow_i( 5, is )
	erbscl = stow_i( 6, is )
	xpl = stow_i( 7, is )
	ypl = stow_i( 8, is )
	qpl = stow_i( 9, is )
c	write(*,*) 'restoreall q', qpl, ' x', xpl, ' y', ypl
	last = 9
      do i=1,nloc
	fs_l( i ) = stow_i( last + 1, is )
	fb_l( i ) = stow_i( last + 2, is )
	sigmag0_l( i ) = stow_i( last + 3, is )
	erbscl_l( i ) = stow_i( last + 4, is )
	syserr_l( i ) = stow_i( last + 5, is )
	last = last + 5
      end do

* subsidiaries
	call subsidiaries

c	plpos = 'XY'
c	call setplpos

	call setplxy( xpl, ypl )

* report
      if( .false. ) then
	write(*,*) 'Parameters:', last, ' of', maxparm
     &	,' restored from slot', is, ' of', maxstack
	write(*,*) 'b0', b0, ' sig0', sigmag0, ' erbscl', erbscl
      end if
	is = is - 1
      if( is .lt. 0 ) then
	write(*,*) '*** ERROR stack underflow in stowall.'
	call die
      end if

c	write(*,*) 'restoreall q', qpl, ' x', xpl, ' y', ypl

	return
	end
