*--------------------------------------------
	subroutine stowgrid( option )
* stow the chi^2 map for later recovery
* 2007 Aug Keith Horne @ LaSilla
* 2011 Mar KDH @ LCOGT stow qmap, mapfit, maptweak mapdof, chi2ref, cpumap

	character*(*) option
	include 'plens.inc'
	data nstow/0/
	call upcase( option, opt )
	write(*,*) 'stowgrid( ' // opt(:len1(opt)) // ' ) ***********'
	call showgrid( opt )

	n_12 = n_1 * n_2
* xy
      if( opt .eq. 'XY' ) then
	nxp = n_1
	nyp = n_2
	call peqp( n_1, xp_x, par_1 )
	call peqp( n_2, yp_y, par_2 )
	call peqp( n_12, c_xy, chi2_12 )
	call stowcxy

	qxy = qmap
	nfitxy = mapfit
	ntweakxy = maptweak
	ndofxy = mapdof
	chi2xy = chi2ref
	cpuxy = cpumap
	needcxy = .false.
* tf
      else if( opt .eq. 'TF' ) then
	ntp = n_1
	nfp = n_2
	call peqp( n_1, tp_t, par_1 )
	call peqp( n_2, fp_f, par_2 )
	call peqp( n_12, c_tf, chi2_12 )
	call stowctf

	qtf = qmap
	nfittf = mapfit
	ntweaktf = maptweak
	ndoftf = mapdof
	chi2tf = chi2ref
	cputf = cpumap
	needctf = .false.
* fq
      else if( opt .eq. 'FQ' ) then
	nf = n_1
	nqp = n_2
	call peqp( n_1, f_f, par_1 )
	call peqp( n_2, qlog_q, par_2 )
	call peqp( n_12, c_fq, chi2_12 )
	call stowcfq

	nfitfq = mapfit
	ntweakfq = maptweak
	ndoffq = mapdof
	chi2fq = chi2ref
	cpufq = cpumap
	needcfq = .false.
* ua
      else if( opt .eq. 'UA' ) then
	nup = n_1
	nap = n_2
	call peqp( n_1, ulog_u, par_1 )
	call peqp( n_2, ap_a, par_2 )
	call peqp( n_12, c_ua, chi2_12 )
	call stowcua

	qua = qmap
	nfitua = mapfit
	ntweakua = maptweak
	ndofua = mapdof
	chi2ua = chi2ref
	cpuua = cpumap

	needcua = .false.
      else
	write(*,*) '** invalid stowgrid(', opt, ') ??? :-('
	return
      end if
	nstow = nstow + 1
	return

* fetch old chi2  map
	entry fetchgrid( option )
	call upcase( option, opt )
	write(*,*) 'fetchgrid( ' // opt(:len1(opt)) // ' ) ***********'

* xy
      if( opt .eq. 'XY' ) then
	n_1 = nxp
	n_2 = nyp
	n_12 = n_1 * n_2
	call peqp( n_1, par_1, xp_x )
	call peqp( n_2, par_2, yp_y )
	call peqp( n_12, chi2_12, c_xy )

	qmap = qxy
	mapfit = nfitxy
	maptweak = ntweakxy
	mapdof = ndofxy
	chi2ref = chi2xy
	cpumap = cpuxy

* tf
      else if( opt .eq. 'TF' ) then
	n_1 = ntp
	n_2 = nfp
	n_12 = n_1 * n_2
	call peqp( n_1, par_1, tp_t )
	call peqp( n_2, par_2, fp_f )
	call peqp( n_12, chi2_12, c_tf )

	qmap = qtf
	mapfit = nfittf
	maptweak = ntweaktf
	mapdof = ndoftf
	chi2ref = chi2tf
	cpumap = cputf

* fq
      else if( opt .eq. 'FQ' ) then
	n_1 = nf
	n_2 = nqp
	n_12 = n_1 * n_2
	call peqp( n_1, par_1, f_f )
	call peqp( n_2, par_2, qlog_q )
	call peqp( n_12, chi2_12, c_fq )

	mapfit = nfitfq
	maptweak = ntweakfq
	mapdof = ndoffq
	chi2ref = chi2fq
	cpumap = cpufq

* ua
      else if( opt .eq. 'UA' ) then
	n_1 = nup
	n_2 = nap
	n_12 = n_1 * n_2
	call peqp( n_1, par_1, ulog_u )
	call peqp( n_2, par_2, ap_a )
	call peqp( n_12, chi2_12, c_ua )

	qmap = qua
	mapfit = nfitua
	maptweak = ntweakua
	mapdof = ndofua
	chi2ref = chi2ua
	cpumap = cpuua

      else
	write(*,*) '** invalid fetchgrid(', opt, ') ??? :-('
      end if
	call showgrid( opt )
	return
	end
