*------------------------------
	subroutine timeaxis( xmn, xmx, timelabel )
* set time limits and label for time axis
* 2005 Aug Keith Horne @ St-Andrews
* 2006 Feb KDH @ St-And - evaluate logical hjdaxis
* 2006 Mar KDH @ St-And - include tnow
* 2008 Jun KDH @ St-And - default t0 +/- 3*min(te,thalf)
* 2009 Jul KDH @ St-And - try to include data when peak is off end
* 2009 Jul KDH @ St-A  - t0 => hjd0
	character*(*) timelabel
	include 'plens.inc'
	a0 = atotl( y0 )
	th = thalf( a0 )
	t0 = hjd0 - mjd0
	write(*,*) 'timeaxis ****** a0', a0,' th=', th, ' x', te, ' =', th*te
* label
	hjdaxis = .false.
	timelabel = '( t - t\d0\u ) / t\dE\u'
      if( mjd0 .ne. 0 .or. te .ne. 1. ) then
	hjdaxis = .true.
	timelabel = 'HJD -'
	call append_i( timelabel, mjd0 )
      end if

* default time range
	factor = th ** 0.75
	twin = max( 1., te * factor )
	xmx = t0 + twin * 3.
	xmn = t0 - twin * 3.

* expand to cover data
      if( ndata .gt. 0 ) then
	call mnmx( ndata, t_t, tdmn, tdmx )
	add = 1.
	tmn = tdmn - add
	tmx = tdmx + add
	xmn = min( xmn, tmn )
	xmx = max( xmx, tmx )
* round to multiple of 1 day
	round = 1.
	call roundup( xmx, round )
	call rounddown( xmn, round )
* data cover rise
	if( tmx .lt. t0 ) xmx = t0 + twin
	if( tmx .lt. t0 + twin ) xmx = t0 + twin * 1.5
* data cover tail
	if( tmn .gt. t0 ) xmx = t0 - twin
	if( tmn .gt. t0 - twin ) xmx = t0 - twin * 1.5
      end if

	write(*,*) 'xmx', xmn, ' xmx', xmx
* force xmn
      if( tbeg .ne. tend ) then
      if( tbeg .gt. mjd0 ) then
	xmn = tbeg - mjd0
      else if( tbeg .gt. 0. ) then
	xmn = tbeg
      else if( tbeg .lt. 0. ) then
	xmn = min( tdmx, t0) + twin * tbeg
      end if
	write(*,*) 'xmn ->', xmn
      end if

* force xmx
      if( tbeg .lt. tend ) then
      if( tbeg .gt. mjd0 ) then
	xmx = tend - mjd0
      else if( tbeg .gt. 0. ) then
	xmx = tend
      else if( tbeg .lt. 0. ) then
	if( tend .gt. 0. ) xmx = max(tdmn,t0) + twin * tend
      end if
	write(*,*) 'xmx ->', xmx
      end if

* include tnow
      if( xmx .ne. xmn ) then
	call marknow( 0., 0. )
	xx = tnow
	if( .not. hjdaxis ) xx = xnow
	part = ( xx - xmn ) / ( xmx - xmn )
      if( part .lt. 1.2 ) then
	xmx = max( xmx, xx + 0.03 * ( xmx - xmn ) )
	write(*,*) 'xmx ->', xmx, ' to include tnow', tnow
      end if
      end if

* expand to include data, if all data omitted
      if( ndata .gt. 0 ) then
	add = max( 1., thalf(a0) * te )
	fac = 0.5
      if( xmn .gt. tmx ) then
	xmn = tmx - add - abs(t0 - tmx) * fac
	xmn = max( xmn, tmn ) 
	xmx = t0 + add
	write(*,*) 'Shift to', xmn, xmx, ' to include data', tmn, tmx
      end if
      if( xmx .lt. tmn ) then
	xmx = tmn + add + abs(t0 - tmn) * fac
	xmx = min(  xmx, tmx ) 
	xmn = t0 - add
	write(*,*) 'Shift to', xmn, xmx, ' to include data', tmn, tmx
      end if

* include the peak
      if( .false. ) then
      if( tmx .lt. t0 ) then
	xmx = t0 + twin
      end if
      if( tmn .gt. t0 ) then
	xmn = t0 - twin
      end if
      end if

      end if

* final rounding
	round = 0.1
	call roundup( xmx, round )
	call rounddown( xmn, round )
	return
	end
