
*--------------------
	subroutine writeout( reply )
* Write fit parameters ( or maps ) to file
* Aug 2002 Colin Snodgrass
* Jun 2004 KDH @ St.And -- added to KDH version
* Mar 2011 KDH @ LCO - write chi^2 maps
* Mar 2011 KDH @ LCO - writeparams and writemap subroutines

	include 'plens.inc'
	character*(maxchar) outfile
	character*(maxchar) mapfile

	write(*,*) '... writeout ...', reply(:len1(reply))

* write parameter file
      if( len1( reply ) .eq. 1 ) then
	outfile = parfile
	write(*,*) 'Data file ', datfile(:len1(datfile))
	if( outfile .eq. ' ' ) outfile = 'parameters.dat'
	call inq( 'Output parameter file', outfile, outfile )
	call writeparams( outfile )
	return
      end if

* writeout maps
	opt = reply(2:len1(reply))
	write(*,*) 'Write Map Option ', opt(:len1(opt) )
* Chi2(x,y)
      if( opt(1:1) .eq. 'X' .or. opt(1:1) .eq. 'C' ) then
	call writemap( 'XY' )
* Chi2(lnu,alp)
      else if( opt(1:1) .eq. 'L' .or. opt(1:2) .eq. 'UA' ) then
	call writemap( 'UA' )
* Chi2(t,f)
      else if( opt(1:1) .eq. 'T' ) then
	call writemap( 'TF' )
* Chi2(f,q)
      else if( opt(1:1) .eq. 'K' .or. opt(1:2) .eq. 'FQ' ) then
	call writemap( 'FQ' )
* Chi2(u,q)
      else if( opt(1:1) .eq. 'U' .or. opt(1:2) .eq. 'UQ' ) then
	call writemap( 'UQ' )
* not recognised
      else
	write(*,*) '** Write Map Option not recognised.  Must be one of:'
	write(*,*) ' WXY ... Chi^2(x,y)'
	write(*,*) ' WUA ... Chi^2(lnu,alp)'
	write(*,*) ' WTF ... Chi^2(t,f)'
	write(*,*) ' WFQ ... Chi^2(f,q) NOT YET IMPLEMENTED'
	write(*,*) ' WUQ ... Chi^2(u,q) NOT YET IMPLEMENTED'
	write(*,*) 'Please try again.'
      end if

	return
	end

*=====================================================
	subroutine writeparams( outfile )
* write PSPL parameters to ascii output file
* 2011 Mar Keith Horne @ LCOGT - from writeout
	include 'plens.inc'
	character*(*) outfile
* open
	iout = 10
	call openfile( iout, outfile, 'FORMATTED', 'UNKNOWN', ier)
      if ( ier .ne. 0) then
	write(*,*) '** ERROR opening file ', outfile(:len1(outfile))
	close( unit = iout )
	return
      end if

* write params to output unit

	call writepar1( iout )

* close
	close( unit = iout )
	write(*,*) 'Output file closed: ', outfile(:len1(outfile))
	parfile = outfile
	return
        end

*------------------------------------------------
	subroutine writepar1( iout )
* write PSPL parameters on specified output unit 
* assumes output unit is already open
* 2011 Mar Keith Horne @ LCOGT - 
	include 'plens.inc'
	write( iout, * ) 'EVENT ', event(:len1(event))
	write( iout, * ) 'ALIAS ', alias(:len1(alias))
	write( iout, * ) 
	write( iout, * ) 'FITCODE PLENS'
	write( iout, * ) 'MODEL PSPL'
	write( iout, * ) 'T0', hjd0 - mjd0
	write( iout, * ) 'SIG(T0)', sigt0
	write( iout, * ) 'TE', te
	write( iout, * ) 'SIG(TE)', sigte
	write( iout, * ) 'U0', y0
	write( iout, * ) 'SIG(u0)', sigy0
	write( iout, * ) 'A0', a0
	write( iout, * ) 'SIG(A0)', siga0
	write( iout, * ) 'I0', smag0
	write( iout, * ) 'SIG(I0)', sigm0
	write( iout, * ) 'B0', b0, '  = FB/FS'
	write( iout, * ) 'SIG(B0)', sigb0
	write( iout, * )
	write( iout, * ) 'PMAX', prioritymax
	write( iout, * )
	write( iout, * ) 'NPFIT', npfit
	write( iout, * ) 'CHI2_4', chi2_4
	write( iout, * ) 'CHI2_5', chi2_5
	write( iout, * ) 'CHI2_6', chi2_6
	write( iout, * ) 'CHI2_7', chi2_7
	write( iout, * )
	write( iout, * ) 'INLIST ', datfile(:len1(datfile))
	write( iout, * ) 'NDATA', ndata
	write( iout, * ) 'NSITE', nloc
      do i=1,nloc
	write( iout, * )
	call setsite( i )
	write( iout, * ) 'SITE ',  site(:len1(site))
	write( iout, * ) 'GLAT', glat
	write( iout, * ) 'GLON', glon
	write( iout, * ) 'ELEV', elev
	write( iout, * ) 'DIAM', diam
	file = datfile_l(i)
	ndat = ndat_l(i)
	write( iout, * ) 'LCFILE ', file(:len1(file))
	write( iout, * ) 'NDAT', ndat
	write( iout, * ) 'FS', fs
	write( iout, * ) 'FB', fb
	write( iout, * ) 'APIV', APIV
	write( iout, * ) 'SYSERR', syserr
	write( iout, * ) 'SIG0', sigmag0
	write( iout, * ) 'ERBSCL', erbscl
      end do
	call setsite( 1 )

	return
	end

*===========================================
	subroutine confirmfile( ask, file )
* let user adjust filename or return ' ' if none
* 2011 Keith Horne @ LCOGT
	character*(*) ask
	character*(*) file
	write(*,*) 'Reply NONE or SKIP to skip output'
	call inq( ask(:len1(ask)), file, file )
	if( file .eq. 'none' ) file = ' '
	if( file .eq. 'NONE' ) file = ' '
	if( file .eq. 'skip' ) file = ' '
	if( file .eq. 'SKIP' ) file = ' '
	return
	end

*=====================================================
	subroutine writemap( opt )
* write Chi2 map as ascii or binary file
* 2011 Mar Keith Horne @ LCOGT
	include 'plens.inc'
	character*1 abold
	character*1 ab / 'A' /

* trap invalid options
      if( .false. ) then
      if( opt(1:2) .eq. 'XY' ) then
      else if( opt(1:2) .eq. 'UA' ) then
      else if( opt(1:2) .eq. 'TF' ) then
      else if( opt(1:2) .eq. 'FQ' ) then
      else
	write(*,*) '** OPTION ', opt(:len1(opt)), ' NOT RECOGNISED.'
	write(*,*) '** MAP NOT WRITTEN :(((((('
	return
      end if
      end if

* recall the required map

	call fetchgrid( opt(1:2) )

* statistics
	write(*,*) 'DeltaChi2(', opt(1:2), ') for q', qmap
	write(*,*) 'Chi2ref', chi2ref, ' Dof', mapdof
	write(*,*) 'Nfit', mapfit, ' Ntweak', maptweak
	call mnmx( n_1, par_1, xmn, xmx )
	call mnmx( n_2, par_2, ymn, ymx )
	write(*,*) opt(1:1), ' ', n_1, xmn, xmx 
	write(*,*) opt(2:2), ' ', n_2, ymn, ymx
	call mnmx( n_1 * n_2, chi2_12, pmn, pmx )
	write(*,*) 'Chi2 min', pmn, ' max', pmx

      if( n_1 * n_2 .le. 0 ) then
	write(*,*) '** NO Chi2 MAP TO WRITE.  :(((.'
	return
      end if

* default file name
	call filenameq( file, qmap )
	call append( file, '_dchi2.' )
	call append( file, opt(1:2) )
	call nospace( file )

* confirm filename
	call confirmfile( 'Write Map to file', file )
	if( file .eq. ' ' ) return

* ascii vs binary
   10	abold = ab
c	call inq( 'A (ASCII) or B (binary) format', abold, ab )
c	call upcase( ab, ab )	
	ab = 'A'

* binary
      if( ab .eq. 'B' ) then
	call dump2d1( file, 1, n_1, n_2, par_1, par_2, chi2_12 )
* neither
      else if( ab .ne. 'A' ) then
	ab = abold
	write(*,*) '** INVALID REPLY.  Please try again.'
	goto 10
      else

* ascii
* open
	iout = 10
	call openfile( iout, file, 'FORMATTED', 'UNKNOWN', ier)
      if ( ier .ne. 0) then
	write(*,*) '** ERROR opening file ', file(:len1(file))
	close( unit = iout )
	return
      end if

* dump map
	write( iout, * ) 'DELTACHI2(', opt(1:2), ')'
	write( iout, * ) 'CHI2REF', chi2ref
	write( iout, * ) 'MAPQ', qmap
	write( iout, * ) 'MAPFIT', mapfit
	write( iout, * ) 'MAPTWEAK', maptweak
	write( iout, * ) 'MAPDOF', mapdof
	write( iout, * ) 'MAPAXIS1', n_1
	write( iout, * ) 'MAPAXIS2', n_2
      do i=1,n_1
	write( iout, * ) i, par_1(i)
      end do
      do i=1,n_2
	write( iout, * ) i, par_2(i)
      end do

* write DeltaChi^2 only when outside +/- tiny
	tiny = 0.001
	i = 0
	last = n_1 * n_2
      do i2=1,n_2
      do i1=1,n_1
	i = i + 1
	val = chi2_12( i ) - chi2ref
      if( abs( val ) .gt. tiny .or. i .eq. last ) then
	write( iout, * ) i1, i2, val
      end if
      end do
      end do

* write PSPL parameters

	call writepar1( iout )

      end if

* close
	close( unit = iout )
	write(*,*) 'Closed unit', iout, ' file: ',file(:len1(file))

	return
        end
