#!/bin/csh
#
# plens.com -- compile plens
#
# 2006 Mar Keith Horne @ St.Andrews

set code = 'plens'
date

# 2009 speed tests with g77 compiler on new 64-bit lacerta
# 28.2s
# alias for 'g77 -fno-automatic -fno-backslash -fugly-assumed'
# 28.1s
# alias for 'g77 -fno-automatic -fno-backslash -fugly-assumed -fomit-frame-pointer'
# 22.1s
 alias for 'g77 -O3 -fno-automatic -fno-backslash -fugly-assumed'
# 19.4s
# alias for 'g77 -O3 -fno-automatic -fno-backslash -fugly-assumed -ffast-math'
# 19.2s
# alias for 'g77 -O3 -fno-automatic -fno-backslash -fugly-assumed -ffast-math -funroll-all-loops'
# fails to compile
# alias for 'g77 -O3 -fno-automatic -fno-backslash -fugly-assumed -m32'

# Apr 2010 speed tests with gfortran vs g77 compiler
# note: must change compiler also in plens_a.com.
# benchmark is test390.dat, fit 5 params, then mc plot and note time for the chi^2(x,y) grid.
#	37.5s
# alias for 'g77 -fno-automatic -fno-backslash'
#	29.5s
 alias for 'g77 -O3 -fno-automatic -fno-backslash'

#	40.4s
# alias for 'gfortran -fno-automatic -ffixed-line-length-132 -fd-lines-as-comments'
#	27.1s
# alias for 'gfortran -O3 -fno-automatic -ffixed-line-length-132 -fd-lines-as-comments'
# change from gfortran version 4.2.1 to gfortran version 4.4
#	23.9s
 alias for gfortran -O3 -fno-automatic -ffixed-line-length-132

# Jun 2010 ifort compiler
#	11.98s
# alias for ifort -save -extend-source
#	19.4s
# alias for ifort -O0 -save -extend-source
#	12.5s
# alias for ifort -O1 -save -extend-source
#	11.94s
# alias for ifort -O2 -save -extend-source
#	12.08s
# alias for ifort -O3 -save -extend-source -mcmodel=medium
#	11.95s
 alias for ifort -O3 -save -extend-source

# switch compilers
#tog77
#togfortran
toifort

which for
for -o $code.exe	\
	$code.for	\
	plens.a		\
	lens1.for	\
	lens2.for	\
	asp.for		\
	dzw.for		\
	misc.for	\
        -L/star/lib `pgplot_link`
date

